// CAboutDlg.cpp - About Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "Resource.hpp"
#include "WinMain.hpp"
#include "CAboutDlg.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from a control or left mouse button has pressed

AFXINLINE LRESULT CAboutDlg::OnCmdLBtnDown(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CAboutDlg::OnCmdLBtnDown\n"));

	FadeOutDialog(*this);
	DestroyIcon(SetWindowIcon(ICON_SMALL));
	EndDialog();

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_PROCESSED;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog box is being displayed

AFXINLINE BOOL CAboutDlg::OnInitDialog(HWND hFocusWnd)
{
	TRACE(_T("Entering CAboutDlg::OnInitDialog\n"));

	SetDialogIcon(*this, ID_HELP_ABOUT);
	MoveDialogCenter();
	FadeInDialog(*this);

	// System (TRUE) or application itself (FALSE) sets the keyboard focus
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CAboutDlg

BEGIN_MESSAGE_MAP(CAboutDlg)
	ON_SAME_MAP(WM_COMMAND)
	ON_ANY_MAP(WM_LBUTTONDOWN, OnCmdLBtnDown)
	ON_WM_INITDIALOG(OnInitDialog)
END_MESSAGE_MAP()
