// CCheckPoiDlg.hpp - Checks POI Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CCHECKPOIDLG_INCLUDED_
#define _CCHECKPOIDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CCheckPoiDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CCheckPoiDlg : public CDialog
{
public:
	enum
	{
		// Button indices
		m_eSimilarName = 0,
		m_eNearDist,
		m_eEmptyCoord,
		m_eceButton,

		// Maximum number of characters can be type in
		m_eccCheckDist = 9,
	};

public:
	int     m_iCheckDist, m_iInitDist;
	UINT    m_nDistUnit;
	UINT    m_nButton[m_eceButton];
	CButton m_jButton[m_eceButton], m_jLargeBtn, m_jSmallBtn, m_jOKBtn;
	CEdit   m_jCkeckDist;

public:
	CCheckPoiDlg();
	void CloseDialog(int iResult);
	void EnableButtons();

protected:
	void OnSimilarName(UINT nNotify, HWND hCtrlWnd);
	void OnNearDist(UINT nNotify, HWND hCtrlWnd);
	void OnEmptyCoord(UINT nNotify, HWND hCtrlWnd);
	void OnOK(UINT nNotify, HWND hCtrlWnd);
	void OnCancel(UINT nNotify, HWND hCtrlWnd);
	BOOL OnInitDialog(HWND hFocusWnd);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CCheckPoiDlg::CCheckPoiDlg()
{
	TRACE(_T("Entering CCheckPoiDlg::CCheckPoiDlg\n"));

	for(int i = 0; i < countof(m_nButton); i++)
		m_nButton[i] = BST_CHECKED;
	m_iInitDist = 50;
	m_nDistUnit = IDC_CHECK_SMALL_UNIT;
}

// End of _CCHECKPOIDLG_INCLUDED_
#endif
