// CClearColDlg.cpp - Clears Column Data Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CClearColDlg.hpp"
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from buttons

AFXINLINE void CClearColDlg::OnCommand(UINT nItemId, UINT nNotify, HWND hCtrlWnd)
{
	TRACE(_T("Entering CClearColDlg::OnCommand\n"));

	int i;
	if((nItemId == ID_OK) || (nItemId == ID_CANCEL))
	{
		if(nItemId == ID_OK)
		{
			i = 0;
			do
			{
				m_nCol[i] = m_jCol[i].GetCheck();
				i++;
			}
			while(i < countof(m_nCol));
		}
		FadeOutDialog(*this);
		DestroyIcon(SetWindowIcon(ICON_SMALL));
		EndDialog(nItemId);
		return;
	}

	i = 0;
	do
	{
		if(m_jCol[i].GetCheck() == BST_CHECKED)
			break;
		i++;
	}
	while(i < countof(m_jCol));
	m_jOKBtn.EnableWindow(i < countof(m_jCol));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog box is being displayed

AFXINLINE BOOL CClearColDlg::OnInitDialog(HWND hFocusWnd)
{
	TRACE(_T("Entering CClearColDlg::OnInitDialog\n"));

	SCUINT snButtonId[] =
	{
		IDC_NAME_LEAD_COL,
		IDC_NAME_TRAIL_COL,
		IDC_LNG_COL,
		IDC_LAT_COL,
		IDC_TEL_COL,
		IDC_MEMO_COL,
	};
	int i;
	ASSERT(countof(m_jCol) == countof(snButtonId));
	SetDialogIcon(*this, ID_POI_CLEAR_COL);
	i = 0;
	do
	{
		m_jCol[i] = GetChild(snButtonId[i]);
		i++;
	}
	while(i < countof(m_jCol));
	m_jOKBtn = GetChild(ID_OK);
	if((e_pTPE->m_fst == CTomPoiEdr::FST_SC) || (e_pTPE->m_fst == CTomPoiEdr::FST_CPB))
	{
		m_jCol[m_eNameLCol].DisableWindow();
		m_jCol[m_eNameTCol].DisableWindow();
		if(e_pTPE->m_fst == CTomPoiEdr::FST_CPB)
		{
			m_jCol[m_eLngCol].DisableWindow();
			m_jCol[m_eLatCol].DisableWindow();
		}
	}
	m_jOKBtn.DisableWindow();
	MoveDialogCenter();
	FadeInDialog(*this);

	// System (TRUE) or application itself (FALSE) sets the keyboard focus
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CClearColDlg

BEGIN_MESSAGE_MAP(CClearColDlg)
	ON_WM_COMMAND(OnCommand)
	ON_WM_INITDIALOG(OnInitDialog)
END_MESSAGE_MAP()
