// CCombColDlg.cpp - Combines Column Data Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// Static data

CTCHAR CCombColDlg::m_szDefText[]   = STR_AT;
CTCHAR CCombColDlg::m_szDefSerial[] = _T("01");

////////////////////////////////////////////////////////////////////////////////////////////////
// Enables or disables controls

void CCombColDlg::EnableControls()
{
	TRACE(_T("Entering CCombColDlg::EnableControls\n"));

	SCBOOL sbEnableOK[] =
	{
		TRUE,  TRUE,  TRUE,  FALSE, FALSE,
		TRUE,  FALSE, FALSE, FALSE, FALSE,
		FALSE, TRUE,  TRUE,  TRUE,  TRUE,
		TRUE,  FALSE, TRUE,  TRUE,  FALSE,
		TRUE,  TRUE,  FALSE, TRUE,  FALSE,
	};
	BOOL  bFCbEdit, bBCbEdit, bEnableOK;
	CEdit jEdit;
	m_iFCbSel = m_jFrontCb.GetCurSel();
	m_iBCbSel = m_jBackCb.GetCurSel();
	if((m_iFCbSel == m_eFCbText) || (m_iFCbSel == m_eFCbSerial))
	{
		jEdit    = m_jFrontEdit;
		bFCbEdit = TRUE;
	}
	else
		bFCbEdit = FALSE;
	if((m_iBCbSel == m_eBCbText) || (m_iBCbSel == m_eBCbSerial))
	{
		jEdit    = m_jBackEdit;
		bBCbEdit = TRUE;
	}
	else
		bBCbEdit = FALSE;
	m_jFrontEdit.EnableWindow(bFCbEdit);
	m_jBackEdit.EnableWindow(bBCbEdit);
	if(!e_pTPE->m_bRPF ||
		((m_iFCbSel != m_eFCbMemo) && (!bFCbEdit || (m_iBCbSel != m_eBCbMemo))))
	{
		bEnableOK = sbEnableOK[m_iFCbSel * m_eceFCb + m_iBCbSel];
		if(bEnableOK && (bFCbEdit || bBCbEdit))
		{
			TCHAR szText[e_eccNameCol];
			if(jEdit.GetWindowText(szText, countof(szText)) && TrimString(szText))
			{
				if((m_iFCbSel == m_eFCbSerial) || (m_iBCbSel == m_eBCbSerial))
				{
					int i;
					i = 0;
					do
					{
						if(!IsValidNumber(szText[i]))
						{
							bEnableOK = FALSE;
							break;
						}
						i++;
					}
					while(szText[i]);
				}
			}
			else
				bEnableOK = FALSE;
		}
	}
	else
		bEnableOK = FALSE;
	m_jOKBtn.EnableWindow(bEnableOK);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from a menu or a control sends a notification

AFXINLINE void CCombColDlg::OnCommand(UINT nItemId, UINT nNotify, HWND hCtrlWnd)
{
	TRACE(_T("Entering CCombColDlg::OnCommand\n"));

	CEdit jEdit;
	if((nItemId == IDC_COMBINE_FRONT_COMBO) || (nItemId == IDC_COMBINE_BACK_COMBO))
	{
		if(nNotify != CBN_SELCHANGE)
			return;

		int iCbSel, iCbText, iCbSerial;
		if(nItemId == IDC_COMBINE_FRONT_COMBO)
		{
			iCbSel = m_jFrontCb.GetCurSel();
			if(iCbSel == m_iFCbSel)
				return;

			jEdit     = m_jFrontEdit;
			iCbText   = m_eFCbText;
			iCbSerial = m_eFCbSerial;
		}
		else
		{
			iCbSel = m_jBackCb.GetCurSel();
			if(iCbSel == m_iBCbSel)
				return;

			jEdit     = m_jBackEdit;
			iCbText   = m_eBCbText;
			iCbSerial = m_eBCbSerial;
		}

		PCTSTR pszDefault;
		int    ccLimit;
		if(iCbSel == iCbText)
		{
			ccLimit    = e_eccNameCol - 1;
			pszDefault = m_szDefText;
		}
		else if(iCbSel == iCbSerial)
		{
			ccLimit    = m_eccSerial;
			pszDefault = m_szDefSerial;
		}
		else
			pszDefault = NULL;
		jEdit.SetWindowText(pszDefault);
		if(pszDefault)
		{
			DWORD dwStyle;
			jEdit.SetLimitText(ccLimit);
			dwStyle = jEdit.GetWindowStyle();
			jEdit.SetWindowStyle((iCbSel == iCbText) ?
				(dwStyle & ~ES_NUMBER) : (dwStyle | ES_NUMBER));
		}
		EnableControls();
		return;
	}

	if((nItemId == IDC_COMBINE_FRONT_EDIT) || (nItemId == IDC_COMBINE_BACK_EDIT))
	{
		if(nNotify == EN_CHANGE)
			EnableControls();
		return;
	}

	if((nItemId != ID_OK) && (nItemId != ID_CANCEL))
		return;

	if(nItemId == ID_OK)
	{
		if((m_iFCbSel == m_eFCbText) || (m_iFCbSel == m_eFCbSerial))
			jEdit = m_jFrontEdit;
		else if((m_iBCbSel == m_eBCbText) || (m_iBCbSel == m_eBCbSerial))
			jEdit = m_jBackEdit;
		else
			jEdit = NULL;
		if(jEdit)
			jEdit.GetWindowText(m_pszCombText, e_eccNameCol);
	}
	FadeOutDialog(*this);
	DestroyIcon(SetWindowIcon(ICON_SMALL));
	EndDialog(nItemId);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog box is being displayed

AFXINLINE BOOL CCombColDlg::OnInitDialog(HWND hFocusWnd)
{
	TRACE(_T("Entering CCombColDlg::OnInitDialog\n"));

	SCUINT snColRes[] = { IDS_NAME_COL, IDS_TEL_COL, IDS_MEMO_COL };
	TCHAR  szColText[32];
	int    i;
	SetDialogIcon(*this, ID_POI_COMBINE_COL);
	m_jFrontCb   = GetChild(IDC_COMBINE_FRONT_COMBO);
	m_jFrontEdit = GetChild(IDC_COMBINE_FRONT_EDIT);
	m_jBackCb    = GetChild(IDC_COMBINE_BACK_COMBO);
	m_jBackEdit  = GetChild(IDC_COMBINE_BACK_EDIT);
	m_jOKBtn     = GetChild(ID_OK);
	i            = 0;
	do
	{
		LoadString(e_hInstance, snColRes[i], szColText, countof(szColText));
		m_jFrontCb.AddItem(szColText);
		m_jBackCb.AddItem(szColText);
		i++;
	}
	while(i < countof(snColRes));
	LoadString(e_hInstance, IDS_COMBINE_TEXT_COL, szColText, countof(szColText));
	m_jFrontCb.InsertItem(szColText, m_eFCbText);
	m_jBackCb.AddItem(szColText);
	LoadString(e_hInstance, IDS_COMBINE_SERIAL_COL, szColText, countof(szColText));
	m_jFrontCb.InsertItem(szColText, m_eFCbSerial);
	m_jBackCb.AddItem(szColText);
	m_jFrontCb.SetCurSel(m_eFCbText);
	m_jBackCb.SetCurSel(m_eBCbName);
	m_jFrontEdit.SetLimitText(e_eccNameCol - 1);
	m_jFrontEdit.SetWindowText(m_szDefText);
	MoveDialogCenter();
	FadeInDialog(*this);

	// System (TRUE) or application itself (FALSE) sets the keyboard focus
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CCombColDlg

BEGIN_MESSAGE_MAP(CCombColDlg)
	ON_WM_COMMAND(OnCommand)
	ON_WM_INITDIALOG(OnInitDialog)
END_MESSAGE_MAP()
