// CCombColDlg.hpp - Combines Column Data Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CCOMBCOLDLG_INCLUDED_
#define _CCOMBCOLDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CCombColDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CCombColDlg : public CDialog
{
public:
	enum
	{
		// Items of front combo box
		m_eFCbText = 0,
		m_eFCbSerial,
		m_eFCbName,
		m_eFCbTel,
		m_eFCbMemo,
		m_eceFCb,

		// Items of back combo box
		m_eBCbName = 0,
		m_eBCbTel,
		m_eBCbMemo,
		m_eBCbText,
		m_eBCbSerial,

		// Maximum characters of serial numbers
		m_eccSerial = 9,
	};

public:
	PTSTR     m_pszCombText;
	int       m_iFCbSel, m_iBCbSel;
	CButton   m_jOKBtn;
	CComboBox m_jFrontCb, m_jBackCb;
	CEdit     m_jFrontEdit, m_jBackEdit;

public:
	static CTCHAR m_szDefText[];
	static CTCHAR m_szDefSerial[];

public:
	CCombColDlg(PTSTR pszCombText);
	void EnableControls();

protected:
	void OnCommand(UINT nItemId, UINT nNotify, HWND hCtrlWnd);
	BOOL OnInitDialog(HWND hFocusWnd);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CCombColDlg::CCombColDlg(PTSTR pszCombText)
{
	TRACE(_T("Entering CCombColDlg::CCombColDlg\n"));

	m_pszCombText = pszCombText;
}

// End of _CCOMBCOLDLG_INCLUDED_
#endif
