// CConvertFormatDlg.cpp - Converts File Format Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// Initializes Browse Folder dialog box

AFXINLINE void CConvertFormatDlg::Initialized()
{
	TRACE(_T("Entering CConvertFormatDlg::Initialized\n"));

	TCHAR      szText[MAX_PATH + 64];
	int        i, xCtrl, cxCtrl, xButton, yButton, cxButton, cyButton, yTvCtrl;
	SIZE       size;
	RECT       rc;
	TEXTMETRIC tm;
	HFONT      hFont, hOldFont;
	HDC        hDC;
	CButton    jButton;
	CTreeView  jTreeView;
	SetDialogIcon(*this, ID_FILE_CONVERT);
	LoadString(e_hInstance, IDS_CFD_NAME, szText, countof(szText));
	SetWindowText(szText);
	m_jTitleStc = GetChild(IDC_BFD_STATIC1);
	m_jTitleStc.SetWindowStyle(m_jTitleStc.GetWindowStyle() | SS_PATHELLIPSIS);
	hDC   = m_jTitleStc.GetDC();
	hFont = m_jTitleStc.GetWindowFont();
	if(!hFont)
		hFont = GetStockFont(SYSTEM_FONT);
	SelectFont(hDC, hFont);
	GetTextMetrics(hDC, &tm);
	m_jTitleStc.MoveWindow(m_ecxBorder, m_ecyBorder,
		m_ecxTvCtrl, tm.tmHeight + tm.tmExternalLeading);
	jButton = GetChild(ID_CANCEL);
	jButton.SetWindowStyle(jButton.GetWindowStyle() & ~WS_GROUP);
	jButton.GetWindowRect(&rc);
	cxButton = GetRectWidth(&rc);
	cyButton = GetRectHeight(&rc);
	xButton  = m_ecxDialog - cxButton - m_ecxBorder + 1;
	yButton  = m_ecyDialog - cyButton - m_ecyBorder;
	jButton.SetWindowPos(NULL, xButton, yButton, UNUSED, UNUSED, SWP_NOSIZE | SWP_NOZORDER);
	jButton = GetChild(ID_OK);
	jButton.SetWindowPos(NULL, xButton - cxButton - m_ecxGap, yButton,
		UNUSED, UNUSED, SWP_NOSIZE | SWP_NOZORDER);
	GetTextExtent(hDC, szText, LoadString(e_hInstance, IDS_CFD_TO_OV2,
		szText, countof(szText)), &size);
	cxCtrl = size.cx + m_ecxRadio + m_ecxPadding;
	m_jOv2Btn.CreateWindow(szText, m_eOv2BtnStyle, m_ecxBorder, yButton,
		cxCtrl, cyButton, *this, m_eOv2BtnId);
	hOldFont = m_jOv2Btn.GetWindowFont();
	m_jOv2Btn.SetWindowFont(hFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	GetTextExtent(hDC, szText, LoadString(e_hInstance, IDS_CFD_TO_EXT,
		szText, countof(szText)), &size);
	m_jTitleStc.ReleaseDC(hDC);
	xCtrl  = cxCtrl + m_ecxBorder + m_ecxGap * 2;
	cxCtrl = size.cx + m_ecxRadio + m_ecxPadding;
	m_jExtBtn.CreateWindow(szText, m_eExtBtnStyle, xCtrl, yButton,
		cxCtrl, cyButton, *this, m_eExtBtnId);
	hOldFont = m_jExtBtn.GetWindowFont();
	m_jExtBtn.SetWindowFont(hFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	xCtrl += cxCtrl + m_ecxGap / 2;
	m_jExtCmb.CreateWindow(m_eExtCmbStyle, xCtrl, yButton, m_ecxCmbCtrl, m_ecyCmbCtrl,
		*this, m_eExtCmbId);
	i = IDS_CFD_EXT_FIRST;
	do
	{
		LoadString(e_hInstance, i, szText, countof(szText));
		m_jExtCmb.AddItem(szText);
		i++;
	}
	while(i <= IDS_CFD_EXT_LAST);
	m_jExtCmb.SetCurSel(m_iSelExt);
	hOldFont = m_jExtCmb.GetWindowFont();
	m_jExtCmb.SetWindowFont(hFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	yTvCtrl   = tm.tmHeight + m_ecyBorder + m_ecyGap;
	jTreeView = GetChild(IDC_BFD_TREE_VIEW);
	jTreeView.SetWindowStyle(jTreeView.GetWindowStyle() |
		((e_dwWinVer > WV_XP) ? m_eTvStyle : m_eTvStyleXP));
	jTreeView.MoveWindow(m_ecxBorder, yTvCtrl, m_ecxTvCtrl, yButton - yTvCtrl - m_ecyGap);
	m_jOv2Btn.SetWindowPos(jTreeView, UNUSED, UNUSED, UNUSED, UNUSED, SWP_NOMOVE | SWP_NOSIZE);
	m_jExtBtn.SetWindowPos(m_jOv2Btn, UNUSED, UNUSED, UNUSED, UNUSED, SWP_NOMOVE | SWP_NOSIZE);
	m_jExtCmb.SetWindowPos(m_jExtBtn, UNUSED, UNUSED, UNUSED, UNUSED, SWP_NOMOVE | SWP_NOSIZE);
	if(m_nOv2Btn == BST_CHECKED)
	{
		i = m_eOv2BtnId;
		m_jExtCmb.EnableWindow(FALSE);
	}
	else
		i = m_eExtBtnId;
	CheckButton(m_eOv2BtnId, m_eExtBtnId, i);
	SetRect(&rc, 0, 0, m_ecxDialog, m_ecyDialog);
	AdjustWindowRect(&rc, GetWindowStyle(), FALSE);
	MoveWindow(0, 0, GetRectWidth(&rc), GetRectHeight(&rc));
	MoveDialogCenter();
	if(m_pIDL)
		SendMessage(BFFM_SETSELECTION, FALSE, (LPARAM)m_pIDL);
	else
		m_jTitleStc.SetWindowText(lpszTitle);
	jTreeView.EnsureVisible(jTreeView.GetNextItem(TVGN_CARET));
	FadeInDialog(*this);
	m_wpPrev = (WNDPROC)SetWindowLong(GWL_WNDPROC, (LONG)WndProc);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Selected item of Browse Folder dialog box has changed

AFXINLINE void CConvertFormatDlg::SelChanged(PITEMIDLIST pIDL)
{
	TRACE(_T("Entering CConvertFormatDlg::SelChanged\n"));

	if(!m_jTitleStc)
		return;

	TCHAR szText[MAX_PATH + 64];
	int   ccText;
	SHGetPathFromIDList(pIDL, m_pszPathName);
	ccText = lstrlen(lpszTitle);
	CopyMemory(szText, lpszTitle, ccText * sizeof(TCHAR));
	szText[ccText]     = CHR_SP;
	szText[ccText + 1] = CHR_SP;
	e_pTPE->GetPurePathName(m_pszPathName, szText + ccText + 2);
	m_jTitleStc.SetWindowText(szText);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Callback procedure for Browse Folder dialog box

int CALLBACK CConvertFormatDlg::CbProc(HWND hWnd, UINT nMsg, LPARAM lData, LPARAM lParam)
{
	TRACE(_T("Entering CConvertFormatDlg::CbProc\n"));

	CConvertFormatDlg* pCFD;
	pCFD = (CConvertFormatDlg*)lParam;
	if(nMsg == BFFM_SELCHANGED)
	{
		pCFD->SelChanged((PITEMIDLIST)lData);
		return 0;
	}

	if(nMsg != BFFM_INITIALIZED)
		return 0;

	pCFD->m_hWnd = hWnd;
	pCFD->Initialized();
	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Window procedure for Browse Folder dialog box

LRESULT CALLBACK CConvertFormatDlg::WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CConvertFormatDlg::WndProc\n"));

	CConvertFormatDlg* pCFD;
	pCFD = &e_pTPE->m_jConvertFormatDlg;
	if(nMsg == WM_COMMAND)
	{
		switch(LOWORD(wParam))
		{
		case m_eOv2BtnId:
			pCFD->m_jExtCmb.EnableWindow(FALSE);
			break;
		case m_eExtBtnId:
			pCFD->m_jExtCmb.EnableWindow(TRUE);
			pCFD->m_jExtCmb.SetFocus();
			pCFD->m_jExtCmb.ShowDropDown();
			break;
		case ID_OK:
			pCFD->m_nOv2Btn = pCFD->m_jOv2Btn.GetCheck();
			pCFD->m_iSelExt = pCFD->m_jExtCmb.GetCurSel();
		case ID_CANCEL:
			FadeOutDialog(hWnd);
			DestroyIcon(pCFD->SetWindowIcon(ICON_SMALL));
		}
	}
	return CallWindowProc(pCFD->m_wpPrev, hWnd, nMsg, wParam, lParam);
}
