// CConvertFormatDlg.hpp - Converts File Format Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CCONVERTFORMATDLG_INCLUDED_
#define _CCONVERTFORMATDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CConvertFormatDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CConvertFormatDlg : public CDialog, public BROWSEINFO
{
public:
	enum
	{
		// Tree view styles
		m_eTvStyleXP = TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND | TVS_TRACKSELECT,
		m_eTvStyle   = m_eTvStyleXP | TVS_FULLROWSELECT,

		// Control styles
		m_eExtBtnStyle = WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
		m_eOv2BtnStyle = m_eExtBtnStyle | WS_GROUP | WS_TABSTOP,
		m_eExtCmbStyle = WS_CHILD | WS_TABSTOP | WS_VISIBLE | CBS_DROPDOWNLIST,

		// Control identifiers
		m_eOv2BtnId = 5000,
		m_eExtBtnId,
		m_eExtCmbId,

		// Control sizes
		m_ecxDialog  = 520,
		m_ecyDialog  = m_ecxDialog,
		m_ecxBorder  = 10,
		m_ecyBorder  = m_ecxBorder,
		m_ecxGap     = 10,
		m_ecyGap     = m_ecxGap,
		m_ecxPadding = 2,
		m_ecxRadio   = 16,
		m_ecxTvCtrl  = m_ecxDialog - m_ecxBorder * 2,
		m_ecxCmbCtrl = 100,
		m_ecyCmbCtrl = 100,

		// Combo box items for file extensions
		m_eKmlExt = 0,
		m_eGpxExt,
		m_eCsvAExt,
		m_eCsvUExt,
		m_eCsvU8Ext,
		m_eTxtAExt,
		m_eTxtUExt,
		m_eTxtU8Ext,
	};

public:
	PITEMIDLIST m_pIDL;
	WNDPROC     m_wpPrev;
	PTSTR       m_pszPathName;
	int         m_iSelExt;
	UINT        m_nOv2Btn;
	CButton     m_jOv2Btn, m_jExtBtn;
	CComboBox   m_jExtCmb;
	CStatic     m_jTitleStc;

public:
	CConvertFormatDlg();
	~CConvertFormatDlg();
	BOOL Browse(PTSTR pszPathName);
	void FreeIDL();
	void Initialized();
	void SelChanged(PITEMIDLIST pIDL);

public:
	static int CALLBACK CbProc(HWND hWnd, UINT nMsg, LPARAM lData, LPARAM lParam);
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CConvertFormatDlg::CConvertFormatDlg()
{
	TRACE(_T("Entering CConvertFormatDlg::CConvertFormatDlg\n"));

	pidlRoot  = NULL;
	ulFlags   = BIF_RETURNONLYFSDIRS;
	lpfn      = CbProc;
	lParam    = (LPARAM)this;
	m_pIDL    = NULL;
#ifdef VER_ESPANA
	m_nOv2Btn = BST_UNCHECKED;
	m_iSelExt = m_eCsvAExt;
#else
	m_nOv2Btn = BST_CHECKED;
	m_iSelExt = m_eKmlExt;
#endif
}

AFXINLINE CConvertFormatDlg::~CConvertFormatDlg()
{
	TRACE(_T("Entering CConvertFormatDlg::~CConvertFormatDlg\n"));

	FreeIDL();
}

AFXINLINE BOOL CConvertFormatDlg::Browse(PTSTR pszPathName)
{
	TRACE(_T("Entering CConvertFormatDlg::Browse\n"));

	PITEMIDLIST pIDL;
	m_jTitleStc   = NULL;
	m_pszPathName = pszPathName;
	pIDL          = SHBrowseForFolder(this);
	if(!pIDL)
		return FALSE;

	FreeIDL();
	m_pIDL = pIDL;
	return TRUE;
}

AFXINLINE void CConvertFormatDlg::FreeIDL()
{
	TRACE(_T("Entering CConvertFormatDlg::FreeIDL\n"));

	CoTaskMemFree(m_pIDL);
}

// End of _CCONVERTFORMATDLG_INCLUDED_
#endif
