// CCustTbDlg.hpp - Customize Toolbar Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CCUSTTBDLG_INCLUDED_
#define _CCUSTTBDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CCustTbDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CCustTbDlg : public CSubclassWnd<CDialog>
{
public:
	enum
	{
		// Control styles
		m_eWndStyle   = WS_CHILD | WS_GROUP | WS_VISIBLE,
		m_eStcStyle   = m_eWndStyle | SS_LEFT,
		m_eEdtStyle   = m_eWndStyle | WS_TABSTOP | ES_LEFT | ES_NUMBER,
		m_eEdtExStyle = WS_EX_CLIENTEDGE,
		m_eUpdStyle   = m_eWndStyle | UDS_ALIGNRIGHT | UDS_ARROWKEYS |
			UDS_HOTTRACK | UDS_SETBUDDYINT,

		// Control identifiers
		m_eAvailStcId   = 0xFFFF,
		m_eAvailLstId   = 0xC9,
		m_eAddBtnId     = 0x1,
		m_eCloseBtnId   = ID_CANCEL,
		m_eResetBtnId   = 0xCA,
		m_eSpacingEdtId = 5000,
		m_eSpacingUpdId,

		// Control sizes
		m_ecxSpacingEdt = 36,
		m_ecyBorder     = 2,
		m_exDelta       = 1,

		// Spacing values
		m_eMinSpacing = 0,
		m_eMaxSpacing = 9,
		m_eDefSpacing = 0,
	};

public:
	int     m_cxSpacing;
	CButton m_jCloseBtn, m_jResetBtn;
	CEdit   m_jSpacingEdt;

public:
	void EnableCloseButton();
	void InitDialog(HWND hDlg);

protected:
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
};

// End of _CCUSTTBDLG_INCLUDED_
#endif
