// CDumpFolderDlg.hpp - Brose Folder Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CDUMPFOLDERDLG_INCLUDED_
#define _CDUMPFOLDERDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CDumpFolderDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CDumpFolderDlg : public CDialog, public BROWSEINFO
{
public:
	enum
	{
		// Tree view styles
		m_eTvStyleXP = TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND | TVS_TRACKSELECT,
		m_eTvStyle   = m_eTvStyleXP | TVS_FULLROWSELECT,

		// Control sizes
		m_ecxDialog = 420,
		m_ecyDialog = 360,
		m_ecxBorder = 10,
		m_ecyBorder = m_ecxBorder,
		m_ecxGap    = 10,
		m_ecyGap    = m_ecxGap,
		m_ecxTvCtrl = m_ecxDialog - m_ecxBorder * 2,
	};

public:
	PTSTR   m_pszPathName;
	CStatic m_jTitleStc;

public:
	static WNDPROC m_wpPrev;

public:
	CDumpFolderDlg();
	BOOL Browse(PTSTR pszPathName);
	void Initialized();
	void SelChanged(PITEMIDLIST pIDL);

public:
	static int CALLBACK CbProc(HWND hWnd, UINT nMsg, LPARAM lData, LPARAM lParam);
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CDumpFolderDlg::CDumpFolderDlg()
{
	TRACE(_T("Entering CDumpFolderDlg::CDumpFolderDlg\n"));

	pidlRoot = NULL;
	ulFlags  = BIF_RETURNONLYFSDIRS;
	lpfn     = CbProc;
	lParam   = (LPARAM)this;
}

AFXINLINE BOOL CDumpFolderDlg::Browse(PTSTR pszPathName)
{
	TRACE(_T("Entering CDumpFolderDlg::Browse\n"));

	PITEMIDLIST pIDL;
	m_jTitleStc   = NULL;
	m_pszPathName = pszPathName;
	pIDL          = SHBrowseForFolder(this);
	if(pIDL)
		CoTaskMemFree(pIDL);
	return (BOOL)pIDL;
}

// End of _CDUMPFOLDERDLG_INCLUDED_
#endif
