// CFileDlg.cpp - Open and Save As Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include <Dlgs.h>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// The user specifies a file name and clicks the OK button

AFXINLINE BOOL CFileDlg::OnCdnFileOK(PCOFNOTIFY pOFN)
{
	TRACE(_T("Entering CFileDlg::OnCdnFileOK\n"));

	((CFileParentDlg*)&m_hParentDlg)->CloseDialog();

	// Accepts (FALSE) or rejects (TRUE) the file name
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// The system has finished arranging the controls in the dialog box

AFXINLINE void CFileDlg::OnCdnInitDone(PCOFNOTIFY pOFN)
{
	TRACE(_T("Entering CFileDlg::OnCdnInitDone\n"));

	TCHAR           szText[MAX_STR];
	int             cxFNStc, cyFNStc, xFNCmb;
	POINT           pt;
	RECT            rcPrtDlg, rcFNStc, rcFNCmb, rcFTStc, rcFTCmb;
	HFONT           hTomFont, hOldFont;
	CComboBox       jFNCmb;
	CStatic         jFNStc, jFTStc, jTomStc;
	CFileParentDlg* pFPD;
	SetParent(GetParent());
	if(e_dwWinVer <= WV_XP)
		SetDialogIcon(m_hParentDlg, m_nItemId);
	pFPD        = (CFileParentDlg*)&m_hParentDlg;
	pFPD->m_pFD = this;
	jFNStc      = pFPD->GetChild(stc3);
	jFNCmb      = pFPD->GetChild(cmb13);
	jFTStc      = pFPD->GetChild(stc2);
	m_jFTCmb    = pFPD->GetChild(cmb1);
	LoadString(e_hInstance, IDS_WINDOWS_STATIC, szText, countof(szText));
	jFNStc.SetWindowText(szText);
	LoadString(e_hInstance, IDS_TOMTOM_STATIC, szText, countof(szText));
	jTomStc.CreateWindow(szText, WS_CHILD | WS_VISIBLE, 0, 0, 0, 0, m_hParentDlg, IDC_STATIC);
	m_jTomName.CreateWindow(WS_CHILD | WS_VISIBLE | SS_ENDELLIPSIS, 0, 0, 0, 0,
		m_hParentDlg, m_eTomNameId);
	pFPD->GetWindowRect(&rcPrtDlg);
	jFNStc.GetWindowRect(&rcFNStc);
	cxFNStc = GetRectWidth(&rcFNStc) + m_ecxOffset;
	cyFNStc = GetRectHeight(&rcFNStc);
	jFNStc.SetWindowPos(NULL, UNUSED, UNUSED, cxFNStc, cyFNStc, SWP_NOMOVE | SWP_NOZORDER);
	jFNCmb.GetWindowRect(&rcFNCmb);
	rcFNCmb.left  += m_ecxOffset;
	rcFNCmb.right += m_ecxOffset;
	SetPoint(&pt, rcFNCmb.left, rcFNCmb.top);
	pFPD->ScreenToClient(&pt);
	jFNCmb.SetWindowPos(NULL, pt.x, pt.y, UNUSED, UNUSED, SWP_NOSIZE | SWP_NOZORDER);
	xFNCmb = pt.x;
	jFTStc.GetWindowRect(&rcFTStc);
	m_jFTCmb.GetWindowRect(&rcFTCmb);
	rcFTCmb.left  += m_ecxOffset;
	rcFTCmb.right += m_ecxOffset;
	m_jFTCmb.SetWindowPos(NULL, pt.x, rcFTCmb.top - rcFNCmb.top + pt.y, UNUSED, UNUSED,
		SWP_NOSIZE | SWP_NOZORDER);
	hTomFont = jFTStc.GetWindowFont();
	hOldFont = jTomStc.GetWindowFont();
	if(hTomFont)
		m_cyTomName = cyFNStc;
	else
	{
		TEXTMETRIC tm;
		HDC        hTomStcDC;
		hTomStcDC = jTomStc.GetDC();
		hTomFont  = GetStockFont(DEFAULT_GUI_FONT);
		SelectFont(hTomStcDC, hTomFont);
		GetTextMetrics(hTomStcDC, &tm);
		jTomStc.ReleaseDC(hTomStcDC);
		m_cyTomName = tm.tmHeight;
	}
	jTomStc.SetWindowFont(hTomFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	hOldFont = m_jTomName.GetWindowFont();
	m_jTomName.SetWindowFont(hTomFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	SetPoint(&pt, rcFTStc.left, rcFTStc.top * 2 - rcFNStc.top);
	pFPD->ScreenToClient(&pt);
	jTomStc.MoveWindow(pt.x, pt.y, cxFNStc, m_cyTomName);
	m_jTomName.MoveWindow(xFNCmb, pt.y, GetRectWidth(&rcFNCmb), m_cyTomName);
	pFPD->SetWindowPos(NULL, UNUSED, UNUSED, GetRectWidth(&rcPrtDlg),
		GetRectHeight(&rcPrtDlg) + m_cyTomName + rcFTCmb.top - rcFNCmb.bottom,
		SWP_NOMOVE | SWP_NOZORDER);
	pFPD->MoveDialogCenter();
	pFPD->SubclassWindow();
	if(e_pTPE->m_jOptionDlg.m_nFadeWnd == BST_UNCHECKED)
		return;
	pFPD->SetWindowExStyle(pFPD->GetWindowExStyle() | WS_EX_LAYERED);
	pFPD->SetLayeredWindowAttributes(UNUSED, 0, LWA_ALPHA);
	pFPD->SetTimer(CFileParentDlg::m_eTimerId, CFileParentDlg::m_eTimerIntl);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// The selection changes in the contents of the opened folder or directory

AFXINLINE void CFileDlg::OnCdnSelChange(PCOFNOTIFY pOFN)
{
	TRACE(_T("Entering CFileDlg::OnCdnSelChange\n"));

	TCHAR szFileTitle[MAX_FNAME];
	if((GetFilePath(szFileTitle, countof(szFileTitle)) > 1) && IsValidDirectory(szFileTitle))
	{
		PathStripPath(szFileTitle);
		e_pTPE->TomFile2WinFile(szFileTitle, szFileTitle);
		m_jTomName.SetWindowText(szFileTitle);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CFileDlg

BEGIN_MESSAGE_MAP(CFileDlg)
	BEGIN_NOTIFY_MAP()
		ON_CDN_FILEOK(OnCdnFileOK)
		ON_CDN_INITDONE(OnCdnInitDone)
		ON_CDN_SELCHANGE(OnCdnSelChange)
	END_NOTIFY_MAP()
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////////////////////////
// Closes the dialog

void CFileParentDlg::CloseDialog()
{
	TRACE(_T("Entering CFileParentDlg::CloseDialog\n"));

	FadeOutDialog(*this);
	if(e_dwWinVer <= WV_XP)
		DestroyIcon(SetWindowIcon(ICON_SMALL));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from a menu or a control sends a notification

AFXINLINE LRESULT CFileParentDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CFileParentDlg::OnCommand\n"));

	if(wParam == MAKEWPARAM(cmb13, CBN_EDITCHANGE))
	{
		TCHAR     szFileTitle[MAX_FNAME];
		CComboBox jFNCmb((HWND)lParam);
		jFNCmb.GetWindowText(szFileTitle, countof(szFileTitle));
		e_pTPE->TomFile2WinFile(szFileTitle, szFileTitle);
		m_pFD->m_jTomName.SetWindowText(szFileTitle);
	}
	else if(LOWORD(wParam) == ID_CANCEL)
		CloseDialog();

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Window size has changed

AFXINLINE LRESULT CFileParentDlg::OnSize(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CFileParentDlg::OnSize\n"));

	RECT rcFTCmb;
	m_pFD->m_jFTCmb.GetWindowRect(&rcFTCmb);
	m_pFD->m_jTomName.SetWindowPos(NULL, UNUSED, UNUSED,
		GetRectWidth(&rcFTCmb), m_pFD->m_cyTomName, SWP_NOMOVE | SWP_NOZORDER);
	m_pFD->m_jTomName.InvalidateRect();

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// A timer interval expires

AFXINLINE LRESULT CFileParentDlg::OnTimer(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CFileParentDlg::OnTimer\n"));

	if(wParam == m_eTimerId)
	{
		FadeInDialog(*this);
		KillTimer(m_eTimerId);
	}

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CFileParentDlg

BEGIN_MESSAGE_MAP(CFileParentDlg)
	ON_ANY_MAP(WM_COMMAND, OnCommand)
	ON_ANY_MAP(WM_SIZE, OnSize)
	ON_ANY_MAP(WM_TIMER, OnTimer)
END_MESSAGE_MAP()
