// CFileDlg.hpp - Open and Save As Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CFILEDLG_INCLUDED_
#define _CFILEDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CFileDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CFileDlg : public CFileDialog
{
public:
	enum
	{
		// Static identifier
		m_eTomNameId = 5000,

		// Offset for reposition controls
		m_ecxOffset = 12,
	};

public:
	int       m_cyTomName;
	UINT      m_nItemId;
	CComboBox m_jFTCmb;
	CStatic   m_jTomName;

public:
	CFileDlg(PTSTR pszFileName, PTSTR pszFileTitle);
	BOOL GetOpenFileName(BOOL bImport);
	BOOL GetSaveFileName(BOOL bExport);

protected:
	BOOL OnCdnFileOK(PCOFNOTIFY pOFN);
	void OnCdnInitDone(PCOFNOTIFY pOFN);
	void OnCdnSelChange(PCOFNOTIFY pOFN);

	DECLARE_MESSAGE_MAP()
};

class CFileParentDlg : public CSubclassWnd<CDialog>
{
public:
	enum
	{
		// Timer identifier and its interval
		m_eTimerId   = 7,
		m_eTimerIntl = 100,
	};

public:
	CFileDlg* m_pFD;
	void CloseDialog();

protected:
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CFileDlg::CFileDlg(PTSTR pszFileName, PTSTR pszFileTitle)
{
	TRACE(_T("Entering CFileDlg::CFileDlg\n"));

	lpstrFile      = pszFileName;
	lpstrFileTitle = pszFileTitle;
}

AFXINLINE BOOL CFileDlg::GetOpenFileName(BOOL bImport)
{
	m_nItemId = bImport ? ID_FILE_IMPORT : ID_FILE_OPEN;
	return CFileDialog::GetOpenFileName();
}

AFXINLINE BOOL CFileDlg::GetSaveFileName(BOOL bExport)
{
	m_nItemId = bExport ? ID_FILE_EXPORT : ID_FILE_SAVE_AS;
	return CFileDialog::GetSaveFileName();
}

// End of _CFILEDLG_INCLUDED_
#endif
