// CFindReplDlg.hpp - Finds and Replaces POI Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CFINDREPLDLG_INCLUDED_
#define _CFINDREPLDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CFindReplDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CFindReplDlg : public CDialog
{
public:
	BOOL    m_bReplaceDlg;
	UINT    m_nMatchCase, m_nOnlyName, m_nAllPoi;
	PTSTR   m_pszFindText, m_pszReplaceText;
	CButton m_jOKBtn;
	CEdit   m_jFindWhat, m_jReplaceWith;

public:
	CFindReplDlg(PTSTR pszFindText, PTSTR pszReplaceText);
	void CloseDialog(int iResult);
	int DisplayDialogBox(HINSTANCE hInstance, UINT nTmplId, HWND hOwnerWnd);

protected:
	void OnFindWhat(UINT nNotify, HWND hCtrlWnd);
	void OnOK(UINT nNotify, HWND hCtrlWnd);
	void OnCancel(UINT nNotify, HWND hCtrlWnd);
	BOOL OnInitDialog(HWND hFocusWnd);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CFindReplDlg::CFindReplDlg(PTSTR pszFindText, PTSTR pszReplaceText)
{
	TRACE(_T("Entering CFindReplDlg::CFindReplDlg\n"));

	m_nMatchCase      = BST_CHECKED;
	m_nOnlyName       = BST_CHECKED;
	m_nAllPoi         = BST_CHECKED;
	m_pszFindText     = pszFindText;
	*m_pszFindText    = CHR_NULL;
	m_pszReplaceText  = pszReplaceText;
	*m_pszReplaceText = CHR_NULL;
}

AFXINLINE int CFindReplDlg::DisplayDialogBox(HINSTANCE hInstance, UINT nTmplId, HWND hOwnerWnd)
{
	TRACE(_T("Entering CFindReplDlg::DisplayDialogBox\n"));

	m_bReplaceDlg = nTmplId == IDD_REPLACE_POI;
	return DialogBox(hInstance, nTmplId, hOwnerWnd);
}

// End of _CFINDREPLDLG_INCLUDED_
#endif
