// CFontDlg.cpp - Font Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include <Dlgs.h>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from a menu or a control sends a notification

AFXINLINE LRESULT CFontDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CFontDlg::OnCommand\n"));

	UINT nBtnId;
	nBtnId = LOWORD(wParam);
	if(nBtnId == m_eApplyId)
	{
		SCCOLORREF scrFont[] =
		{
			RGB_BLACK,
			RGB_DKBROWN,
			RGB_DKGREEN,
			RGB_BROWN,
			RGB_DKBLUE,
			RGB_DKMAGENTA,
			RGB_DKGRAY,
			RGB_GRAY,
			RGB_LTGRAY,
			RGB_RED,
			RGB_GREEN,
			RGB_YELLOW,
			RGB_BLUE,
			RGB_MAGENTA,
			RGB_CYAN,
			RGB_WHITE,
		};
		CComboBox jColorCb;
		jColorCb = GetChild(cmb4);
		ASSERT(jColorCb.GetCount() == countof(scrFont));
		rgbColors = scrFont[jColorCb.GetCurSel()];
		GetLogFont();
		e_pTPE->SetLvFont();
		return WMR_DEFAULT;
	}

	if((nBtnId == ID_OK) || (nBtnId == ID_CANCEL))
	{
		FadeOutDialog(*this);
		DestroyIcon(SetWindowIcon(ICON_SMALL));
	}

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog box is being displayed

AFXINLINE BOOL CFontDlg::OnInitDialog(HWND hFocusWnd)
{
	TRACE(_T("Entering CFontDlg::OnInitDialog\n"));

	// Disables unused controls
	SetDialogIcon(*this, ID_TOOLS_LVFONT);
	::EnableWindow(GetChild(chx1), FALSE);
	::EnableWindow(GetChild(chx2), FALSE);
	::EnableWindow(GetChild(stc7), FALSE);
	MoveDialogCenter();
	FadeInDialog(*this);

	// Directs the system (TRUE) or application itself (FALSE) to set the keyboard focus
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CFontDlg

BEGIN_MESSAGE_MAP(CFontDlg)
	ON_ANY_MAP(WM_COMMAND, OnCommand)
	ON_WM_INITDIALOG(OnInitDialog)
END_MESSAGE_MAP()
