// CLvBkDlg.cpp - List View Background Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// The user specifies a file name and clicks the OK button

AFXINLINE BOOL CLvBkDlg::OnCdnFileOK(PCOFNOTIFY pOFN)
{
	TRACE(_T("Entering CLvBkDlg::OnCdnFileOK\n"));

	((CLvBkParentDlg*)&m_hParentDlg)->CloseDialog();

	// Accepts (FALSE) or rejects (TRUE) the file name
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// The system has finished arranging the controls in the dialog box

AFXINLINE void CLvBkDlg::OnCdnInitDone(PCOFNOTIFY pOFN)
{
	TRACE(_T("Entering CLvBkDlg::OnCdnInitDone\n"));

	CLvBkParentDlg* pLPD;
	SetParent(GetParent());
	if(e_dwWinVer <= WV_XP)
		SetDialogIcon(m_hParentDlg, ID_TOOLS_LVBKGND);
	pLPD = (CLvBkParentDlg*)&m_hParentDlg;
	pLPD->MoveDialogCenter();
	if(e_pTPE->m_jOptionDlg.m_nFadeWnd == BST_UNCHECKED)
		return;

	pLPD->SubclassWindow();
	pLPD->SetWindowExStyle(pLPD->GetWindowExStyle() | WS_EX_LAYERED);
	pLPD->SetLayeredWindowAttributes(UNUSED, 0, LWA_ALPHA);
	pLPD->SetTimer(CLvBkParentDlg::m_eTimerId, CLvBkParentDlg::m_eTimerIntl);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CLvBkDlg

BEGIN_MESSAGE_MAP(CLvBkDlg)
	BEGIN_NOTIFY_MAP()
		ON_CDN_FILEOK(OnCdnFileOK)
		ON_CDN_INITDONE(OnCdnInitDone)
	END_NOTIFY_MAP()
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////////////////////////
// Closes the dialog

void CLvBkParentDlg::CloseDialog()
{
	TRACE(_T("Entering CLvBkParentDlg::CloseDialog\n"));

	FadeOutDialog(*this);
	if(e_dwWinVer <= WV_XP)
		DestroyIcon(SetWindowIcon(ICON_SMALL));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from a menu or a control sends a notification

AFXINLINE LRESULT CLvBkParentDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CLvBkParentDlg::OnCommand\n"));

	if(LOWORD(wParam) == ID_CANCEL)
		CloseDialog();

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// A timer interval expires

AFXINLINE LRESULT CLvBkParentDlg::OnTimer(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CLvBkParentDlg::OnTimer\n"));

	if(wParam == m_eTimerId)
	{
		FadeInDialog(*this);
		KillTimer(m_eTimerId);
	}

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CLvBkParentDlg

BEGIN_MESSAGE_MAP(CLvBkParentDlg)
	ON_ANY_MAP(WM_COMMAND, OnCommand)
	ON_ANY_MAP(WM_TIMER, OnTimer)
END_MESSAGE_MAP()
