// CLvHeader.cpp - List View Header Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// Left or right mouse button has pressed/double clicked

AFXINLINE LRESULT CLvHeader::OnLRBtnDblClkDown(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CLvHeader::OnLRBtnDblClkDown\n"));

	if(e_pTPE->m_jLvEdit.IsWindowVisible())
	{
		e_pTPE->m_jLvEdit.SendMessage(WM_CHAR, CHR_CR);
		if(!e_pTPE->m_jLvEdit.m_bTextOK)
			return WMR_PROCESSED;
	}

	HDHITTESTINFO hhti;
	hhti.pt = MAKEPOINT(lParam);
	HitTest(&hhti);
	if(hhti.flags & (HHT_ONDIVIDER | HHT_ONDIVOPEN))
	{
		if((hhti.iItem == LVC_LNG) || (hhti.iItem == LVC_LAT))
			return ((e_pTPE->m_fst == CTomPoiEdr::FST_CPB) ? WMR_PROCESSED : WMR_DEFAULT);

		return (((hhti.iItem == LVC_DIST) &&
			(e_pTPE->m_jOptionDlg.m_nShowDist == BST_UNCHECKED)) ? WMR_PROCESSED : WMR_DEFAULT);
	}

	int ceLvItem;
	ceLvItem = e_pTPE->m_jListView.GetItemCount();
	if(e_pTPE->m_bMyBP)
		ceLvItem--;
	if(ceLvItem < 2)
		return WMR_PROCESSED;

	if(hhti.iItem != LVC_DIST)
		return WMR_DEFAULT;

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return ((e_pTPE->m_iLvBaseItem == LVI_ERR) ? WMR_PROCESSED : WMR_DEFAULT);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Mouse cursor shape should be set

AFXINLINE BOOL CLvHeader::OnSetCursor(HWND hCursorWnd, int iHitTest, UINT nMsg)
{
	TRACE(_T("Entering CLvHeader::OnSetCursor\n"));

	HDHITTESTINFO hhti;
	GetCursorPos(&hhti.pt);
	ScreenToClient(&hhti.pt);
	HitTest(&hhti);
	if((hhti.iItem == LVC_LNG) || (hhti.iItem == LVC_LAT))
	{
		if(e_pTPE->m_fst != CTomPoiEdr::FST_CPB)
			return FALSE;
	}
	else if((hhti.iItem != LVC_DIST) || (e_pTPE->m_jOptionDlg.m_nShowDist == BST_CHECKED))
		return FALSE;

	SetCursor(LoadCursor(IDC_ARROW));

	// Cursor shape is set (TRUE) or not (FALSE)
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CLvHeader

BEGIN_MESSAGE_MAP(CLvHeader)
	ON_SAME_MAP(WM_LBUTTONDBLCLK)
	ON_SAME_MAP(WM_LBUTTONDOWN)
	ON_ANY_MAP(WM_RBUTTONDOWN, OnLRBtnDblClkDown)
	ON_WM_SETCURSOR(OnSetCursor)
END_MESSAGE_MAP()
