// CMyBPDlg.hpp - My Base Point Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CMYBPDLG_INCLUDED_
#define _CMYBPDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CMyBPDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CMyBPDlg : public CDialog
{
public:
	enum
	{
		// Minimum size of dialog box
		m_ecxMinDlg = 360,
		m_ecyMinDlg = 360,

		// List view extended styles
		m_eLvExStyle   = LVS_EX_DOUBLEBUFFER | LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP,
		m_eLvExStyleXP = m_eLvExStyle | LVS_EX_GRIDLINES,

		// Maximum number of list view items
		m_eceMaxLvItem = 100,

		// Button indices
		m_eSet = 0,
		m_eMoveU,
		m_eMoveD,
		m_eAdd,
		m_eDel,
		m_eDelAll,
		m_eExport,
		m_eOK,
		m_eCancel,
		m_eceButton,

		// Separator character for base points written into profile
		m_eSepChar = CHR_GT,
	};

	class CLvCtrl : public CListView
	{
	public:
		BOOL m_bRedraw;

	public:
		void SetWindowRedraw(BOOL bRedraw = TRUE);
	};

public:
	BOOL    m_bDirty, m_bExport;
	int     m_iInsertBP;
	CButton m_jButton[m_eceButton];
	CLvCtrl m_jListView;

public:
	static CTCHAR m_szSection[];
	static CTCHAR m_szListEntry[];
	static CTCHAR m_szInsertEntry[];

public:
	CMyBPDlg();
	void AutoSizeLvCol();
	void EnableButtons(BOOL bSetFocus);
	void MoveLvItem(BOOL bMoveUp);
	void WriteSection(BOOL bWriteBP, int iResult);

protected:
	void OnSet(UINT nNotify, HWND hCtrlWnd);
	void OnMoveUp(UINT nNotify, HWND hCtrlWnd);
	void OnMoveDown(UINT nNotify, HWND hCtrlWnd);
	void OnAdd(UINT nNotify, HWND hCtrlWnd);
	void OnDelete(UINT nNotify, HWND hCtrlWnd);
	void OnDeleteAll(UINT nNotify, HWND hCtrlWnd);
	void OnExport(UINT nNotify, HWND hCtrlWnd);
	void OnOK(UINT nNotify, HWND hCtrlWnd);
	void OnCancel(UINT nNotify, HWND hCtrlWnd);
	void OnGetMinMaxInfo(PMINMAXINFO pMMI);
	BOOL OnInitDialog(HWND hFocusWnd);
	void OnLvnItemChanged(PCNMLISTVIEW pNMLV);
	UINT OnNmCustomDraw(PCNMCUSTOMDRAW pNMCD);
	BOOL OnNmDblClk(PCNMHDR pNMH);
	void OnSize(UINT nType, int cxClient, int cyClient);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CMyBPDlg::CMyBPDlg()
{
	TRACE(_T("Entering CMyBPDlg::CMyBPDlg\n"));

	m_jListView.m_bRedraw = TRUE;
}

// End of _CMYBPDLG_INCLUDED_
#endif
