// COpenDeviceDlg.hpp - Open Device Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _COPENDEVICEDLG_INCLUDED_
#define _COPENDEVICEDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  COpenDeviceDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct GPSFILELIST* PGPSFILELIST;

class COpenDeviceDlg : public CDialog
{
public:
	enum
	{
		// Minimum size of dialog box
		m_ecxMinDlg = 480,
		m_ecyMinDlg = 360,

		// List view extended styles
		m_eLvExStyle   = LVS_EX_DOUBLEBUFFER | LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP,
		m_eLvExStyleXP = m_eLvExStyle | LVS_EX_GRIDLINES,

		// List view columns
		LVC_FIRST = 0,
		LVC_NAME  = LVC_FIRST,
		LVC_DATE,
		LVC_SIZE,
		LVC_BMP,
		LVC_OGG,
		LVC_RPF,
		LVC_VIF,
		LVC_COUNT,

		// POI image list
		m_ecxDummyImgXP = 26,
		m_ecyDummyImgXP = m_ecxDummyImgXP,
		m_ecxDummyImg   = m_ecxDummyImgXP,
		m_ecyDummyImg   = m_ecyDummyImgXP + 1,
		m_ecxPoiImg     = 22,
		m_ecyPoiImg     = m_ecxPoiImg,
		m_eceGrowImg    = 32,

		// Maximum number of characters, including null character
		m_eccDateCol = 64,
		m_eccSizeCol = 32,
		m_eccMarkCol = 8,

		// Timer identifier and its interval
		m_eTimerId   = 7,
		m_eTimerIntl = 100,
	};

	class CLvHeader : public CSubclassWnd<CHeader>
	{
	protected:
		LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);

		DECLARE_MESSAGE_MAP()
	};

public:
	PTSTR        m_pszSelName;
	PGPSFILELIST m_pGPSFL;
	BOOL         m_bFavFile, m_bAscend;
	int          m_iLvCol;
	HINTERNET    m_hInternet;
	CButton      m_jDeleteBtn, m_jRefreshBtn, m_jOKBtn, m_jCancelBtn;
	CImageList   m_jDummyIL, m_jLvItemIL;
	CListView    m_jListView;
	CLvHeader    m_jLvHeader;

public:
	COpenDeviceDlg(HINTERNET hInternet, PGPSFILELIST pGPSFL, PTSTR pszSelName);

public:
	static CTCHAR m_szSection[];

public:
	static int CALLBACK CompareLvItem(int iItem1, int iItem2, LPARAM lSortParam);
	static int CALLBACK CompareLvParam(LPARAM lParam1, LPARAM lParam2, LPARAM lSortParam);

protected:
	void OnCommand(UINT nItemId, UINT nNotify, HWND hCtrlWnd);
	void OnGetMinMaxInfo(PMINMAXINFO pMMI);
	BOOL OnInitDialog(HWND hFocusWnd);
	void OnHdnItemClick(PCNMHEADER pNMH);
	void OnLvnItemChanged(PCNMLISTVIEW pNMLV);
	UINT OnNmCustomDraw(PCNMCUSTOMDRAW pNMCD);
	BOOL OnNmDblClk(PCNMHDR pNMH);
	void OnSize(UINT nType, int cxClient, int cyClient);
	void OnTimer(UINT nTimerId);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE COpenDeviceDlg::COpenDeviceDlg(HINTERNET hInternet,
	PGPSFILELIST pGPSFL, PTSTR pszSelName)
{
	TRACE(_T("Entering COpenDeviceDlg::COpenDeviceDlg\n"));

	m_hInternet  = hInternet;
	m_pGPSFL     = pGPSFL;
	m_pszSelName = pszSelName;
}

// End of _COPENDEVICEDLG_INCLUDED_
#endif
