// COpenFavDlg.hpp - Open Favorites Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _COPENFAVDLG_INCLUDED_
#define _COPENFAVDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  COpenFavDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class COpenFavDlg : public CDialog, public BROWSEINFO
{
public:
	enum
	{
		// Tree view styles
		m_eTvStyleXP = TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND | TVS_TRACKSELECT,
		m_eTvStyle   = m_eTvStyleXP | TVS_FULLROWSELECT,

		// Control styles
		m_eRecentBtnStyle = WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_AUTOCHECKBOX,

		// Control identifiers
		m_eRecentBtnId = 5000,

		// Control sizes
		m_ecxDialog   = 520,
		m_ecyDialog   = m_ecxDialog,
		m_ecxBorder   = 10,
		m_ecyBorder   = m_ecxBorder,
		m_ecxGap      = 10,
		m_ecyGap      = m_ecxGap,
		m_ecxPadding  = 2,
		m_ecxCheckBox = 16,
		m_ecxTvCtrl   = m_ecxDialog - m_ecxBorder * 2,
	};

public:
	PITEMIDLIST m_pIDL;
	WNDPROC     m_wpPrev;
	PTSTR       m_pszFileName;
	PCTSTR      m_pszFavName;
	BOOL        m_bRecentDest;
	CStatic     m_jTitleStc;

public:
	COpenFavDlg();
	~COpenFavDlg();
	BOOL Browse(PTSTR pszFileName);
	void FreeIDL();
	void Initialized();
	void SelChanged(PITEMIDLIST pIDL);

public:
	static int CALLBACK CbProc(HWND hWnd, UINT nMsg, LPARAM lData, LPARAM lParam);
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE COpenFavDlg::COpenFavDlg()
{
	TRACE(_T("Entering COpenFavDlg::COpenFavDlg\n"));

	pidlRoot      = NULL;
	ulFlags       = BIF_RETURNONLYFSDIRS;
	lpfn          = CbProc;
	lParam        = (LPARAM)this;
	m_pIDL        = NULL;
	m_bRecentDest = FALSE;
}

AFXINLINE COpenFavDlg::~COpenFavDlg()
{
	TRACE(_T("Entering COpenFavDlg::~COpenFavDlg\n"));

	FreeIDL();
}

AFXINLINE BOOL COpenFavDlg::Browse(PTSTR pszFileName)
{
	TRACE(_T("Entering COpenFavDlg::Browse\n"));

	PITEMIDLIST pIDL;
	m_jTitleStc   = NULL;
	m_pszFileName = pszFileName;
	pIDL          = SHBrowseForFolder(this);
	if(!pIDL)
		return FALSE;

	FreeIDL();
	m_pIDL = pIDL;
	return TRUE;
}

AFXINLINE void COpenFavDlg::FreeIDL()
{
	TRACE(_T("Entering COpenFavDlg::FreeIDL\n"));

	CoTaskMemFree(m_pIDL);
}

// End of _COPENFAVDLG_INCLUDED_
#endif
