// COptionDlg.hpp - Options Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _COPTIONDLG_INCLUDED_
#define _COPTIONDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  COptionDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class COptionDlg : public CDialog
{
public:
	enum
	{
		// Index of check boxes
		m_eShowMb = 0,
		m_eShowTb,
		m_eLargeTb,
		m_eWrapTb,
		m_eLngFirst,
		m_eDmsFormat,
		m_eCompassDir,
		m_eAutoColumn,
		m_eShowDist,
		m_eMetricUnit,
		m_eRecentFile,
		m_eFadeWnd,
		m_eShadeTable,
		m_eShowSb,
		m_eSignalMark,
		m_eOptPoi,
		m_eCheckName,
		m_eAutoBP,
		m_eOpenLast,
		m_eTranName,
		m_eBackupFile,
		m_eGmUseCookie,
		m_eGmUpdateMemo,
		m_eGmFlashRoute,
		m_eceCheckBox,

		// Maximum number of characters can be type in
		m_eccMaxRecentBuddy = 1,
		m_eccMaxBackupBuddy = 2,
	};

public:
	int       m_ceRecentFile, m_ceBackupIntl, m_iGmLang;
	UINT      m_nShowMb, m_nShowTb, m_nLargeTb, m_nWrapTb, m_nLngFirst, m_nDmsFormat;
	UINT      m_nCompassDir, m_nAutoColumn, m_nShowDist, m_nMetricUnit, m_nRecentFile;
	UINT      m_nFadeWnd, m_nShadeTable, m_nShowSb, m_nSignalMark, m_nOptPoi;
	UINT      m_nCheckName, m_nAutoBP, m_nOpenLast, m_nTranName, m_nBackupFile;
	UINT      m_nGmUseCookie, m_nGmUpdateMemo, m_nGmFlashRoute;
	PUINT     m_pnCheckBox[m_eceCheckBox];
	CButton   m_jLargeTb, m_jAutoWrapTb, m_jAutoBP, m_jOpenLast;
	CComboBox m_jGmLang;
	CEdit     m_jRecentBuddy, m_jBackupBuddy;
	CUpDown   m_jRecentSpin, m_jBackupSpin;

public:
	static CUINT m_nCheckBoxId[];

public:
	COptionDlg();
	void CloseDialog(int iResult);
	UINT ValidateValue(CEdit** ppEdit);

protected:
	void OnShowToolbar(UINT nNotify, HWND hCtrlWnd);
	void OnShowDistance(UINT nNotify, HWND hCtrlWnd);
	void OnRecentFile(UINT nNotify, HWND hCtrlWnd);
	void OnBackupFile(UINT nNotify, HWND hCtrlWnd);
	void OnOK(UINT nNotify, HWND hCtrlWnd);
	void OnCancel(UINT nNotify, HWND hCtrlWnd);
	BOOL OnInitDialog(HWND hFocusWnd);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE COptionDlg::COptionDlg()
{
	TRACE(_T("Entering COptionDlg::COptionDlg\n"));

	m_pnCheckBox[m_eShowMb]       = &m_nShowMb;
	m_pnCheckBox[m_eShowTb]       = &m_nShowTb;
	m_pnCheckBox[m_eLargeTb]      = &m_nLargeTb;
	m_pnCheckBox[m_eWrapTb]       = &m_nWrapTb;
	m_pnCheckBox[m_eLngFirst]     = &m_nLngFirst;
	m_pnCheckBox[m_eDmsFormat]    = &m_nDmsFormat;
	m_pnCheckBox[m_eCompassDir]   = &m_nCompassDir;
	m_pnCheckBox[m_eAutoColumn]   = &m_nAutoColumn;
	m_pnCheckBox[m_eShowDist]     = &m_nShowDist;
	m_pnCheckBox[m_eMetricUnit]   = &m_nMetricUnit;
	m_pnCheckBox[m_eRecentFile]   = &m_nRecentFile;
	m_pnCheckBox[m_eFadeWnd]      = &m_nFadeWnd;
	m_pnCheckBox[m_eShadeTable]   = &m_nShadeTable;
	m_pnCheckBox[m_eShowSb]       = &m_nShowSb;
	m_pnCheckBox[m_eSignalMark]   = &m_nSignalMark;
	m_pnCheckBox[m_eOptPoi]       = &m_nOptPoi;
	m_pnCheckBox[m_eCheckName]    = &m_nCheckName;
	m_pnCheckBox[m_eAutoBP]       = &m_nAutoBP;
	m_pnCheckBox[m_eOpenLast]     = &m_nOpenLast;
	m_pnCheckBox[m_eTranName]     = &m_nTranName;
	m_pnCheckBox[m_eBackupFile]   = &m_nBackupFile;
	m_pnCheckBox[m_eGmUseCookie]  = &m_nGmUseCookie;
	m_pnCheckBox[m_eGmUpdateMemo] = &m_nGmUpdateMemo;
	m_pnCheckBox[m_eGmFlashRoute] = &m_nGmFlashRoute;
}

// End of _COPTIONDLG_INCLUDED_
#endif
