// CQueryNameDlg.cpp - Queries File Name Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CQueryNameDlg.hpp"
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// IDC_TOM_NAME sends a notification message

AFXINLINE void CQueryNameDlg::OnTomName(UINT nNotify, HWND hCtrlWnd)
{
	TRACE(_T("Entering CQueryNameDlg::OnTomName\n"));

	if((nNotify != EN_CHANGE) || (GetFocus() != hCtrlWnd))
		return;

	TCHAR szWinName[MAX_PATH];
	m_jTomName.GetWindowText(szWinName, countof(szWinName));
	e_pTPE->WinFile2TomFile(szWinName, szWinName);
	m_jWinName.SetWindowText(szWinName);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// IDC_WIN_NAME sends a notification message

AFXINLINE void CQueryNameDlg::OnWinName(UINT nNotify, HWND hCtrlWnd)
{
	TRACE(_T("Entering CQueryNameDlg::OnWinName\n"));

	if((nNotify != EN_CHANGE) || (GetFocus() != hCtrlWnd))
		return;

	TCHAR szTomName[MAX_PATH];
	m_jWinName.GetWindowText(szTomName, countof(szTomName));
	e_pTPE->TomFile2WinFile(szTomName, szTomName);
	m_jTomName.SetWindowText(szTomName);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// ID_CANCEL sends a notification message

AFXINLINE void CQueryNameDlg::OnCancel(UINT nNotify, HWND hCtrlWnd)
{
	TRACE(_T("Entering CQueryNameDlg::OnCancel\n"));

	FadeOutDialog(*this);
	DestroyIcon(SetWindowIcon(ICON_SMALL));
	EndDialog();
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog box is being displayed

AFXINLINE BOOL CQueryNameDlg::OnInitDialog(HWND hFocusWnd)
{
	TRACE(_T("Entering CQueryNameDlg::OnInitDialog\n"));

	SetDialogIcon(*this, ID_FILE_QUERY);
	m_jTomName = GetChild(IDC_TOM_NAME);
	m_jWinName = GetChild(IDC_WIN_NAME);
	m_jTomName.SetLimitText(MAX_PATH - 1);
	m_jWinName.SetLimitText(MAX_PATH - 1);
	MoveDialogCenter();
	FadeInDialog(*this);

	// System (TRUE) or application itself (FALSE) sets the keyboard focus
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CQueryNameDlg

BEGIN_MESSAGE_MAP(CQueryNameDlg)
	BEGIN_COMMAND_MAP()
		ON_CONTROL(IDC_TOM_NAME, OnTomName)
		ON_CONTROL(IDC_WIN_NAME, OnWinName)
		ON_CONTROL(ID_CANCEL, OnCancel)
	END_COMMAND_MAP()
	ON_WM_INITDIALOG(OnInitDialog)
END_MESSAGE_MAP()
