// CSaveDeviceDlg.hpp - Save Device Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CSAVEDEVICEDLG_INCLUDED_
#define _CSAVEDEVICEDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CSaveDeviceDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

#include "CTomPoiEdr.hpp"

// Save flags for GPS device
enum
{
	GPSSF_OV2 = 0x01,
	GPSSF_BMP = 0x02,
	GPSSF_OGG = 0x04,
	GPSSF_RPF = 0x08,
	GPSSF_VIF = 0x10,
};

class CSaveDeviceDlg : public CDialog
{
public:
	PCTSTR  m_pszFileName;
	PUINT   m_pnSaveFlags;
	CButton m_jButton[GPSF_COUNT], m_jOKBtn;

public:
	CSaveDeviceDlg(PCTSTR pszFileName, PUINT pnSaveFlags);

protected:
	void OnCommand(UINT nItemId, UINT nNotify, HWND hCtrlWnd);
	BOOL OnInitDialog(HWND hFocusWnd);

	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CSaveDeviceDlg::CSaveDeviceDlg(PCTSTR pszFileName, PUINT pnSaveFlags)
{
	TRACE(_T("Entering CSaveDeviceDlg::CSaveDeviceDlg\n"));

	m_pszFileName = pszFileName;
	m_pnSaveFlags = pnSaveFlags;
}

// End of _CSAVEDEVICEDLG_INCLUDED_
#endif
