// CSbCtrl.cpp - Status Bar Control Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// Sets the text of info part, and inserts a space at head of string, if necessary

BOOL CSbCtrl::SetInfoText(UINT nMsg, WPARAM wParam, PCTSTR pszText)
{
	TRACE(_T("Entering CSbCtrl::SetInfoText\n"));

	if(!pszText || !*pszText || (*pszText == CHR_SP))
		return FALSE;

	PTSTR pszDest;
	TCHAR szText[MAX_STR], cLast;
	int   ccText;
	*szText = CHR_SP;
	ccText  = lstrlen(pszText);
	cLast   = pszText[ccText - 1];
	if((cLast == _T('C')) ||
		((ccText >= 2) && (cLast == CHR_DOT) && (pszText[ccText - 2] != CHR_DOT)))
		ccText--;
	if(ccText > (countof(szText) - 2))
		ccText = countof(szText) - 2;
	pszDest = szText + 1;
	CopyMemory(pszDest, pszText, ccText * sizeof(TCHAR));
	pszDest[ccText] = CHR_NULL;
	return DefWindowProc(nMsg, wParam, (LPARAM)szText);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Sets the text of a status bar

AFXINLINE LRESULT CSbCtrl::OnSbSetText(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CSbCtrl::OnSbSetText\n"));

	int iPart;
	iPart = LOBYTE(wParam);
	if((iPart != CTomPoiEdr::m_eInfoPart) && (iPart < CTomPoiEdr::m_eceSbPart))
		return WMR_DEFAULT;

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return (SetInfoText(SB_SETTEXT, wParam, (PCTSTR)lParam) ? TRUE : WMR_DEFAULT);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Sets the text of a window

AFXINLINE LRESULT CSbCtrl::OnSetText(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CSbCtrl::OnSetText\n"));

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return (SetInfoText(WM_SETTEXT, wParam, (PCTSTR)lParam) ? TRUE : WMR_DEFAULT);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CSbCtrl

BEGIN_MESSAGE_MAP(CSbCtrl)
	ON_ANY_MAP(SB_SETTEXT, OnSbSetText)
	ON_ANY_MAP(WM_SETTEXT, OnSetText)
END_MESSAGE_MAP()
