// CTbBkDlg.cpp - Toolbar Background Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTbBkDlg.hpp"
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// A command item from a menu or a control sends a notification

AFXINLINE LRESULT CTbBkDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CTbBkDlg::OnCommand\n"));

	UINT nBtnId;
	nBtnId = LOWORD(wParam);
	if(nBtnId == m_eApplyId)
	{
		e_pTPE->m_crTbBkgnd = RGB(GetChildInt(m_eREditId), GetChildInt(m_eGEditId),
			GetChildInt(m_eBEditId));
		e_pTPE->m_jToolbar.SendMessage(WM_NCPAINT);
		e_pTPE->m_jToolbar.InvalidateRect();
		return WMR_PROCESSED;
	}

	if((nBtnId == ID_OK) || (nBtnId == ID_CANCEL))
		FadeOutDialog(*this);

	// Result value of the message processed (or WMR_PROCESSED, WMR_DEFAULT)
	return WMR_DEFAULT;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog box is being displayed

AFXINLINE BOOL CTbBkDlg::OnInitDialog(HWND hFocusWnd)
{
	TRACE(_T("Entering CTbBkDlg::OnInitDialog\n"));

	TCHAR   szBtnText[32];
	int     xBtn, yBtn, cxBtn, cyBtn;
	RECT    rc;
	CButton jAddBtn, jOKBtn, jCancelBtn, jApplyBtn;
	jAddBtn = GetChild(m_eAddBtnId);
	if(jAddBtn)
	{
		PTSTR pszBtnText;
		jAddBtn.GetWindowText(szBtnText, countof(szBtnText));
		if((szBtnText[0] == CHR_AMP) && (szBtnText[1] == _T('A')))
			pszBtnText = szBtnText + 1;
		else
		{
			pszBtnText = StrStr(szBtnText, _T("(&A)"));
			if(pszBtnText)
			{
				*pszBtnText = CHR_NULL;
				pszBtnText  = szBtnText;
				TrimString(szBtnText);
			}
		}
		if(pszBtnText)
			jAddBtn.SetWindowText(pszBtnText);
	}
	LoadString(e_hInstance, IDS_COLORDLG_APPLY, szBtnText, countof(szBtnText));
	jOKBtn     = GetChild(ID_OK);
	jCancelBtn = GetChild(ID_CANCEL);
	jCancelBtn.SetWindowStyle(jCancelBtn.GetWindowStyle() & ~WS_GROUP);
	jOKBtn.GetWindowRect(&rc);
	cxBtn = GetRectWidth(&rc);
	cyBtn = GetRectHeight(&rc);
	ScreenToClient((PPOINT)&rc);
	xBtn = rc.left;
	yBtn = rc.top;
	jCancelBtn.GetWindowRect(&rc);
	ScreenToClient((PPOINT)&rc);
	xBtn = rc.left * 2 - xBtn;
	jApplyBtn.CreateWindow(szBtnText, m_eApplyStyle, xBtn, yBtn, cxBtn, cyBtn,
		*this, m_eApplyId);
	jApplyBtn.SetWindowPos(jCancelBtn, UNUSED, UNUSED, UNUSED, UNUSED, SWP_NOMOVE | SWP_NOSIZE);
	jApplyBtn.SetWindowFont(jCancelBtn.GetWindowFont());
	MoveDialogCenter();
	FadeInDialog(*this);

	// Directs the system (TRUE) or application itself (FALSE) to set the keyboard focus
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps for CTbBkDlg

BEGIN_MESSAGE_MAP(CTbBkDlg)
	ON_ANY_MAP(WM_COMMAND, OnCommand)
	ON_WM_INITDIALOG(OnInitDialog)
END_MESSAGE_MAP()
