// CTbCtrl.hpp - Toolbar Control Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CTBCTRL_INCLUDED_
#define _CTBCTRL_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CTbCtrl - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CTbCtrl : public CSubclassWnd<CToolbar>
{
public:
	int FindButton(UINT nCmdId);

public:
	BOOL CheckButton(UINT nCmdId, BOOL bCheck = TRUE);
	BOOL EnableButton(UINT nCmdId, BOOL bEnable = TRUE);
	BOOL IsButtonEnabled(UINT nCmdId);
	BOOL IsButtonPressed(UINT nCmdId);
	BOOL PressButton(UINT nCmdId, BOOL bPress = TRUE);

protected:
	LRESULT OnLRBtnDblClkDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnMouseMove(WPARAM wParam, LPARAM lParam);
	int OnNcCalcSize(BOOL bCalcRects, LPARAM lParam);
	void OnNcPaint(HRGN hUpdateRgn);
	void OnTtnPop(PCNMHDR pNMH);

	DECLARE_MESSAGE_MAP()
};

// End of _CTBCTRL_INCLUDED_
#endif
