// CTranNameDlg.cpp - Translates File Name Dialog Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>
#include "CTomPoiEdr.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////
// Initializes Browse Folder dialog box

AFXINLINE void CTranNameDlg::Initialized()
{
	TRACE(_T("Entering CTranNameDlg::Initialized\n"));

	TCHAR      szText[MAX_PATH + 64];
	int        xCtrl, cxCtrl, xButton, yButton, cxButton, cyButton, cyStatic, yTvCtrl;
	SIZE       size;
	RECT       rc;
	TEXTMETRIC tm;
	HFONT      hFont, hOldFont;
	HDC        hDC;
	CButton    jButton, jWinBtn;
	CStatic    jTranStc;
	CTreeView  jTreeView;
	SetDialogIcon(*this, ID_FILE_TRANSLATE);
	LoadString(e_hInstance, IDS_TND_NAME, szText, countof(szText));
	SetWindowText(szText);
	m_jTitleStc = GetChild(IDC_BFD_STATIC1);
	m_jTitleStc.SetWindowStyle(m_jTitleStc.GetWindowStyle() | SS_PATHELLIPSIS);
	hDC   = m_jTitleStc.GetDC();
	hFont = m_jTitleStc.GetWindowFont();
	if(!hFont)
		hFont = GetStockFont(SYSTEM_FONT);
	SelectFont(hDC, hFont);
	GetTextMetrics(hDC, &tm);
	cyStatic = tm.tmHeight + tm.tmExternalLeading;
	m_jTitleStc.MoveWindow(m_ecxBorder, m_ecyBorder, m_ecxTvCtrl, cyStatic);
	jButton = GetChild(ID_CANCEL);
	jButton.SetWindowStyle(jButton.GetWindowStyle() & ~WS_GROUP);
	jButton.GetWindowRect(&rc);
	cxButton = GetRectWidth(&rc);
	cyButton = GetRectHeight(&rc);
	xButton  = m_ecxDialog - cxButton - m_ecxBorder + 1;
	yButton  = m_ecyDialog - cyButton - m_ecyBorder;
	jButton.SetWindowPos(NULL, xButton, yButton, UNUSED, UNUSED, SWP_NOSIZE | SWP_NOZORDER);
	jButton = GetChild(ID_OK);
	jButton.SetWindowPos(NULL, xButton - cxButton - m_ecxGap, yButton,
		UNUSED, UNUSED, SWP_NOSIZE | SWP_NOZORDER);
	GetTextExtent(hDC, szText, LoadString(e_hInstance, IDS_TND_TRANSLATE,
			szText, countof(szText)), &size);
	cxCtrl = size.cx + m_ecxPadding;
	jTranStc.CreateWindow(szText, m_eTranStcStyle,
		m_ecxBorder, yButton + (cyButton - size.cy) / 2 + 1,
		cxCtrl, cyStatic, *this, m_eTranStcId);
	hOldFont = jTranStc.GetWindowFont();
	jTranStc.SetWindowFont(hFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	xCtrl = cxCtrl + m_ecxBorder + m_ecxGap;
	GetTextExtent(hDC, szText, LoadString(e_hInstance, IDS_TOMTOM_CHAR,
		szText, countof(szText)), &size);
	cxCtrl = size.cx + m_ecxRadio + m_ecxPadding;
	m_jTomBtn.CreateWindow(szText, m_eTomBtnStyle, xCtrl, yButton,
		cxCtrl, cyButton, *this, m_eTomBtnId);
	hOldFont = m_jTomBtn.GetWindowFont();
	m_jTomBtn.SetWindowFont(hFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	GetTextExtent(hDC, szText, LoadString(e_hInstance, IDS_WINDOWS_CHAR,
		szText, countof(szText)), &size);
	m_jTitleStc.ReleaseDC(hDC);
	jWinBtn.CreateWindow(szText, m_eWinBtnStyle, xCtrl + cxCtrl + m_ecxGap, yButton,
		size.cx + m_ecxRadio + m_ecxPadding, cyButton, *this, m_eWinBtnId);
	hOldFont = jWinBtn.GetWindowFont();
	jWinBtn.SetWindowFont(hFont);
	if(hOldFont)
		DeleteFont(hOldFont);
	CheckButton(m_eTomBtnId, m_eWinBtnId,
		(m_nTomTom == BST_CHECKED) ? m_eTomBtnId : m_eWinBtnId);
	yTvCtrl   = tm.tmHeight + m_ecyBorder + m_ecyGap;
	jTreeView = GetChild(IDC_BFD_TREE_VIEW);
	jTreeView.SetWindowStyle(jTreeView.GetWindowStyle() |
		((e_dwWinVer > WV_XP) ? m_eTvStyle : m_eTvStyleXP));
	jTreeView.MoveWindow(m_ecxBorder, yTvCtrl, m_ecxTvCtrl, yButton - yTvCtrl - m_ecyGap);
	m_jTomBtn.SetWindowPos(jTreeView, UNUSED, UNUSED, UNUSED, UNUSED, SWP_NOMOVE | SWP_NOSIZE);
	jWinBtn.SetWindowPos(m_jTomBtn, UNUSED, UNUSED, UNUSED, UNUSED, SWP_NOMOVE | SWP_NOSIZE);
	SetRect(&rc, 0, 0, m_ecxDialog, m_ecyDialog);
	AdjustWindowRect(&rc, GetWindowStyle(), FALSE);
	MoveWindow(0, 0, GetRectWidth(&rc), GetRectHeight(&rc));
	MoveDialogCenter();
	if(m_pIDL)
		SendMessage(BFFM_SETSELECTION, FALSE, (LPARAM)m_pIDL);
	else
		m_jTitleStc.SetWindowText(lpszTitle);
	jTreeView.EnsureVisible(jTreeView.GetNextItem(TVGN_CARET));
	FadeInDialog(*this);
	m_wpPrev = (WNDPROC)SetWindowLong(GWL_WNDPROC, (LONG)WndProc);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Selected item of Browse Folder dialog box has changed

AFXINLINE void CTranNameDlg::SelChanged(PITEMIDLIST pIDL)
{
	TRACE(_T("Entering CTranNameDlg::SelChanged\n"));

	if(!m_jTitleStc)
		return;

	TCHAR szText[MAX_PATH + 64];
	int   ccText;
	SHGetPathFromIDList(pIDL, m_pszPathName);
	ccText = lstrlen(lpszTitle);
	CopyMemory(szText, lpszTitle, ccText * sizeof(TCHAR));
	szText[ccText]     = CHR_SP;
	szText[ccText + 1] = CHR_SP;
	e_pTPE->GetPurePathName(m_pszPathName, szText + ccText + 2);
	m_jTitleStc.SetWindowText(szText);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Callback procedure for Browse Folder dialog box

int CALLBACK CTranNameDlg::CbProc(HWND hWnd, UINT nMsg, LPARAM lData, LPARAM lParam)
{
	TRACE(_T("Entering CTranNameDlg::CbProc\n"));

	CTranNameDlg* pTND;
	pTND = (CTranNameDlg*)lParam;
	if(nMsg == BFFM_SELCHANGED)
	{
		pTND->SelChanged((PITEMIDLIST)lData);
		return 0;
	}

	if(nMsg != BFFM_INITIALIZED)
		return 0;

	pTND->m_hWnd = hWnd;
	pTND->Initialized();
	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Window procedure for Browse Folder dialog box

LRESULT CALLBACK CTranNameDlg::WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("Entering CTranNameDlg::WndProc\n"));

	CTranNameDlg* pTND;
	pTND = &e_pTPE->m_jTranNameDlg;
	if(nMsg == WM_COMMAND)
	{
		switch(LOWORD(wParam))
		{
		case ID_OK:
			pTND->m_nTomTom = pTND->m_jTomBtn.GetCheck();
		case ID_CANCEL:
			FadeOutDialog(hWnd);
			DestroyIcon(pTND->SetWindowIcon(ICON_SMALL));
		}
	}
	return CallWindowProc(pTND->m_wpPrev, hWnd, nMsg, wParam, lParam);
}
