// CTranNameDlg.hpp - Translates File Name Dialog Declaration File
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _CTRANNAMEDLG_INCLUDED_
#define _CTRANNAMEDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CTranNameDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////

class CTranNameDlg : public CDialog, public BROWSEINFO
{
public:
	enum
	{
		// Tree view styles
		m_eTvStyleXP = TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND | TVS_TRACKSELECT,
		m_eTvStyle   = m_eTvStyleXP | TVS_FULLROWSELECT,

		// Control styles
		m_eTranStcStyle = WS_CHILD | WS_GROUP | WS_VISIBLE | SS_LEFT,
		m_eWinBtnStyle  = WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
		m_eTomBtnStyle  = m_eWinBtnStyle | WS_GROUP | WS_TABSTOP,

		// Control identifiers
		m_eTranStcId = 5000,
		m_eTomBtnId,
		m_eWinBtnId,

		// Control sizes
		m_ecxDialog  = 520,
		m_ecyDialog  = m_ecxDialog,
		m_ecxBorder  = 10,
		m_ecyBorder  = m_ecxBorder,
		m_ecxGap     = 10,
		m_ecyGap     = m_ecxGap,
		m_ecxPadding = 2,
		m_ecxRadio   = 16,
		m_ecxTvCtrl  = m_ecxDialog - m_ecxBorder * 2,
	};

public:
	PITEMIDLIST m_pIDL;
	WNDPROC     m_wpPrev;
	PTSTR       m_pszPathName;
	UINT        m_nTomTom;
	CButton     m_jTomBtn;
	CStatic     m_jTitleStc;

public:
	CTranNameDlg();
	~CTranNameDlg();
	BOOL Browse(PTSTR pszPathName);
	void FreeIDL();
	void Initialized();
	void SelChanged(PITEMIDLIST pIDL);

public:
	static int CALLBACK CbProc(HWND hWnd, UINT nMsg, LPARAM lData, LPARAM lParam);
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
};

////////////////////////////////////////////////////////////////////////////////////////////////

AFXINLINE CTranNameDlg::CTranNameDlg()
{
	TRACE(_T("Entering CTranNameDlg::CTranNameDlg\n"));

	pidlRoot  = NULL;
	ulFlags   = BIF_RETURNONLYFSDIRS;
	lpfn      = CbProc;
	lParam    = (LPARAM)this;
	m_pIDL    = NULL;
	m_nTomTom = BST_CHECKED;
}

AFXINLINE CTranNameDlg::~CTranNameDlg()
{
	TRACE(_T("Entering CTranNameDlg::~CTranNameDlg\n"));

	FreeIDL();
}

AFXINLINE BOOL CTranNameDlg::Browse(PTSTR pszPathName)
{
	TRACE(_T("Entering CTranNameDlg::Browse\n"));

	PITEMIDLIST pIDL;
	m_jTitleStc   = NULL;
	m_pszPathName = pszPathName;
	pIDL          = SHBrowseForFolder(this);
	if(!pIDL)
		return FALSE;

	FreeIDL();
	m_pIDL = pIDL;
	return TRUE;
}

AFXINLINE void CTranNameDlg::FreeIDL()
{
	TRACE(_T("Entering CTranNameDlg::FreeIDL\n"));

	CoTaskMemFree(m_pIDL);
}

// End of _CTRANNAMEDLG_INCLUDED_
#endif
