////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// MmSystem.hpp - Multimedia System Declaration File                                          //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _MMSYSTEM_INCLUDED_
#define _MMSYSTEM_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  MmSystem - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////
// Message maps

// An MCI device has completed an operation
#define ON_MM_MCINOTIFY(fName) \
	case MM_MCINOTIFY: \
		pWnd->fName(lParam, wParam); \
		return _eResult;

////////////////////////////////////////////////////////////////////////////////////////////////
// Sound functions

// Plays/stops a sound specified by the given file name, resource or system event
// Returns: TRUE if the sound is played/stoped
AFXINLINE BOOL WINAPI PlaySound(HMODULE hModule, UINT nSoundId, DWORD dwFlags)
{
	return VERIFY(PlaySound(MAKERESPTR(nSoundId), hModule, dwFlags));
}

AFXINLINE BOOL WINAPI PlaySound(PCVOID pvSound, DWORD dwFlags)
{
	return VERIFY(PlaySound((PCTSTR)pvSound, NULL, dwFlags));
}

AFXINLINE BOOL WINAPI StopSound(HMODULE hModule, UINT nSoundId = UNUSED)
{
	return VERIFY(PlaySound(MAKERESPTR(nSoundId), hModule, SND_PURGE | SND_RESOURCE));
}

AFXINLINE BOOL WINAPI StopSound(PCVOID pvSound = NULL, DWORD dwFlags = SND_PURGE)
{
	return VERIFY(PlaySound((PCTSTR)pvSound, NULL, dwFlags));
}

// End of _MMSYSTEM_INCLUDED_
#endif
