////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// OleDlg.hpp - OLE UI Dialog Boxes Declaration File                                          //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _OLEDLG_INCLUDED_
#define _OLEDLG_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  OleDlg - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////
// General purposes

// Gets the dialog procedure of a class object
// Returns: Address of the procedure
#define GetOleDialogProc(CName) ((LPFNOLEUIHOOK)CName::_WindowProc)

////////////////////////////////////////////////////////////////////////////////////////////////
// COleBusyDialog

// Only can be derived (cannot be instantiated)
class COleBusyDialog : public CDialog, public OLEUIBUSY
{
public:
	UINT OleUIBusy();

protected:
	COleBusyDialog();
};

AFXINLINE COleBusyDialog::COleBusyDialog()
{
	// Does nothing
}

AFXINLINE UINT COleBusyDialog::OleUIBusy()
{
	ASSERT(!_m_pWnd && (cbStruct == sizeof(OLEUIBUSY)) && ::IsValidPtr(lpfnHook));
	_m_pWnd = this;
	UINT nResult = ::OleUIBusy(this);
	ASSERT((nResult < OLEUI_ERR_STANDARDMIN) || (nResult > OLEUI_ERR_STANDARDMAX));
	return nResult;
}

// End of _OLEDLG_INCLUDED_
#endif
