////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// RichEdit.hpp - Rich Edit Control Class Declaration File                                    //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _RICHEDIT_INCLUDED_
#define _RICHEDIT_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  RichEdit - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////
// Custom data types

typedef const POINTL* PCPOINTL;

////////////////////////////////////////////////////////////////////////////////////////////////
// CRichEdit

// Window class name
#define WC_RICHEDIT RICHEDIT_CLASS

class CRichEdit : public CEdit
{
public:
	CRichEdit();
	CRichEdit(HWND hRichEdit);
	void operator =(HWND hRichEdit);
	DWORD CharFromPos(PCPOINTL pPoint) const;
	BOOL InitCtrl() const;
};

AFXINLINE CRichEdit::CRichEdit()
{
	// Does nothing
}

AFXINLINE CRichEdit::CRichEdit(HWND hRichEdit)
{
	m_hWnd = hRichEdit;
}

AFXINLINE void CRichEdit::operator =(HWND hRichEdit)
{
	m_hWnd = hRichEdit;
}

AFXINLINE DWORD CRichEdit::CharFromPos(PCPOINTL pPoint) const
{
	return ::SendMessage(m_hWnd, EM_CHARFROMPOS, UNUSED, (LPARAM)pPoint);
}

AFXINLINE BOOL CRichEdit::InitCtrl() const
{
	return (BOOL)VERIFY(::LoadLibrary(_T("RichEd32.dll")));
}

// End of _RICHEDIT_INCLUDED_
#endif
