////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// ShlApi.hpp - Shell Library Declaration File                                                //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _SHLAPI_INCLUDED_
#define _SHLAPI_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  ShlApi - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////
// Custom data types

// Pointers
typedef ITEMIDLIST* PITEMIDLIST;

////////////////////////////////////////////////////////////////////////////////////////////////
// Dialog control identifiers for Browse Folder dialog box

#define IDC_BFD_STATIC1   14146
#define IDC_BFD_STATIC2   14147
#define IDC_BFD_TREE_VIEW 14145

////////////////////////////////////////////////////////////////////////////////////////////////
// General macros and functions

// Gets the file name of dropped files
// Returns: Number of characters stored/required/count of the dropped files
AFXINLINE UINT WINAPI DragQueryFile(HDROP hDropFile, UINT nFile = MAX_UINT,
	PTSTR pszBuffer = NULL, UINT ccBuffer = UNUSED)
{
	return VERIFY(::DragQueryFile(hDropFile, nFile, pszBuffer, ccBuffer));
}

// End of _SHLAPI_INCLUDED_
#endif
