////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// WinSpool.hpp - Windows Printer Spooler Declaration File                                    //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _WINSPOOL_INCLUDED_
#define _WINSPOOL_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  WinSpool - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////
// General functions

// Enumerates available printers/Gets the size of buffer required
// Returns: TRUE if the function succeeds
AFXINLINE BOOL WINAPI EnumPrinters(DWORD dwFlags, DWORD dwLevel, PVOID pvInfo, DWORD cbInfo,
	PDWORD pcbInfo, PDWORD pceInfo)
{
	return VERIFY(EnumPrinters(dwFlags, NULL, dwLevel, (PBYTE)pvInfo, cbInfo,
		pcbInfo, pceInfo));
}

AFXINLINE void WINAPI EnumPrinters(DWORD dwFlags, PTSTR pszName, DWORD dwLevel, PDWORD pcbInfo)
{
	DWORD dwDummy;
	EnumPrinters(dwFlags, pszName, dwLevel, NULL, UNUSED, pcbInfo, &dwDummy);
}

AFXINLINE void WINAPI EnumPrinters(DWORD dwFlags, DWORD dwLevel, PDWORD pcbInfo)
{
	DWORD dwDummy;
	EnumPrinters(dwFlags, NULL, dwLevel, NULL, UNUSED, pcbInfo, &dwDummy);
}

// Opens a printer or print server
// Returns: TRUE if the function succeeds
AFXINLINE BOOL WINAPI OpenPrinter(PTSTR pszName, PHPRINTER phPrinter)
{
	return VERIFY(OpenPrinter(pszName, phPrinter, NULL));
}

AFXINLINE BOOL WINAPI OpenPrinter(PHPRINTER phPrinter, PPRINTER_DEFAULTS pPD = NULL)
{
	return VERIFY(OpenPrinter(NULL, phPrinter, pPD));
}

// End of _WINSPOOL_INCLUDED_
#endif
