////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// DirectX.cpp - DirectX Macros and Functions Implementation File                             //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>

// Entire file for debug version only
#ifdef DEBUG

////////////////////////////////////////////////////////////////////////////////////////////////
// Displays a message by a message box or into the debug window (used internally only)

HRESULT WINAPI _DXTRACE(PCSTR pszFileName, int iLine, HRESULT hResult, PCWSTR pszMsg,
	BOOL bMsgBox)
{
	char szMsg[MAX_STR];
	wsprintfA(szMsg, "%ls", pszMsg);
	return _DXTRACE(pszFileName, iLine, hResult, szMsg, bMsgBox);
}
HRESULT WINAPI _DXTRACE(PCSTR pszFileName, int iLine, HRESULT hResult, PCSTR pszMsg,
	BOOL bMsgBox)
{
	char szMsg[MAX_STR];
	wsprintfA(szMsg, "%hs hr=0x%08x", pszMsg, hResult);
	_DebugWarn(pszFileName, iLine, szMsg, FALSE);
	if(bMsgBox && _DebugError(pszFileName, iLine, pszMsg))
		_CrtDbgBreak();
	return hResult;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Determines whether a resulting value is succeeded (used internally only)

HRESULT WINAPI _DXVERIFY(PCSTR pszFileName, int iLine, HRESULT hResult, PCSTR pszMsg)
{
	if(FAILED(hResult))
	{
		char szMsg[MAX_STR];
		wsprintfA(szMsg, "DXVERIFY(%hs)", pszMsg);
		_DXTRACE(pszFileName, iLine, hResult, szMsg, TRUE);
	}
	return hResult;
}

// End of DEBUG
#endif
