////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// PreCtrl.cpp - Predefined Classes Implementation File                                       //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>

////////////////////////////////////////////////////////////////////////////////////////////////
// Gets object pointer to this control (used internally only)

CWnd* WINAPI CCustomCtrl::_GetObjectPtr(HWND hWnd)
{
	// Object pointer associated with this control
	CWnd* pWnd = (CWnd*)::GetWindowLong(hWnd, GWL_USERDATA);
	if(pWnd)
	{
		ASSERT(pWnd->m_hWnd == hWnd);
		return pWnd;
	}

	// Retrieves the object pointer from the message queue
	MSG  msg;
	UINT nCtrlId = ::GetDlgCtrlID(hWnd);
	while(TRUE)
	{
		VERIFY(::PeekMessage(&msg, (HWND)-1, _WM_CTMCTRL, _WM_CTMCTRL, PM_REMOVE));
		if(msg.wParam == nCtrlId)
			break;
		VERIFY(::PostMessage(NULL, _WM_CTMCTRL, msg.wParam, msg.lParam));
	}
	pWnd = (CWnd*)msg.lParam;
	ASSERT_WRITE(pWnd, _m_cbObject);
	pWnd->m_hWnd = hWnd;
	::SetWindowLong(hWnd, GWL_USERDATA, (LONG)pWnd);
	return pWnd;
}
