////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// WinSock.cpp - Windows Sockets Implementation File                                          //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinAfx.hpp>

////////////////////////////////////////////////////////////////////////////////////////////////
// Removes messages associated with a socket/task (used internally only)

void WINAPI _WSARemoveMessage(HWND hWnd, UINT nMsg, HSOCKET hSocket)
{
	MSG msg;
	msg.wParam = ~hSocket;
	msg.lParam = INVALID_VALUE;
	do
	{
		if(hSocket != msg.wParam)
			VERIFY(PostMessage(hWnd, nMsg, msg.wParam, msg.lParam));
		VERIFY(PeekMessage(&msg, hWnd, nMsg, nMsg, PM_REMOVE));
	}
	while(msg.lParam != INVALID_VALUE);
}
