////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// CommCtrl.hpp - Common Control Classes Declaration File                                     //
//                                                                                            //
// Copyright (c) 1988-2013, Softop Corporation                                                //
// All rights reserved                                                                        //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////

// Marks the file we have included
#ifndef _COMMCTRL_INCLUDED_
#define _COMMCTRL_INCLUDED_

// Framework header file should be included first
#ifndef _WINAFX_INCLUDED_
#error  CommCtrl - Framework header file <WinAfx.hpp> should be included first.
#endif

// Included only once by the compiler in a build
#pragma once

////////////////////////////////////////////////////////////////////////////////////////////////
// Control class names

#define WC_ANIMATE   ANIMATE_CLASS
#define WC_COMBOEX   WC_COMBOBOXEX
#define WC_DATETIME  DATETIMEPICK_CLASS
#define WC_HOTKEY    HOTKEY_CLASS
#define WC_MONTHCAL  MONTHCAL_CLASS
#define WC_PAGERCTRL WC_PAGESCROLLER
#define WC_PROGRESS  PROGRESS_CLASS
#define WC_REBAR     REBARCLASSNAME
#define WC_STATUSBAR STATUSCLASSNAME
#define WC_TABCTRL   WC_TABCONTROL
#define WC_TOOLBAR   TOOLBARCLASSNAME
#define WC_TOOLTIP   TOOLTIPS_CLASS
#define WC_TRACKBAR  TRACKBAR_CLASS
#define WC_UPDOWN    UPDOWN_CLASS

////////////////////////////////////////////////////////////////////////////////////////////////
// Custom data types

// Pointers
typedef HPROPSHEETPAGE             HPROPPAGE;
typedef PROPSHEETPAGE              PROPPAGE;
typedef PROPSHEETHEADER            PROPSHEET;
typedef COLORSCHEME*               PCOLORSCHEME;
typedef COMBOBOXEXITEM*            PCOMBOEXITEM;
typedef HDHITTESTINFO*             PHDHITTESTINFO;
typedef HDITEM*                    PHDITEM;
typedef HDLAYOUT*                  PHDLAYOUT;
typedef IMAGEINFO*                 PIMAGEINFO;
typedef IMAGELISTDRAWPARAMS*       PIMAGELISTDRAWPARAMS;
typedef INITCOMMONCONTROLSEX*      PINITCOMMONCONTROLSEX;
typedef LVBKIMAGE*                 PLVBKIMAGE;
typedef LVCOLUMN*                  PLVCOLUMN;
typedef LVHITTESTINFO*             PLVHITTESTINFO;
typedef LVITEM*                    PLVITEM;
typedef NMCOMBOBOXEX*              PNMCOMBOEX;
typedef NMCUSTOMDRAW*              PNMCUSTOMDRAW;
typedef NMDATETIMEFORMAT*          PNMDATETIMEFORMAT;
typedef NMDATETIMEFORMATQUERY*     PNMDATETIMEFORMATQUERY;
typedef NMDATETIMESTRING*          PNMDATETIMESTRING;
typedef NMDAYSTATE*                PNMDAYSTATE;
typedef NMHDDISPINFO*              PNMHDDISPINFO;
typedef NMIPADDRESS*               PNMIPADDRESS;
typedef NMLISTVIEW*                PNMLISTVIEW;
typedef NMLVCUSTOMDRAW*            PNMLVCUSTOMDRAW;
typedef NMLVDISPINFO*              PNMLVDISPINFO;
typedef NMLVGETINFOTIP*            PNMLVGETINFOTIP;
typedef NMOBJECTNOTIFY*            PNMOBJECTNOTIFY;
typedef NMPGCALCSIZE*              PNMPGCALCSIZE;
typedef NMPGSCROLL*                PNMPGSCROLL;
typedef NMREBARCHILDSIZE*          PNMREBARCHILDSIZE;
typedef NMTBCUSTOMDRAW*            PNMTBCUSTOMDRAW;
typedef NMTBDISPINFO*              PNMTBDISPINFO;
typedef NMTBGETINFOTIP*            PNMTBGETINFOTIP;
typedef NMTBRESTORE*               PNMTBRESTORE;
typedef NMTBSAVE*                  PNMTBSAVE;
typedef NMTOOLBAR*                 PNMTOOLBAR;
typedef NMTTCUSTOMDRAW*            PNMTTCUSTOMDRAW;
typedef NMTTDISPINFO*              PNMTTDISPINFO;
typedef NMTVDISPINFO*              PNMTVDISPINFO;
typedef NMTVGETINFOTIP*            PNMTVGETINFOTIP;
typedef PROPPAGE*                  PPROPPAGE;
typedef RBHITTESTINFO*             PRBHITTESTINFO;
typedef REBARBANDINFO*             PREBARBANDINFO;
typedef REBARINFO*                 PREBARINFO;
typedef TBBUTTONINFO*              PTBBUTTONINFO;
typedef TBINSERTMARK*              PTBINSERTMARK;
typedef TBMETRICS*                 PTBMETRICS;
typedef TCHITTESTINFO*             PTCHITTESTINFO;
typedef TCITEM*                    PTCITEM;
typedef TTHITTESTINFO*             PTTHITTESTINFO;
typedef TTTOOLINFO*                PTTTOOLINFO;
typedef TVHITTESTINFO*             PTVHITTESTINFO;
typedef TVITEM*                    PTVITEM;
typedef TVITEMEX*                  PTVITEMEX;
typedef UDACCEL*                   PUDACCEL;
typedef const COLORSCHEME*         PCCOLORSCHEME;
typedef const COMBOBOXEXITEM*      PCCOMBOEXITEM;
typedef const DRAGLISTINFO*        PCDRAGLISTINFO;
typedef const HDITEM*              PCHDITEM;
typedef const LVBKIMAGE*           PCLVBKIMAGE;
typedef const LVCOLUMN*            PCLVCOLUMN;
typedef const LVFINDINFO*          PCLVFINDINFO;
typedef const LVITEM*              PCLVITEM;
typedef const MONTHDAYSTATE*       PCMONTHDAYSTATE;
typedef const NMCBEDRAGBEGIN*      PCNMCBEDRAGBEGIN;
typedef const NMCBEENDEDIT*        PCNMCBEENDEDIT;
typedef const NMCHAR*              PCNMCHAR;
typedef const NMCOMBOBOXEX*        PCNMCOMBOEX;
typedef const NMCUSTOMDRAW*        PCNMCUSTOMDRAW;
typedef const NMDATETIMECHANGE*    PCNMDATETIMECHANGE;
typedef const NMDATETIMEWMKEYDOWN* PCNMDATETIMEWMKEYDOWN;
typedef const NMHEADER*            PCNMHEADER;
typedef const NMHDFILTERBTNCLICK*  PCNMHDFILTERBTNCLICK;
typedef const NMITEMACTIVATE*      PCNMITEMACTIVATE;
typedef const NMKEY*               PCNMKEY;
typedef const NMLISTVIEW*          PCNMLISTVIEW;
typedef const NMLVCACHEHINT*       PCNMLVCACHEHINT;
typedef const NMLVDISPINFO*        PCNMLVDISPINFO;
typedef const NMLVFINDITEM*        PCNMLVFINDITEM;
typedef const NMLVKEYDOWN*         PCNMLVKEYDOWN;
typedef const NMLVODSTATECHANGE*   PCNMLVODSTATECHANGE;
typedef const NMLVSCROLL*          PCNMLVSCROLL;
typedef const NMMOUSE*             PCNMMOUSE;
typedef const NMRBAUTOSIZE*        PCNMRBAUTOSIZE;
typedef const NMREBAR*             PCNMREBAR;
typedef const NMREBARCHEVRON*      PCNMREBARCHEVRON;
typedef const NMSELCHANGE*         PCNMSELCHANGE;
typedef const NMSELECT*            PCNMSELECT;
typedef const NMTBHOTITEM*         PCNMTBHOTITEM;
typedef const NMTCKEYDOWN*         PCNMTCKEYDOWN;
typedef const NMTOOLBAR*           PCNMTOOLBAR;
typedef const NMTOOLTIPSCREATED*   PCNMTOOLTIPSCREATED;
typedef const NMTREEVIEW*          PCNMTREEVIEW;
typedef const NMTVCUSTOMDRAW*      PCNMTVCUSTOMDRAW;
typedef const NMTVDISPINFO*        PCNMTVDISPINFO;
typedef const NMTVKEYDOWN*         PCNMTVKEYDOWN;
typedef const NMUPDOWN*            PCNMUPDOWN;
typedef const PROPPAGE*            PCPROPPAGE;
typedef const PROPSHEET*           PCPROPSHEET;
typedef const PSHNOTIFY*           PCPSHNOTIFY;
typedef const REBARBANDINFO*       PCREBARBANDINFO;
typedef const REBARINFO*           PCREBARINFO;
typedef const TBADDBITMAP*         PCTBADDBITMAP;
typedef const TBBUTTON*            PCTBBUTTON;
typedef const TBBUTTONINFO*        PCTBBUTTONINFO;
typedef const TBINSERTMARK*        PCTBINSERTMARK;
typedef const TBMETRICS*           PCTBMETRICS;
typedef const TBREPLACEBITMAP*     PCTBREPLACEBITMAP;
typedef const TBSAVEPARAMS*        PCTBSAVEPARAMS;
typedef const TCITEM*              PCTCITEM;
typedef const TTTOOLINFO*          PCTTTOOLINFO;
typedef const TVINSERTSTRUCT*      PCTVINSERTSTRUCT;
typedef const TVITEM*              PCTVITEM;
typedef const TVITEMEX*            PCTVITEMEX;
typedef const TVSORTCB*            PCTVSORTCB;
typedef const UDACCEL*             PCUDACCEL;

// Comparison function for CListView::SortItems
typedef int (CALLBACK* PLVCOMPARE)(int, int, LPARAM);

// Static
#define SIMAGELISTDRAWPARAMS static IMAGELISTDRAWPARAMS

////////////////////////////////////////////////////////////////////////////////////////////////
// General functions

AFXINLINE BOOL WINAPI InitCommonControls(PINITCOMMONCONTROLSEX pICCX)
{
	return VERIFY(InitCommonControlsEx(pICCX));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// General notification messages

#define ON_NM_CHAR(fName)            _ON_NOTIFY_R(NM_CHAR, fName, PCNMCHAR)
#define ON_NM_CLICK(fName)           _ON_NOTIFY_R(NM_CLICK, fName, PCNMHDR)

// A control is about to be drawn
// UINT OnNmCustomDraw(PCNMCUSTOMDRAW pNMCD);
// Returns: Result value of the message processed
#define ON_NM_CUSTOMDRAW(fName) _ON_NOTIFY_R(NM_CUSTOMDRAW, fName, PCNMCUSTOMDRAW)

#define ON_NM_DBLCLK(fName)          _ON_NOTIFY_R(NM_DBLCLK, fName, PCNMHDR)
#define ON_NM_HOVER(fName)           _ON_NOTIFY_R(NM_HOVER, fName, PCNMHDR)
#define ON_NM_KEYDOWN(fName)         _ON_NOTIFY_R(NM_KEYDOWN, fName, PCNMKEY)
#define ON_NM_KILLFOCUS(fName)       _ON_NOTIFY_V(NM_KILLFOCUS, fName, PCNMHDR)
#define ON_NM_LDOWN(fName)           _ON_NOTIFY_V(NM_LDOWN, fName, PCNMHDR)
#define ON_NM_NCHITTEST(fName)       _ON_NOTIFY_R(NM_NCHITTEST, fName, PCNMMOUSE)
#define ON_NM_OUTOFMEMORY(fName)     _ON_NOTIFY_V(NM_OUTOFMEMORY, fName, PCNMHDR)
#define ON_NM_RCLICK(fName)          _ON_NOTIFY_R(NM_RCLICK, fName, PCNMHDR)
#define ON_NM_RDBLCLK(fName)         _ON_NOTIFY_R(NM_RDBLCLK, fName, PCNMHDR)
#define ON_NM_RELEASEDCAPTURE(fName) _ON_NOTIFY_V(NM_RELEASEDCAPTURE, fName, PCNMHDR)
#define ON_NM_RETURN(fName)          _ON_NOTIFY_R(NM_RETURN, fName, PCNMHDR)
#define ON_NM_SETCURSOR(fName)       _ON_NOTIFY_R(NM_SETCURSOR, fName, PCNMMOUSE)
#define ON_NM_SETFOCUS(fName)        _ON_NOTIFY_V(NM_SETFOCUS, fName, PCNMHDR)
#define ON_NM_TOOLTIPSCREATED(fName) \
	_ON_NOTIFY_V(NM_TOOLTIPSCREATED, fName, PCNMTOOLTIPSCREATED)

////////////////////////////////////////////////////////////////////////////////////////////////
// CAnimate

#define ON_ACN_START(fName) _ON_CONTROL_NOTIFY(ACN_START, fName)
#define ON_ACN_STOP(fName)  _ON_CONTROL_NOTIFY(ACN_STOP, fName)

class CAnimate : public CWnd
{
public:
	CAnimate();
	CAnimate(HWND hAnimate);
	void operator =(HWND hAnimate);
	BOOL Close() const;
	BOOL CreateWindow(DWORD dwStyle, HWND hParentWnd, UINT nAnimateId);
	BOOL Open(HINSTANCE hInstance, UINT nNameId) const;
	BOOL Open(UINT nNameId) const;
	BOOL Open(PCTSTR pszName) const;
	BOOL Play(UINT nFrom = 0, UINT nTo = MAX_UINT, UINT nRepeat = MAX_UINT) const;
	BOOL Seek(UINT nFrame) const;
	BOOL Stop() const;
};

AFXINLINE CAnimate::CAnimate()
{
	// Does nothing
}

AFXINLINE CAnimate::CAnimate(HWND hAnimate)
{
	m_hWnd = hAnimate;
}

AFXINLINE void CAnimate::operator =(HWND hAnimate)
{
	m_hWnd = hAnimate;
}

AFXINLINE BOOL CAnimate::Close() const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_OPEN, UNUSED, UNUSED));
}

AFXINLINE BOOL CAnimate::CreateWindow(DWORD dwStyle, HWND hParentWnd, UINT nAnimateId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_ANIMATE, NULL, dwStyle,
		0, 0, 0, 0, hParentWnd, (HMENU)nAnimateId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CAnimate::Open(HINSTANCE hInstance, UINT nNameId) const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_OPEN, (WPARAM)hInstance, nNameId));
}

AFXINLINE BOOL CAnimate::Open(UINT nNameId) const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_OPEN, UNUSED, nNameId));
}

AFXINLINE BOOL CAnimate::Open(PCTSTR pszName) const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_OPEN, UNUSED, (LPARAM)pszName));
}

AFXINLINE BOOL CAnimate::Play(UINT nFrom /* = 0 */, UINT nTo /* = MAX_UINT */,
	UINT nRepeat /* = MAX_UINT */) const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_PLAY, nRepeat, MAKELPARAM(nFrom, nTo)));
}

AFXINLINE BOOL CAnimate::Seek(UINT nFrame) const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_PLAY, 1, MAKELPARAM(nFrame, nFrame)));
}

AFXINLINE BOOL CAnimate::Stop() const
{
	return VERIFY(::SendMessage(m_hWnd, ACM_STOP, UNUSED, UNUSED));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CComboEx

#define ON_CBEN_BEGINEDIT(fName)   _ON_NOTIFY_V(CBEN_BEGINEDIT, fName, PCNMHDR)
#define ON_CBEN_DELETEITEM(fName)  _ON_NOTIFY_V(CBEN_DELETEITEM, fName, PCNMCOMBOEX)
#define ON_CBEN_DRAGBEGIN(fName)   _ON_NOTIFY_V(CBEN_DRAGBEGIN, fName, PCNMCBEDRAGBEGIN)
#define ON_CBEN_ENDEDIT(fName)     _ON_NOTIFY_R(CBEN_ENDEDIT, fName, PCNMCBEENDEDIT)
#define ON_CBEN_GETDISPINFO(fName) _ON_NOTIFY_V(CBEN_GETDISPINFO, fName, PNMCOMBOEX)
#define ON_CBEN_INSERTITEM(fName)  _ON_NOTIFY_V(CBEN_INSERTITEM, fName, PCNMCOMBOEX)

class CComboEx : public CComboBox
{
public:
	CComboEx();
	CComboEx(HWND hComboEx);
	void operator =(HWND hComboEx);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nComboExId);
	int DeleteItem(int iItem) const;
	HWND GetComboCtrl() const;
	HWND GetEditCtrl() const;
	DWORD GetExStyle() const;
	HIMAGELIST GetImageList() const;
	BOOL GetItem(PCOMBOEXITEM pCXI) const;
	BOOL GetUnicodeFormat() const;
	int InsertItem(PCCOMBOEXITEM pCXI) const;
	BOOL IsEditChanged() const;
	DWORD SetExStyle(DWORD dwStyle, DWORD dwMask = UNUSED) const;
	HIMAGELIST SetImageList(HIMAGELIST hImageList) const;
	BOOL SetItem(PCCOMBOEXITEM pCXI) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
};

AFXINLINE CComboEx::CComboEx()
{
	// Does nothing
}

AFXINLINE CComboEx::CComboEx(HWND hComboEx)
{
	m_hWnd = hComboEx;
}

AFXINLINE void CComboEx::operator =(HWND hComboEx)
{
	m_hWnd = hComboEx;
}

AFXINLINE BOOL CComboEx::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nComboExId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_COMBOEX, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nComboExId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE int CComboEx::DeleteItem(int iItem) const
{
	return UNEQUAL(::SendMessage(m_hWnd, CBEM_DELETEITEM, iItem, UNUSED), CB_ERR);
}

AFXINLINE HWND CComboEx::GetComboCtrl() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, CBEM_GETCOMBOCONTROL, UNUSED, UNUSED));
}

AFXINLINE HWND CComboEx::GetEditCtrl() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, CBEM_GETEDITCONTROL, UNUSED, UNUSED));
}

AFXINLINE DWORD CComboEx::GetExStyle() const
{
	return ::SendMessage(m_hWnd, CBEM_GETEXTENDEDSTYLE, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CComboEx::GetImageList() const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, CBEM_GETIMAGELIST, UNUSED, UNUSED));
}

AFXINLINE BOOL CComboEx::GetItem(PCOMBOEXITEM pCXI) const
{
	return VERIFY(::SendMessage(m_hWnd, CBEM_GETITEM, UNUSED, (LPARAM)pCXI));
}

AFXINLINE BOOL CComboEx::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, CBEM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE int CComboEx::InsertItem(PCCOMBOEXITEM pCXI) const
{
	return UNEQUAL(::SendMessage(m_hWnd, CBEM_INSERTITEM, UNUSED, (LPARAM)pCXI), RV_ERR);
}

AFXINLINE BOOL CComboEx::IsEditChanged() const
{
	return ::SendMessage(m_hWnd, CBEM_HASEDITCHANGED, UNUSED, UNUSED);
}

AFXINLINE DWORD CComboEx::SetExStyle(DWORD dwStyle, DWORD dwMask /* = UNUSED */) const
{
	return ::SendMessage(m_hWnd, CBEM_SETEXTENDEDSTYLE, dwMask, dwStyle);
}

AFXINLINE HIMAGELIST CComboEx::SetImageList(HIMAGELIST hImageList) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, CBEM_SETIMAGELIST, UNUSED, (LPARAM)hImageList);
}

AFXINLINE BOOL CComboEx::SetItem(PCCOMBOEXITEM pCXI) const
{
	return VERIFY(::SendMessage(m_hWnd, CBEM_SETITEM, UNUSED, (LPARAM)pCXI));
}

AFXINLINE BOOL CComboEx::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, CBEM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CDateTime

#define ON_DTN_CLOSEUP(fName)        _ON_NOTIFY_V(DTN_CLOSEUP, fName, PCNMHDR)
#define ON_DTN_DATETIMECHANGE(fName) _ON_NOTIFY_V(DTN_DATETIMECHANGE, fName, PCNMDATETIMECHANGE)
#define ON_DTN_DROPDOWN(fName)    _ON_NOTIFY_V(DTN_DROPDOWN, fName, PCNMHDR)
#define ON_DTN_FORMAT(fName)      _ON_NOTIFY_V(DTN_FORMAT, fName, PNMDATETIMEFORMAT)
#define ON_DTN_FORMATQUERY(fName) _ON_NOTIFY_V(DTN_FORMATQUERY, fName, PNMDATETIMEFORMATQUERY)
#define ON_DTN_USERSTRING(fName)  _ON_NOTIFY_V(DTN_USERSTRING, fName, PNMDATETIMESTRING)
#define ON_DTN_WMKEYDOWN(fName)   _ON_NOTIFY_V(DTN_WMKEYDOWN, fName, PCNMDATETIMEWMKEYDOWN)

class CDateTime : public CWnd
{
public:
	CDateTime();
	CDateTime(HWND hDateTime);
	void operator =(HWND hDateTime);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nDateTimeId);
	COLORREF GetMcColor(UINT nPortion) const;
	HFONT GetMcFont() const;
	HWND GetMonthCal() const;
	UINT GetRange(PSYSTEMTIME paST) const;
	int GetSystemTime(PSYSTEMTIME pST) const;
	BOOL SetFormat(PCTSTR pszFormat = NULL) const;
	COLORREF SetMcColor(COLORREF crValue, UINT nPortion) const;
	void SetMcFont(HFONT hFont, BOOL bRedraw = TRUE) const;
	BOOL SetRange(PCSYSTEMTIME paST, UINT nFlags) const;
	BOOL SetSystemTime(UINT nFlag, PCSYSTEMTIME pST = NULL) const;
};

AFXINLINE CDateTime::CDateTime()
{
	// Does nothing
}

AFXINLINE CDateTime::CDateTime(HWND hDateTime)
{
	m_hWnd = hDateTime;
}

AFXINLINE void CDateTime::operator =(HWND hDateTime)
{
	m_hWnd = hDateTime;
}

AFXINLINE BOOL CDateTime::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nDateTimeId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_DATETIME, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nDateTimeId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE COLORREF CDateTime::GetMcColor(UINT nPortion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, DTM_GETMCCOLOR, nPortion, UNUSED), RV_ERR);
}

AFXINLINE HFONT CDateTime::GetMcFont() const
{
	return (HFONT)::SendMessage(m_hWnd, DTM_GETMCFONT, UNUSED, UNUSED);
}

AFXINLINE HWND CDateTime::GetMonthCal() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, DTM_GETMONTHCAL, UNUSED, UNUSED));
}

AFXINLINE UINT CDateTime::GetRange(PSYSTEMTIME paST) const
{
	return ::SendMessage(m_hWnd, DTM_GETRANGE, UNUSED, (LPARAM)paST);
}

AFXINLINE int CDateTime::GetSystemTime(PSYSTEMTIME pST) const
{
	return UNEQUAL(::SendMessage(m_hWnd, DTM_GETSYSTEMTIME, UNUSED, (LPARAM)pST), GDT_ERROR);
}

AFXINLINE BOOL CDateTime::SetFormat(PCTSTR pszFormat /* = NULL */) const
{
	return VERIFY(::SendMessage(m_hWnd, DTM_SETFORMAT, UNUSED, (LPARAM)pszFormat));
}

AFXINLINE COLORREF CDateTime::SetMcColor(COLORREF crValue, UINT nPortion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, DTM_SETMCCOLOR, nPortion, crValue), GDT_ERROR);
}

AFXINLINE void CDateTime::SetMcFont(HFONT hFont, BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, DTM_SETMCFONT, (WPARAM)hFont, bRedraw);
}

AFXINLINE BOOL CDateTime::SetRange(PCSYSTEMTIME paST, UINT nFlags) const
{
	return VERIFY(::SendMessage(m_hWnd, DTM_SETRANGE, nFlags, (LPARAM)paST));
}

AFXINLINE BOOL CDateTime::SetSystemTime(UINT nFlag, PCSYSTEMTIME pST /* = NULL */) const
{
	return VERIFY(::SendMessage(m_hWnd, DTM_SETSYSTEMTIME, nFlag, (LPARAM)pST));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CDragList

// Notification message of drag list box
// Returns: Result value of the message processed
#define ON_DLM_NOTIFY(nRegMsg, fName) \
	_ON_WM_REGISTER_R(nRegMsg, fName, (wParam, (PCDRAGLISTINFO)lParam))

class CDragList : public CListBox
{
public:
	// Registered message
	UINT m_nRegMsg;

public:
	CDragList();
	CDragList(HWND hDragList);
	void operator =(HWND hDragList);
	void DrawInsert(HWND hParentWnd, int iItem) const;
	int ItemFromPt(POINT ptScreen, BOOL bAutoScroll = TRUE) const;
	BOOL MakeDragList() const;
	BOOL RegisterMessage();
	void RemoveInsert(HWND hParentWnd) const;
};

AFXINLINE CDragList::CDragList()
{
	// Does nothing
}

AFXINLINE CDragList::CDragList(HWND hDragList)
{
	m_hWnd = hDragList;
}

AFXINLINE void CDragList::operator =(HWND hDragList)
{
	m_hWnd = hDragList;
}

AFXINLINE void CDragList::DrawInsert(HWND hParentWnd, int iItem) const
{
	::DrawInsert(hParentWnd, m_hWnd, iItem);
}

AFXINLINE int CDragList::ItemFromPt(POINT ptScreen, BOOL bAutoScroll /* = TRUE */) const
{
	return ::LBItemFromPt(m_hWnd, ptScreen, bAutoScroll);
}

AFXINLINE BOOL CDragList::MakeDragList() const
{
	return VERIFY(::MakeDragList(m_hWnd));
}

AFXINLINE BOOL CDragList::RegisterMessage()
{
	m_nRegMsg = ::RegisterWindowMessage(DRAGLISTMSGSTRING);
	return VERIFY(m_nRegMsg);
}

AFXINLINE void CDragList::RemoveInsert(HWND hParentWnd) const
{
	::DrawInsert(hParentWnd, m_hWnd, -1);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CHeader

#define ON_HDN_BEGINDRAG(fName)       _ON_NOTIFY_R(HDN_BEGINDRAG, fName, PCNMHEADER)
#define ON_HDN_BEGINTRACK(fName)      _ON_NOTIFY_R(HDN_BEGINTRACK, fName, PCNMHEADER)
#define ON_HDN_DIVIDERDBLCLICK(fName) _ON_NOTIFY_V(HDN_DIVIDERDBLCLICK, fName, PCNMHEADER)
#define ON_HDN_ENDDRAG(fName)         _ON_NOTIFY_R(HDN_ENDDRAG, fName, PCNMHEADER)
#define ON_HDN_ENDTRACK(fName)        _ON_NOTIFY_V(HDN_ENDTRACK, fName, PCNMHEADER)
#define ON_HDN_FILTERBTNCLICK(fName) \
	_ON_NOTIFY_R(HDN_FILTERBTNCLICK, fName, PCNMHDFILTERBTNCLICK)
#define ON_HDN_FILTERCHANGE(fName) _ON_NOTIFY_V(HDN_FILTERCHANGE, fName, PCNMHEADER)
#define ON_HDN_GETDISPINFO(fName)  _ON_NOTIFY_V(HDN_GETDISPINFO, fName, PNMHDDISPINFO)
#define ON_HDN_ITEMCHANGED(fName)  _ON_NOTIFY_V(HDN_ITEMCHANGED, fName, PCNMHEADER)
#define ON_HDN_ITEMCHANGING(fName) _ON_NOTIFY_R(HDN_ITEMCHANGING, fName, PCNMHEADER)
#define ON_HDN_ITEMCLICK(fName)    _ON_NOTIFY_V(HDN_ITEMCLICK, fName, PCNMHEADER)
#define ON_HDN_ITEMDBLCLICK(fName) _ON_NOTIFY_V(HDN_ITEMDBLCLICK, fName, PCNMHEADER)
#define ON_HDN_TRACK(fName)        _ON_NOTIFY_R(HDN_TRACK, fName, PCNMHEADER)

class CHeader : public CWnd
{
public:
	CHeader();
	CHeader(HWND hHeader);
	void operator =(HWND hHeader);
	int AppendItem(PCHDITEM pHI) const;
	int ClearFilter(int iColumn = -1) const;
	HIMAGELIST CreateDragImage(int iItem) const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nHeaderId);
	BOOL DeleteItem(int iItem) const;
	int EditFilter(int iColumn, BOOL bDiscard = FALSE) const;
	int GetBitmapMargin() const;
	HIMAGELIST GetImageList() const;
	BOOL GetItem(int iItem, PHDITEM pHI) const;
	int GetItemCount() const;
	int GetItemIndex(int iOrder) const;
	BOOL GetItemOrder(PINT piaItem, int ceItem) const;
	BOOL GetItemRect(int iItem, PRECT pRect) const;
	BOOL GetUnicodeFormat() const;
	int HitTest(PHDHITTESTINFO pHHTI) const;
	int InsertItem(PCHDITEM pHI, int iItem = 0) const;
	BOOL Layout(PHDLAYOUT pHL) const;
	int SetBitmapMargin(int iWidth) const;
	int SetFilterChangeTimeout(int iInterval) const;
	int SetHotDivider(DWORD dwData = MAX_DWORD, BOOL bPosition = FALSE) const;
	HIMAGELIST SetImageList(HIMAGELIST hImageList) const;
	BOOL SetItem(int iItem, PCHDITEM pHI) const;
	BOOL SetItemOrder(PCINT piaItem, int ceItem) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
};

AFXINLINE CHeader::CHeader()
{
	// Does nothing
}

AFXINLINE CHeader::CHeader(HWND hHeader)
{
	m_hWnd = hHeader;
}

AFXINLINE void CHeader::operator =(HWND hHeader)
{
	m_hWnd = hHeader;
}

AFXINLINE int CHeader::AppendItem(PCHDITEM pHI) const
{
	return UNEQUAL(::SendMessage(m_hWnd, HDM_INSERTITEM, MAX_INT, (LPARAM)pHI), RV_ERR);
}

AFXINLINE int CHeader::ClearFilter(int iColumn /* = -1 */) const
{
	return ::SendMessage(m_hWnd, HDM_CLEARFILTER, iColumn, UNUSED);
}

AFXINLINE HIMAGELIST CHeader::CreateDragImage(int iItem) const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, HDM_CREATEDRAGIMAGE, iItem, UNUSED));
}

AFXINLINE BOOL CHeader::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nHeaderId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_HEADER, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nHeaderId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CHeader::DeleteItem(int iItem) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_DELETEITEM, iItem, UNUSED));
}

AFXINLINE int CHeader::EditFilter(int iColumn, BOOL bDiscard /* = FALSE */) const
{
	return ::SendMessage(m_hWnd, HDM_EDITFILTER, iColumn, bDiscard);
}

AFXINLINE int CHeader::GetBitmapMargin() const
{
	return ::SendMessage(m_hWnd, HDM_GETBITMAPMARGIN, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CHeader::GetImageList() const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, HDM_GETIMAGELIST, UNUSED, UNUSED));
}

AFXINLINE BOOL CHeader::GetItem(int iItem, PHDITEM pHI) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_GETITEM, iItem, (LPARAM)pHI));
}

AFXINLINE int CHeader::GetItemCount() const
{
	return UNEQUAL(::SendMessage(m_hWnd, HDM_GETITEMCOUNT, UNUSED, UNUSED), RV_ERR);
}

AFXINLINE int CHeader::GetItemIndex(int iOrder) const
{
	return ::SendMessage(m_hWnd, HDM_ORDERTOINDEX, iOrder, UNUSED);
}

AFXINLINE BOOL CHeader::GetItemOrder(PINT piaItem, int ceItem) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_GETORDERARRAY, ceItem, (LPARAM)piaItem));
}

AFXINLINE BOOL CHeader::GetItemRect(int iItem, PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_GETITEMRECT, iItem, (LPARAM)pRect));
}

AFXINLINE BOOL CHeader::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, HDM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE int CHeader::HitTest(PHDHITTESTINFO pHHTI) const
{
	return ::SendMessage(m_hWnd, HDM_HITTEST, UNUSED, (LPARAM)pHHTI);
}

AFXINLINE int CHeader::InsertItem(PCHDITEM pHI, int iItem /* = 0 */) const
{
	return UNEQUAL(::SendMessage(m_hWnd, HDM_INSERTITEM, iItem, (LPARAM)pHI), RV_ERR);
}

AFXINLINE BOOL CHeader::Layout(PHDLAYOUT pHL) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_LAYOUT, UNUSED, (LPARAM)pHL));
}

AFXINLINE int CHeader::SetBitmapMargin(int iWidth) const
{
	return ::SendMessage(m_hWnd, HDM_SETBITMAPMARGIN, iWidth, UNUSED);
}

AFXINLINE int CHeader::SetFilterChangeTimeout(int iInterval) const
{
	return ::SendMessage(m_hWnd, HDM_SETFILTERCHANGETIMEOUT, UNUSED, iInterval);
}

AFXINLINE int CHeader::SetHotDivider(DWORD dwData /* = MAX_DWORD */,
	BOOL bPosition /* = FALSE */) const
{
	return ::SendMessage(m_hWnd, HDM_SETHOTDIVIDER, bPosition, dwData);
}

AFXINLINE HIMAGELIST CHeader::SetImageList(HIMAGELIST hImageList) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, HDM_SETIMAGELIST, UNUSED, (LPARAM)hImageList);
}

AFXINLINE BOOL CHeader::SetItem(int iItem, PCHDITEM pHI) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_SETITEM, iItem, (LPARAM)pHI));
}

AFXINLINE BOOL CHeader::SetItemOrder(PCINT piaItem, int ceItem) const
{
	return VERIFY(::SendMessage(m_hWnd, HDM_SETORDERARRAY, ceItem, (LPARAM)piaItem));
}

AFXINLINE BOOL CHeader::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, HDM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CHotKey

class CHotKey : public CWnd
{
public:
	CHotKey();
	CHotKey(HWND hHotKey);
	void operator =(HWND hHotKey);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nHotKeyId);
	WORD GetHotKey() const;
	void SetHotKey(BYTE byVirtKey, BYTE byMods) const;
	void SetRules(UINT nInvCombs, UINT nDefCombs) const;
};

AFXINLINE CHotKey::CHotKey()
{
	// Does nothing
}

AFXINLINE CHotKey::CHotKey(HWND hHotKey)
{
	m_hWnd = hHotKey;
}

AFXINLINE void CHotKey::operator =(HWND hHotKey)
{
	m_hWnd = hHotKey;
}

AFXINLINE BOOL CHotKey::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nHotKeyId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_HOTKEY, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nHotKeyId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE WORD CHotKey::GetHotKey() const
{
	return (WORD)::SendMessage(m_hWnd, HKM_GETHOTKEY, UNUSED, UNUSED);
}

AFXINLINE void CHotKey::SetHotKey(BYTE byVirtKey, BYTE byMods) const
{
	::SendMessage(m_hWnd, HKM_SETHOTKEY, MAKEWORD(byVirtKey, byMods), UNUSED);
}

AFXINLINE void CHotKey::SetRules(UINT nInvCombs, UINT nDefCombs) const
{
	::SendMessage(m_hWnd, HKM_SETRULES, nInvCombs, nDefCombs);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CImageList

class CImageList
{
public:
	// Image list handle
	HIMAGELIST m_hImageList;

public:
	CImageList();
	CImageList(HIMAGELIST hImageList);
	operator HIMAGELIST() const;
	void operator =(HIMAGELIST hImageList);
	int Add(HBITMAP hImageBmp, HBITMAP hMaskBmp = NULL) const;
	int Add(HICON hIcon) const;
	int AddMasked(HBITMAP hBitmap, COLORREF crMask) const;
	BOOL BeginDrag(int iImage, int xHotspot, int yHotspot) const;
	BOOL Copy(int iDestImage, int iSrcImage, UINT nFlag) const;
	BOOL Create(int iWidth, int iHeight, UINT nFlags, int ceImage, int ceGrow = UNUSED);
	BOOL Destroy() const;
	BOOL Draw(int iImage, HDC hDC, int x, int y, UINT nStyle, COLORREF crBkgnd,
		COLORREF crForegnd, int iWidth = UNUSED, int iHeight = UNUSED) const;
	BOOL Draw(int iImage, HDC hDC, int x, int y, UINT nStyle) const;
	HIMAGELIST Duplicate() const;
	COLORREF GetBkColor() const;
	BOOL GetDragImage(PPOINT pptDrag = NULL, PPOINT pptHotspot = NULL);
	HICON GetIcon(int iImage, UINT nStyle = ILD_NORMAL) const;
	int GetImageCount() const;
	BOOL GetImageInfo(int iImage, PIMAGEINFO pII) const;
	BOOL GetImageSize(PINT piWidth, PINT piHeight) const;
	BOOL LoadImage(HINSTANCE hInstance, PCTSTR pszName, int iWidth, int ceGrow, COLORREF crMask,
		UINT nType, UINT nFlags = LR_DEFAULTCOLOR);
	BOOL LoadImage(HINSTANCE hInstance, UINT nNameId, int iWidth, int ceGrow, COLORREF crMask,
		UINT nType, UINT nFlags = LR_DEFAULTCOLOR);
	HIMAGELIST Merge(int iImage1, HIMAGELIST hIml2, int iImage2, int cxOffset,
		int cyOffset) const;
	BOOL Read(IStream* pStm);
	BOOL Remove(int iImage) const;
	BOOL RemoveAll() const;
	BOOL Replace(int iImage, HBITMAP hImageBmp, HBITMAP hMaskBmp = NULL) const;
	int Replace(int iImage, HICON hIcon) const;
	COLORREF SetBkColor(COLORREF crValue) const;
	BOOL SetDragImage(int iImage, int xHotspot, int yHotspot) const;
	BOOL SetImageCount(UINT ceImage) const;
	BOOL SetImageSize(int cxImage, int cyImage) const;
	BOOL SetOverlayImage(int iImage, int iOverlay) const;
	BOOL Write(IStream* pStm) const;
};

AFXINLINE CImageList::CImageList()
{
	// Does nothing
}

AFXINLINE CImageList::CImageList(HIMAGELIST hImageList)
{
	m_hImageList = hImageList;
}

AFXINLINE CImageList::operator HIMAGELIST() const
{
	return m_hImageList;
}

AFXINLINE void CImageList::operator =(HIMAGELIST hImageList)
{
	m_hImageList = hImageList;
}

AFXINLINE int CImageList::Add(HBITMAP hImageBmp, HBITMAP hMaskBmp /* = NULL */) const
{
	return UNEQUAL(::ImageList_Add(m_hImageList, hImageBmp, hMaskBmp), RV_ERR);
}

AFXINLINE int CImageList::Add(HICON hIcon) const
{
	return UNEQUAL(::ImageList_ReplaceIcon(m_hImageList, -1, hIcon), RV_ERR);
}

AFXINLINE int CImageList::AddMasked(HBITMAP hBitmap, COLORREF crMask) const
{
	return UNEQUAL(::ImageList_AddMasked(m_hImageList, hBitmap, crMask), RV_ERR);
}

AFXINLINE BOOL CImageList::BeginDrag(int iImage, int xHotspot, int yHotspot) const
{
	return VERIFY(::ImageList_BeginDrag(m_hImageList, iImage, xHotspot, yHotspot));
}

AFXINLINE BOOL CImageList::Copy(int iDestImage, int iSrcImage, UINT nFlag) const
{
	return VERIFY(::ImageList_Copy(m_hImageList, iDestImage, m_hImageList, iSrcImage, nFlag));
}

AFXINLINE BOOL CImageList::Create(int iWidth, int iHeight, UINT nFlags,
	int ceImage, int ceGrow /* = UNUSED */)
{
	m_hImageList = ::ImageList_Create(iWidth, iHeight, nFlags, ceImage, ceGrow);
	return (BOOL)VERIFY(m_hImageList);
}

AFXINLINE BOOL CImageList::Destroy() const
{
	return VERIFY(::ImageList_Destroy(m_hImageList));
}

AFXINLINE BOOL CImageList::Draw(int iImage, HDC hDC, int x, int y, UINT nStyle,
	COLORREF crBkgnd, COLORREF crForegnd,
	int iWidth /* = UNUSED */, int iHeight /* = UNUSED */) const
{
	return VERIFY(::ImageList_DrawEx(m_hImageList, iImage, hDC, x, y,
		iWidth, iHeight, crBkgnd, crForegnd, nStyle));
}

AFXINLINE BOOL CImageList::Draw(int iImage, HDC hDC, int x, int y, UINT nStyle) const
{
	return VERIFY(::ImageList_Draw(m_hImageList, iImage, hDC, x, y, nStyle));
}

AFXINLINE HIMAGELIST CImageList::Duplicate() const
{
	return (HIMAGELIST)VERIFY(::ImageList_Duplicate(m_hImageList));
}

AFXINLINE COLORREF CImageList::GetBkColor() const
{
	return ::ImageList_GetBkColor(m_hImageList);
}

AFXINLINE BOOL CImageList::GetDragImage(PPOINT pptDrag /* = NULL */,
	PPOINT pptHotspot /* = NULL */)
{
	m_hImageList = ::ImageList_GetDragImage(pptDrag, pptHotspot);
	return (BOOL)VERIFY(m_hImageList);
}

AFXINLINE HICON CImageList::GetIcon(int iImage, UINT nStyle /* = ILD_NORMAL */) const
{
	return (HICON)VERIFY(::ImageList_GetIcon(m_hImageList, iImage, nStyle));
}

AFXINLINE int CImageList::GetImageCount() const
{
	return ::ImageList_GetImageCount(m_hImageList);
}

AFXINLINE BOOL CImageList::GetImageInfo(int iImage, PIMAGEINFO pII) const
{
	return VERIFY(::ImageList_GetImageInfo(m_hImageList, iImage, pII));
}

AFXINLINE BOOL CImageList::GetImageSize(PINT piWidth, PINT piHeight) const
{
	return VERIFY(::ImageList_GetIconSize(m_hImageList, piWidth, piHeight));
}

AFXINLINE BOOL CImageList::LoadImage(HINSTANCE hInstance, PCTSTR pszName, int iWidth,
	int ceGrow, COLORREF crMask, UINT nType, UINT nFlags /* = LR_DEFAULTCOLOR */)
{
	m_hImageList = ::ImageList_LoadImage(hInstance, pszName, iWidth,
		ceGrow, crMask, nType, nFlags);
	return (BOOL)VERIFY(m_hImageList);
}

AFXINLINE BOOL CImageList::LoadImage(HINSTANCE hInstance, UINT nNameId, int iWidth,
	int ceGrow, COLORREF crMask, UINT nType, UINT nFlags /* = LR_DEFAULTCOLOR */)
{
	m_hImageList = ::ImageList_LoadImage(hInstance, MAKERESPTR(nNameId), iWidth,
		ceGrow, crMask, nType, nFlags);
	return (BOOL)VERIFY(m_hImageList);
}

AFXINLINE HIMAGELIST CImageList::Merge(int iImage1, HIMAGELIST hIml2, int iImage2,
	int cxOffset, int cyOffset) const
{
	return (HIMAGELIST)VERIFY(::ImageList_Merge(m_hImageList, iImage1, hIml2, iImage2,
		cxOffset, cyOffset));
}

AFXINLINE BOOL CImageList::Read(IStream* pStm)
{
	m_hImageList = ::ImageList_Read(pStm);
	return (BOOL)VERIFY(m_hImageList);
}

AFXINLINE BOOL CImageList::Remove(int iImage) const
{
	return VERIFY(::ImageList_Remove(m_hImageList, iImage));
}

AFXINLINE BOOL CImageList::RemoveAll() const
{
	return VERIFY(::ImageList_Remove(m_hImageList, -1));
}

AFXINLINE BOOL CImageList::Replace(int iImage, HBITMAP hImageBmp,
	HBITMAP hMaskBmp /* = NULL */) const
{
	return VERIFY(::ImageList_Replace(m_hImageList, iImage, hImageBmp, hMaskBmp));
}

AFXINLINE int CImageList::Replace(int iImage, HICON hIcon) const
{
	return UNEQUAL(::ImageList_ReplaceIcon(m_hImageList, iImage, hIcon), RV_ERR);
}

AFXINLINE COLORREF CImageList::SetBkColor(COLORREF crValue) const
{
	return ::ImageList_SetBkColor(m_hImageList, crValue);
}

AFXINLINE BOOL CImageList::SetDragImage(int iImage, int xHotspot, int yHotspot) const
{
	return VERIFY(::ImageList_SetDragCursorImage(m_hImageList, iImage, xHotspot, yHotspot));
}

AFXINLINE BOOL CImageList::SetImageCount(UINT ceImage) const
{
	return VERIFY(::ImageList_SetImageCount(m_hImageList, ceImage));
}

AFXINLINE BOOL CImageList::SetImageSize(int cxImage, int cyImage) const
{
	return VERIFY(::ImageList_SetIconSize(m_hImageList, cxImage, cyImage));
}

AFXINLINE BOOL CImageList::SetOverlayImage(int iImage, int iOverlay) const
{
	return VERIFY(::ImageList_SetOverlayImage(m_hImageList, iImage, iOverlay));
}

AFXINLINE BOOL CImageList::Write(IStream* pStm) const
{
	return VERIFY(::ImageList_Write(m_hImageList, pStm));
}

AFXINLINE BOOL WINAPI DragHide()
{
	return VERIFY(ImageList_DragShowNolock(FALSE));
}

AFXINLINE BOOL WINAPI DragMove(int x, int y)
{
	return VERIFY(ImageList_DragMove(x, y));
}

AFXINLINE BOOL WINAPI DragShow()
{
	return VERIFY(ImageList_DragShowNolock(TRUE));
}

AFXINLINE BOOL WINAPI DrawImage(PIMAGELISTDRAWPARAMS pILDP)
{
	return VERIFY(ImageList_DrawIndirect(pILDP));
}

AFXINLINE void WINAPI EndDrag()
{
	ImageList_EndDrag();
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CIPAddress

#define ON_IPN_FIELDCHANGED(fName) _ON_NOTIFY_V(IPN_FIELDCHANGED, fName, PNMIPADDRESS)

#undef  MAKEIPRANGE
#undef  MAKEIPADDRESS
#define MAKEIPRANGE(l, h) MAKEWORD(l, h)
#define MAKEIPADDRESS(f0, f1, f2, f3) \
	((LPARAM)(((DWORD)(f0) << 24) | ((DWORD)(f1) << 16) | ((DWORD)(f2) << 8) | (f3)))

class CIPAddress : public CWnd
{
public:
	CIPAddress();
	CIPAddress(HWND hIPAddress);
	void operator =(HWND hIPAddress);
	void ClearAddress() const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nIPAddressId);
	int GetAddress(PDWORD pdwAddress) const;
	BOOL IsBlank() const;
	void SetAddress(DWORD dwAddress) const;
	void SetFocus(int iField) const;
	BOOL SetRange(int iField, BYTE byLower, BYTE byUpper) const;
};

AFXINLINE CIPAddress::CIPAddress()
{
	// Does nothing
}

AFXINLINE CIPAddress::CIPAddress(HWND hIPAddress)
{
	m_hWnd = hIPAddress;
}

AFXINLINE void CIPAddress::operator =(HWND hIPAddress)
{
	m_hWnd = hIPAddress;
}

AFXINLINE void CIPAddress::ClearAddress() const
{
	::SendMessage(m_hWnd, IPM_CLEARADDRESS, UNUSED, UNUSED);
}

AFXINLINE BOOL CIPAddress::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nIPAddressId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_IPADDRESS, NULL, dwStyle, x, y, iWidth, iHeight,
		hParentWnd, (HMENU)nIPAddressId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE int CIPAddress::GetAddress(PDWORD pdwAddress) const
{
	return ::SendMessage(m_hWnd, IPM_GETADDRESS, UNUSED, (LPARAM)pdwAddress);
}

AFXINLINE BOOL CIPAddress::IsBlank() const
{
	return ::SendMessage(m_hWnd, IPM_ISBLANK, UNUSED, UNUSED);
}

AFXINLINE void CIPAddress::SetAddress(DWORD dwAddress) const
{
	::SendMessage(m_hWnd, IPM_SETADDRESS, UNUSED, dwAddress);
}

AFXINLINE void CIPAddress::SetFocus(int iField) const
{
	::SendMessage(m_hWnd, IPM_SETFOCUS, iField, UNUSED);
}

AFXINLINE BOOL CIPAddress::SetRange(int iField, BYTE byLower, BYTE byUpper) const
{
	return VERIFY(::SendMessage(m_hWnd, IPM_SETRANGE, iField, MAKEIPRANGE(byLower, byUpper)));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CListView

#define ON_LVN_BEGINDRAG(fName)      _ON_NOTIFY_V(LVN_BEGINDRAG, fName, PCNMLISTVIEW)
#define ON_LVN_BEGINLABELEDIT(fName) _ON_NOTIFY_R(LVN_BEGINLABELEDIT, fName, PCNMLVDISPINFO)
#define ON_LVN_BEGINRDRAG(fName)     _ON_NOTIFY_V(LVN_BEGINRDRAG, fName, PCNMLISTVIEW)
#define ON_LVN_BEGINSCROLL(fName)    _ON_NOTIFY_V(LVN_BEGINSCROLL, fName, PCNMLVSCROLL)
#define ON_LVN_COLUMNCLICK(fName)    _ON_NOTIFY_V(LVN_COLUMNCLICK, fName, PCNMLISTVIEW)
#define ON_LVN_DELETEALLITEMS(fName) _ON_NOTIFY_R(LVN_DELETEALLITEMS, fName, PCNMLISTVIEW)
#define ON_LVN_DELETEITEM(fName)     _ON_NOTIFY_V(LVN_DELETEITEM, fName, PCNMLISTVIEW)
#define ON_LVN_ENDDRAG(fName)        _ON_NOTIFY_V(LVN_ENDDRAG, fName, PCNMLISTVIEW)
#define ON_LVN_ENDLABELEDIT(fName)   _ON_NOTIFY_R(LVN_ENDLABELEDIT, fName, PCNMLVDISPINFO)
#define ON_LVN_ENDSCROLL(fName)      _ON_NOTIFY_V(LVN_ENDSCROLL, fName, PCNMLVSCROLL)
#define ON_LVN_GETDISPINFO(fName)    _ON_NOTIFY_V(LVN_GETDISPINFO, fName, PNMLVDISPINFO)
#define ON_LVN_GETINFOTIP(fName)     _ON_NOTIFY_V(LVN_GETINFOTIP, fName, PNMLVGETINFOTIP)
#define ON_LVN_HOTTRACK(fName)       _ON_NOTIFY_R(LVN_HOTTRACK, fName, PNMLISTVIEW)
#define ON_LVN_INSERTITEM(fName)     _ON_NOTIFY_V(LVN_INSERTITEM, fName, PCNMLISTVIEW)
#define ON_LVN_ITEMACTIVATE(fName)   _ON_NOTIFY_V(LVN_ITEMACTIVATE, fName, PCNMITEMACTIVATE)
#define ON_LVN_ITEMCHANGED(fName)    _ON_NOTIFY_V(LVN_ITEMCHANGED, fName, PCNMLISTVIEW)
#define ON_LVN_ITEMCHANGING(fName)   _ON_NOTIFY_R(LVN_ITEMCHANGING, fName, PCNMLISTVIEW)
#define ON_LVN_KEYDOWN(fName)        _ON_NOTIFY_V(LVN_KEYDOWN, fName, PCNMLVKEYDOWN)
#define ON_LVN_MARQUEEBEGIN(fName)   _ON_NOTIFY_R(LVN_MARQUEEBEGIN, fName, PCNMLISTVIEW)
#define ON_LVN_ODCACHEHINT(fName)    _ON_NOTIFY_V(LVN_ODCACHEHINT, fName, PCNMLVCACHEHINT)
#define ON_LVN_ODFINDITEM(fName)     _ON_NOTIFY_R(LVN_ODFINDITEM, fName, PCNMLVFINDITEM)
#define ON_LVN_ODSTATECHANGED(fName) \
	_ON_NOTIFY_V(LVN_ODSTATECHANGED, fName, PCNMLVODSTATECHANGE)
#define ON_LVN_SETDISPINFO(fName) _ON_NOTIFY_V(LVN_SETDISPINFO, fName, PCNMLVDISPINFO)

// A list view is about to be drawn
// UINT OnNmCustomDrawLV(PNMLVCUSTOMDRAW pNMLVCD);
// Returns: Result value of the message processed
#define ON_NM_CUSTOMDRAWLV(fName) _ON_NOTIFY_R(NM_CUSTOMDRAW, fName, PNMLVCUSTOMDRAW)

class CListView : public CWnd
{
public:
	CListView();
	CListView(HWND hListView);
	void operator =(HWND hListView);
	BOOL Arrange(UINT nType) const;
	HIMAGELIST CreateDragImage(int iItem, PPOINT pPoint) const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nListViewId);
	BOOL DeleteAllItems() const;
	BOOL DeleteColumn(int iColumn) const;
	BOOL DeleteItem(int iItem) const;
	HWND EditLabel(int iItem) const;
	void EndLabelEdit() const;
	BOOL EnsureVisible(int iItem, BOOL bPartial = FALSE) const;
	int FindItem(PCLVFINDINFO pLVFI, int iStart = -1) const;
	COLORREF GetBkColor() const;
	BOOL GetBkImage(PLVBKIMAGE pLVBKI) const;
	UINT GetCallbackMask() const;
	BOOL GetCheckState(int iItem) const;
	BOOL GetColumn(int iColumn, PLVCOLUMN pLVC) const;
	BOOL GetColumnOrder(PINT piaColumn, int ceColumn) const;
	int GetColumnWidth(int iColumn = UNUSED) const;
	int GetCountPerPage() const;
	HWND GetEditCtrl() const;
	DWORD GetExStyle() const;
	HWND GetHeader() const;
	HCURSOR GetHotCursor() const;
	int GetHotItem() const;
	UINT GetHoverTime() const;
	HIMAGELIST GetImageList(UINT nType) const;
	int GetISearchString(PTSTR pszBuffer = NULL) const;
	BOOL GetItem(PLVITEM pLVI) const;
	int GetItemCount() const;
	BOOL GetItemPos(int iItem, PPOINT pPoint) const;
	BOOL GetItemRect(int iItem, UINT nPortion, PRECT pRect) const;
	BOOL GetItemRect(int iItem, int iSubitem, UINT nPortion, PRECT pRect) const;
	DWORD GetItemSpacing(BOOL bSmall) const;
	UINT GetItemState(int iItem, UINT nMask) const;
	int GetItemText(int iItem, PCLVITEM pLVI) const;
	int GetNextItem(UINT nFlags, int iStart = -1) const;
	BOOL GetOrigin(PPOINT pPoint) const;
	int GetSelCount() const;
	int GetSelMark() const;
	int GetStringWidth(PCTSTR pszText) const;
	COLORREF GetTextBkColor() const;
	COLORREF GetTextColor() const;
	HWND GetTooltips() const;
	int GetTopIndex() const;
	BOOL GetUnicodeFormat() const;
	int GetVersion() const;
	DWORD GetViewRect(int iWidth, int iHeight, int ceItem = -1) const;
	DWORD GetViewRect(int ceItem = -1) const;
	BOOL GetViewRect(PRECT pRect) const;
	void GetWorkAreaCount(PINT pceWorkArea) const;
	void GetWorkAreas(PRECT prcaWorkArea, int ceWorkArea) const;
	int HitTest(PLVHITTESTINFO pLVHTI) const;
	int InsertColumn(int iColumn, PCLVCOLUMN pLVC) const;
	int InsertItem(PCLVITEM pLVI) const;
	int MapIdToIndex(UINT nItemId) const;
	UINT MapIndexToId(int iItem) const;
	BOOL RedrawItems(int iFirst, int iLast) const;
	BOOL RedrawItems(int iItem) const;
	BOOL Scroll(int cxAmount, int cyAmount) const;
	BOOL SetBkColor(COLORREF crValue) const;
	BOOL SetBkImage(PCLVBKIMAGE pLVBKI) const;
	BOOL SetCallbackMask(UINT nMask) const;
	BOOL SetCheckState(int iItem, BOOL bCheck) const;
	BOOL SetColumn(int iColumn, PCLVCOLUMN pLVC) const;
	BOOL SetColumnOrder(PCINT piaColumn, int ceColumn) const;
	BOOL SetColumnWidth(int iColumn, int iWidth) const;
	BOOL SetColumnWidth(int iWidth) const;
	DWORD SetExStyle(DWORD dwStyle, DWORD dwMask = UNUSED) const;
	HCURSOR SetHotCursor(HCURSOR hCursor) const;
	int SetHotItem(int iItem) const;
	UINT SetHoverTime(UINT nTime = MAX_UINT) const;
	HIMAGELIST SetImageList(HIMAGELIST hImageList, UINT nType) const;
	BOOL SetItem(PCLVITEM pLVI) const;
	BOOL SetItemCount(int ceItem, UINT nFlags = UNUSED) const;
	BOOL SetItemPos(int iItem, int x, int y) const;
	void SetItemPos(int iItem, PCPOINT pPoint) const;
	DWORD SetItemSpacing(int cxAmount, int cyAmount) const;
	BOOL SetItemState(int iItem, PCLVITEM pLVI) const;
	BOOL SetItemState(PCLVITEM pLVI) const;
	BOOL SetItemText(int iItem, PCLVITEM pLVI) const;
	int SetSelMark(int iItem) const;
	BOOL SetTextBkColor(COLORREF crValue) const;
	BOOL SetTextColor(COLORREF crValue) const;
	HWND SetTooltips(HWND hTooltip) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
	int SetVersion(int iVersion) const;
	void SetWorkAreas(PCRECT prcaWorkArea = NULL, int ceWorkArea = UNUSED) const;
	BOOL SortItems(PFNLVCOMPARE lvcName, LPARAM lSortParam = UNUSED) const;
	BOOL SortItems(PLVCOMPARE lvcName, LPARAM lSortParam = UNUSED) const;
	int SubitemHitTest(PLVHITTESTINFO pLVHTI) const;
	BOOL Update(int iItem) const;
};

AFXINLINE CListView::CListView()
{
	// Does nothing
}

AFXINLINE CListView::CListView(HWND hListView)
{
	m_hWnd = hListView;
}

AFXINLINE void CListView::operator =(HWND hListView)
{
	m_hWnd = hListView;
}

AFXINLINE BOOL CListView::Arrange(UINT nType) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_ARRANGE, nType, UNUSED));
}

AFXINLINE HIMAGELIST CListView::CreateDragImage(int iItem, PPOINT pPoint) const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, LVM_CREATEDRAGIMAGE,
		iItem, (LPARAM)pPoint));
}

AFXINLINE BOOL CListView::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nListViewId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_LISTVIEW, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nListViewId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CListView::DeleteAllItems() const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_DELETEALLITEMS, UNUSED, UNUSED));
}

AFXINLINE BOOL CListView::DeleteColumn(int iColumn) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_DELETECOLUMN, iColumn, UNUSED));
}

AFXINLINE BOOL CListView::DeleteItem(int iItem) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_DELETEITEM, iItem, UNUSED));
}

AFXINLINE HWND CListView::EditLabel(int iItem) const
{
	return (HWND)::SendMessage(m_hWnd, LVM_EDITLABEL, iItem, UNUSED);
}

AFXINLINE void CListView::EndLabelEdit() const
{
	::SendMessage(m_hWnd, LVM_EDITLABEL, -1, UNUSED);
}

AFXINLINE BOOL CListView::EnsureVisible(int iItem, BOOL bPartial /* = FALSE */) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_ENSUREVISIBLE, iItem, bPartial));
}

AFXINLINE int CListView::FindItem(PCLVFINDINFO pLVFI, int iStart /* = -1 */) const
{
	return ::SendMessage(m_hWnd, LVM_FINDITEM, iStart, (LPARAM)pLVFI);
}

AFXINLINE COLORREF CListView::GetBkColor() const
{
	return ::SendMessage(m_hWnd, LVM_GETBKCOLOR, UNUSED, UNUSED);
}

AFXINLINE BOOL CListView::GetBkImage(PLVBKIMAGE pLVBKI) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETBKIMAGE, UNUSED, (LPARAM)pLVBKI));
}

AFXINLINE UINT CListView::GetCallbackMask() const
{
	return ::SendMessage(m_hWnd, LVM_GETCALLBACKMASK, UNUSED, UNUSED);
}

AFXINLINE BOOL CListView::GetCheckState(int iItem) const
{
	return (::SendMessage(m_hWnd, LVM_GETITEMSTATE, iItem, LVIS_STATEIMAGEMASK) & 0x2000);
}

AFXINLINE BOOL CListView::GetColumn(int iColumn, PLVCOLUMN pLVC) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETCOLUMN, iColumn, (LPARAM)pLVC));
}

AFXINLINE BOOL CListView::GetColumnOrder(PINT piaColumn, int ceColumn) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETCOLUMNORDERARRAY, ceColumn, (LPARAM)piaColumn));
}

AFXINLINE int CListView::GetColumnWidth(int iColumn /* = UNUSED */) const
{
	return ::SendMessage(m_hWnd, LVM_GETCOLUMNWIDTH, iColumn, UNUSED);
}

AFXINLINE int CListView::GetCountPerPage() const
{
	return ::SendMessage(m_hWnd, LVM_GETCOUNTPERPAGE, UNUSED, UNUSED);
}

AFXINLINE HWND CListView::GetEditCtrl() const
{
	return (HWND)::SendMessage(m_hWnd, LVM_GETEDITCONTROL, UNUSED, UNUSED);
}

AFXINLINE DWORD CListView::GetExStyle() const
{
	return ::SendMessage(m_hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, UNUSED, UNUSED);
}

AFXINLINE HWND CListView::GetHeader() const
{
	return (HWND)::SendMessage(m_hWnd, LVM_GETHEADER, UNUSED, UNUSED);
}

AFXINLINE HCURSOR CListView::GetHotCursor() const
{
	return (HCURSOR)::SendMessage(m_hWnd, LVM_GETHOTCURSOR, UNUSED, UNUSED);
}

AFXINLINE int CListView::GetHotItem() const
{
	return ::SendMessage(m_hWnd, LVM_GETHOTITEM, UNUSED, UNUSED);
}

AFXINLINE UINT CListView::GetHoverTime() const
{
	return ::SendMessage(m_hWnd, LVM_GETHOVERTIME, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CListView::GetImageList(UINT nType) const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, LVM_GETIMAGELIST, nType, UNUSED));
}

AFXINLINE int CListView::GetISearchString(PTSTR pszBuffer /* = NULL */) const
{
	return ::SendMessage(m_hWnd, LVM_GETISEARCHSTRING, UNUSED, (LPARAM)pszBuffer);
}

AFXINLINE BOOL CListView::GetItem(PLVITEM pLVI) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETITEM, UNUSED, (LPARAM)pLVI));
}

AFXINLINE int CListView::GetItemCount() const
{
	return ::SendMessage(m_hWnd, LVM_GETITEMCOUNT, UNUSED, UNUSED);
}

AFXINLINE BOOL CListView::GetItemPos(int iItem, PPOINT pPoint) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETITEMPOSITION, iItem, (LPARAM)pPoint));
}

AFXINLINE BOOL CListView::GetItemRect(int iItem, UINT nPortion, PRECT pRect) const
{
	pRect->left = nPortion;
	return VERIFY(::SendMessage(m_hWnd, LVM_GETITEMRECT, iItem, (LPARAM)pRect));
}

AFXINLINE BOOL CListView::GetItemRect(int iItem, int iSubitem, UINT nPortion, PRECT pRect) const
{
	pRect->left = nPortion;
	pRect->top  = iSubitem;
	return VERIFY(::SendMessage(m_hWnd, LVM_GETSUBITEMRECT, iItem, (LPARAM)pRect));
}

AFXINLINE DWORD CListView::GetItemSpacing(BOOL bSmall) const
{
	return ::SendMessage(m_hWnd, LVM_GETITEMSPACING, bSmall, UNUSED);
}

AFXINLINE UINT CListView::GetItemState(int iItem, UINT nMask) const
{
	return ::SendMessage(m_hWnd, LVM_GETITEMSTATE, iItem, nMask);
}

AFXINLINE int CListView::GetItemText(int iItem, PCLVITEM pLVI) const
{
	return ::SendMessage(m_hWnd, LVM_GETITEMTEXT, iItem, (LPARAM)pLVI);
}

AFXINLINE int CListView::GetNextItem(UINT nFlags, int iStart /* = -1 */) const
{
	return ::SendMessage(m_hWnd, LVM_GETNEXTITEM, iStart, nFlags);
}

AFXINLINE BOOL CListView::GetOrigin(PPOINT pPoint) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETORIGIN, UNUSED, (LPARAM)pPoint));
}

AFXINLINE int CListView::GetSelCount() const
{
	return ::SendMessage(m_hWnd, LVM_GETSELECTEDCOUNT, UNUSED, UNUSED);
}

AFXINLINE int CListView::GetSelMark() const
{
	return ::SendMessage(m_hWnd, LVM_GETSELECTIONMARK, UNUSED, UNUSED);
}

AFXINLINE int CListView::GetStringWidth(PCTSTR pszText) const
{
	return ::SendMessage(m_hWnd, LVM_GETSTRINGWIDTH, UNUSED, (LPARAM)pszText);
}

AFXINLINE COLORREF CListView::GetTextBkColor() const
{
	return ::SendMessage(m_hWnd, LVM_GETTEXTBKCOLOR, UNUSED, UNUSED);
}

AFXINLINE COLORREF CListView::GetTextColor() const
{
	return ::SendMessage(m_hWnd, LVM_GETTEXTCOLOR, UNUSED, UNUSED);
}

AFXINLINE HWND CListView::GetTooltips() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, LVM_GETTOOLTIPS, UNUSED, UNUSED));
}

AFXINLINE int CListView::GetTopIndex() const
{
	return ::SendMessage(m_hWnd, LVM_GETTOPINDEX, UNUSED, UNUSED);
}

AFXINLINE BOOL CListView::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, LVM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE int CListView::GetVersion() const
{
	return ::SendMessage(m_hWnd, CCM_GETVERSION, UNUSED, UNUSED);
}

AFXINLINE DWORD CListView::GetViewRect(int iWidth, int iHeight, int ceItem /* = -1 */) const
{
	return ::SendMessage(m_hWnd, LVM_APPROXIMATEVIEWRECT, ceItem, MAKELPARAM(iWidth, iHeight));
}

AFXINLINE DWORD CListView::GetViewRect(int ceItem /* = -1 */) const
{
	return ::SendMessage(m_hWnd, LVM_APPROXIMATEVIEWRECT, ceItem, -1);
}

AFXINLINE BOOL CListView::GetViewRect(PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_GETVIEWRECT, UNUSED, (LPARAM)pRect));
}

AFXINLINE void CListView::GetWorkAreaCount(PINT pceWorkArea) const
{
	::SendMessage(m_hWnd, LVM_GETNUMBEROFWORKAREAS, UNUSED, (LPARAM)pceWorkArea);
}

AFXINLINE void CListView::GetWorkAreas(PRECT prcaWorkArea, int ceWorkArea) const
{
	::SendMessage(m_hWnd, LVM_GETWORKAREAS, ceWorkArea, (LPARAM)prcaWorkArea);
}

AFXINLINE int CListView::HitTest(PLVHITTESTINFO pLVHTI) const
{
	return ::SendMessage(m_hWnd, LVM_HITTEST, UNUSED, (LPARAM)pLVHTI);
}

AFXINLINE int CListView::InsertColumn(int iColumn, PCLVCOLUMN pLVC) const
{
	return UNEQUAL(::SendMessage(m_hWnd, LVM_INSERTCOLUMN, iColumn, (LPARAM)pLVC), RV_ERR);
}

AFXINLINE int CListView::InsertItem(PCLVITEM pLVI) const
{
	return UNEQUAL(::SendMessage(m_hWnd, LVM_INSERTITEM, UNUSED, (LPARAM)pLVI), RV_ERR);
}

AFXINLINE int CListView::MapIdToIndex(UINT nItemId) const
{
	return ::SendMessage(m_hWnd, LVM_MAPIDTOINDEX, nItemId, UNUSED);
}

AFXINLINE UINT CListView::MapIndexToId(int iItem) const
{
	return ::SendMessage(m_hWnd, LVM_MAPINDEXTOID, iItem, UNUSED);
}

AFXINLINE BOOL CListView::RedrawItems(int iFirst, int iLast) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_REDRAWITEMS, iFirst, iLast));
}

AFXINLINE BOOL CListView::RedrawItems(int iItem) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_REDRAWITEMS, iItem, iItem));
}

AFXINLINE BOOL CListView::Scroll(int cxAmount, int cyAmount) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SCROLL, cxAmount, cyAmount));
}

AFXINLINE BOOL CListView::SetBkColor(COLORREF crValue) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETBKCOLOR, UNUSED, crValue));
}

AFXINLINE BOOL CListView::SetBkImage(PCLVBKIMAGE pLVBKI) const
{
#ifdef DEBUG
	BOOL bSuccess;
	bSuccess = ::SendMessage(m_hWnd, LVM_SETBKIMAGE, UNUSED, (LPARAM)pLVBKI);
	return ((pLVBKI->ulFlags & LVBKIF_SOURCE_NONE) ? TRUE : bSuccess);
#else
	return ::SendMessage(m_hWnd, LVM_SETBKIMAGE, UNUSED, (LPARAM)pLVBKI);
#endif
}

AFXINLINE BOOL CListView::SetCallbackMask(UINT nMask) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETCALLBACKMASK, nMask, UNUSED));
}

AFXINLINE BOOL CListView::SetCheckState(int iItem, BOOL bCheck) const
{
	LVITEM lvi;
	lvi.state     = bCheck ? 0x2000 : 0x1000;
	lvi.stateMask = LVIS_STATEIMAGEMASK;
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEMSTATE, iItem, (LPARAM)&lvi));
}

AFXINLINE BOOL CListView::SetColumn(int iColumn, PCLVCOLUMN pLVC) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETCOLUMN, iColumn, (LPARAM)pLVC));
}

AFXINLINE BOOL CListView::SetColumnOrder(PCINT piaColumn, int ceColumn) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETCOLUMNORDERARRAY, ceColumn, (LPARAM)piaColumn));
}

AFXINLINE BOOL CListView::SetColumnWidth(int iColumn, int iWidth) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETCOLUMNWIDTH, iColumn, iWidth));
}

AFXINLINE BOOL CListView::SetColumnWidth(int iWidth) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETCOLUMNWIDTH, 0, iWidth));
}

AFXINLINE DWORD CListView::SetExStyle(DWORD dwStyle, DWORD dwMask /* = UNUSED */) const
{
	return ::SendMessage(m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, dwMask, dwStyle);
}

AFXINLINE HCURSOR CListView::SetHotCursor(HCURSOR hCursor) const
{
	return (HCURSOR)::SendMessage(m_hWnd, LVM_SETHOTCURSOR, UNUSED, (LPARAM)hCursor);
}

AFXINLINE int CListView::SetHotItem(int iItem) const
{
	return ::SendMessage(m_hWnd, LVM_SETHOTITEM, iItem, UNUSED);
}

AFXINLINE UINT CListView::SetHoverTime(UINT nTime /* = MAX_UINT */) const
{
	return ::SendMessage(m_hWnd, LVM_SETHOVERTIME, UNUSED, nTime);
}

AFXINLINE HIMAGELIST CListView::SetImageList(HIMAGELIST hImageList, UINT nType) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, LVM_SETIMAGELIST, nType, (LPARAM)hImageList);
}

AFXINLINE BOOL CListView::SetItem(PCLVITEM pLVI) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEM, UNUSED, (LPARAM)pLVI));
}

AFXINLINE BOOL CListView::SetItemCount(int ceItem, UINT nFlags /* = UNUSED */) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEMCOUNT, ceItem, nFlags));
}

AFXINLINE BOOL CListView::SetItemPos(int iItem, int x, int y) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEMPOSITION, iItem, MAKELPARAM(x, y)));
}

AFXINLINE void CListView::SetItemPos(int iItem, PCPOINT pPoint) const
{
	::SendMessage(m_hWnd, LVM_SETITEMPOSITION32, iItem, (LPARAM)pPoint);
}

AFXINLINE DWORD CListView::SetItemSpacing(int cxAmount, int cyAmount) const
{
	return ::SendMessage(m_hWnd, LVM_SETICONSPACING, UNUSED, MAKELPARAM(cxAmount, cyAmount));
}

AFXINLINE BOOL CListView::SetItemState(int iItem, PCLVITEM pLVI) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEMSTATE, iItem, (LPARAM)pLVI));
}

AFXINLINE BOOL CListView::SetItemState(PCLVITEM pLVI) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEMSTATE, -1, (LPARAM)pLVI));
}

AFXINLINE BOOL CListView::SetItemText(int iItem, PCLVITEM pLVI) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETITEMTEXT, iItem, (LPARAM)pLVI));
}

AFXINLINE int CListView::SetSelMark(int iItem) const
{
	return ::SendMessage(m_hWnd, LVM_SETSELECTIONMARK, UNUSED, iItem);
}

AFXINLINE BOOL CListView::SetTextBkColor(COLORREF crValue) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETTEXTBKCOLOR, UNUSED, crValue));
}

AFXINLINE BOOL CListView::SetTextColor(COLORREF crValue) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SETTEXTCOLOR, UNUSED, crValue));
}

AFXINLINE HWND CListView::SetTooltips(HWND hTooltip) const
{
	return (HWND)::SendMessage(m_hWnd, LVM_SETTOOLTIPS, (WPARAM)hTooltip, UNUSED);
}

AFXINLINE BOOL CListView::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, LVM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

AFXINLINE int CListView::SetVersion(int iVersion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, CCM_SETVERSION, iVersion, UNUSED), RV_ERR);
}

AFXINLINE void CListView::SetWorkAreas(PCRECT prcaWorkArea /* = NULL */,
	int ceWorkArea /* = UNUSED */) const
{
	::SendMessage(m_hWnd, LVM_SETWORKAREAS, ceWorkArea, (LPARAM)prcaWorkArea);
}

AFXINLINE BOOL CListView::SortItems(PFNLVCOMPARE lvcName,
	LPARAM lSortParam /* = UNUSED */) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SORTITEMS, lSortParam, (LPARAM)lvcName));
}

AFXINLINE BOOL CListView::SortItems(PLVCOMPARE lvcName, LPARAM lSortParam /*= UNUSED */) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_SORTITEMSEX, lSortParam, (LPARAM)lvcName));
}

AFXINLINE int CListView::SubitemHitTest(PLVHITTESTINFO pLVHTI) const
{
	return ::SendMessage(m_hWnd, LVM_SUBITEMHITTEST, UNUSED, (LPARAM)pLVHTI);
}

AFXINLINE BOOL CListView::Update(int iItem) const
{
	return VERIFY(::SendMessage(m_hWnd, LVM_UPDATE, iItem, UNUSED));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CMonthCal

#define ON_MCN_GETDAYSTATE(fName) _ON_NOTIFY_V(MCN_GETDAYSTATE, fName, PNMDAYSTATE)
#define ON_MCN_SELCHANGE(fName)   _ON_NOTIFY_V(MCN_SELCHANGE, fName, PCNMSELCHANGE)
#define ON_MCN_SELECT(fName)      _ON_NOTIFY_V(MCN_SELECT, fName, PCNMSELECT)

class CMonthCal : public CWnd
{
public:
	CMonthCal();
	CMonthCal(HWND hMonthCal);
	void operator =(HWND hMonthCal);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nMonthCalId);
	COLORREF GetColor(UINT nPortion) const;
	BOOL GetCurSel(PSYSTEMTIME pST) const;
	DWORD GetFirstDayOfWeek() const;
	int GetMaxSelCount() const;
	int GetMaxTodayWidth() const;
	BOOL GetMinReqRect(PRECT pRect) const;
	int GetMonthDelta() const;
	int GetMonthRange(PSYSTEMTIME paST, UINT nFlag) const;
	UINT GetRange(PSYSTEMTIME paST) const;
	BOOL GetSelRange(PSYSTEMTIME paST) const;
	BOOL GetToday(PSYSTEMTIME pST) const;
	BOOL GetUnicodeFormat() const;
	UINT HitTest(PMCHITTESTINFO pMCHTI) const;
	COLORREF SetColor(COLORREF crValue, UINT nPortion) const;
	BOOL SetCurSel(PCSYSTEMTIME pST) const;
	BOOL SetDayState(PCMONTHDAYSTATE paMDS, int ceMDS) const;
	DWORD SetFirstDayOfWeek(int iDay) const;
	BOOL SetMaxSelCount(int iMax) const;
	int SetMonthDelta(int iDelta = 0) const;
	BOOL SetRange(PCSYSTEMTIME paST, UINT nFlags) const;
	BOOL SetSelRange(PCSYSTEMTIME paST) const;
	void SetToday(PCSYSTEMTIME pST = NULL) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
};

AFXINLINE CMonthCal::CMonthCal()
{
	// Does nothing
}

AFXINLINE CMonthCal::CMonthCal(HWND hMonthCal)
{
	m_hWnd = hMonthCal;
}

AFXINLINE void CMonthCal::operator =(HWND hMonthCal)
{
	m_hWnd = hMonthCal;
}

AFXINLINE BOOL CMonthCal::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nMonthCalId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_MONTHCAL, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nMonthCalId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE COLORREF CMonthCal::GetColor(UINT nPortion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, MCM_GETCOLOR, nPortion, UNUSED), RV_ERR);
}

AFXINLINE BOOL CMonthCal::GetCurSel(PSYSTEMTIME pST) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_GETCURSEL, UNUSED, (LPARAM)pST));
}

AFXINLINE DWORD CMonthCal::GetFirstDayOfWeek() const
{
	return ::SendMessage(m_hWnd, MCM_GETFIRSTDAYOFWEEK, UNUSED, UNUSED);
}

AFXINLINE int CMonthCal::GetMaxSelCount() const
{
	return ::SendMessage(m_hWnd, MCM_GETMAXSELCOUNT, UNUSED, UNUSED);
}

AFXINLINE int CMonthCal::GetMaxTodayWidth() const
{
	return ::SendMessage(m_hWnd, MCM_GETMAXTODAYWIDTH, UNUSED, UNUSED);
}

AFXINLINE BOOL CMonthCal::GetMinReqRect(PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_GETMINREQRECT, UNUSED, (LPARAM)pRect));
}

AFXINLINE int CMonthCal::GetMonthDelta() const
{
	return ::SendMessage(m_hWnd, MCM_GETMONTHDELTA, UNUSED, UNUSED);
}

AFXINLINE int CMonthCal::GetMonthRange(PSYSTEMTIME paST, UINT nFlag) const
{
	return ::SendMessage(m_hWnd, MCM_GETMONTHRANGE, nFlag, (LPARAM)paST);
}

AFXINLINE UINT CMonthCal::GetRange(PSYSTEMTIME paST) const
{
	return ::SendMessage(m_hWnd, MCM_GETRANGE, UNUSED, (LPARAM)paST);
}

AFXINLINE BOOL CMonthCal::GetSelRange(PSYSTEMTIME paST) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_GETSELRANGE, UNUSED, (LPARAM)paST));
}

AFXINLINE BOOL CMonthCal::GetToday(PSYSTEMTIME pST) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_GETTODAY, UNUSED, (LPARAM)pST));
}

AFXINLINE BOOL CMonthCal::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, MCM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE UINT CMonthCal::HitTest(PMCHITTESTINFO pMCHTI) const
{
	return ::SendMessage(m_hWnd, MCM_HITTEST, UNUSED, (LPARAM)pMCHTI);
}

AFXINLINE COLORREF CMonthCal::SetColor(COLORREF crValue, UINT nPortion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, MCM_SETCOLOR, nPortion, crValue), RV_ERR);
}

AFXINLINE BOOL CMonthCal::SetCurSel(PCSYSTEMTIME pST) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_SETCURSEL, UNUSED, (LPARAM)pST));
}

AFXINLINE BOOL CMonthCal::SetDayState(PCMONTHDAYSTATE paMDS, int ceMDS) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_SETDAYSTATE, ceMDS, (LPARAM)paMDS));
}

AFXINLINE DWORD CMonthCal::SetFirstDayOfWeek(int iDay) const
{
	return ::SendMessage(m_hWnd, MCM_SETFIRSTDAYOFWEEK, UNUSED, iDay);
}

AFXINLINE BOOL CMonthCal::SetMaxSelCount(int iMax) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_SETMAXSELCOUNT, iMax, UNUSED));
}

AFXINLINE int CMonthCal::SetMonthDelta(int iDelta /* = 0 */) const
{
	return ::SendMessage(m_hWnd, MCM_SETMONTHDELTA, iDelta, UNUSED);
}

AFXINLINE BOOL CMonthCal::SetRange(PCSYSTEMTIME paST, UINT nFlags) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_SETRANGE, nFlags, (LPARAM)paST));
}

AFXINLINE BOOL CMonthCal::SetSelRange(PCSYSTEMTIME paST) const
{
	return VERIFY(::SendMessage(m_hWnd, MCM_SETSELRANGE, UNUSED, (LPARAM)paST));
}

AFXINLINE void CMonthCal::SetToday(PCSYSTEMTIME pST /* = NULL */) const
{
	::SendMessage(m_hWnd, MCM_SETTODAY, UNUSED, (LPARAM)pST);
}

AFXINLINE BOOL CMonthCal::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, MCM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CPagerCtrl

#define ON_PGN_CALCSIZE(fName) _ON_NOTIFY_V(PGN_CALCSIZE, fName, PNMPGCALCSIZE)
#define ON_PGN_SCROLL(fName)   _ON_NOTIFY_V(PGN_SCROLL, fName,  PNMPGSCROLL)

class CPagerCtrl : public CWnd
{
public:
	CPagerCtrl();
	CPagerCtrl(HWND hPagerCtrl);
	void operator =(HWND hPagerCtrl);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nPagerCtrlId);
	void ForwardMouse(BOOL bForward = TRUE) const;
	COLORREF GetBkColor() const;
	int GetBorder() const;
	int GetButtonSize() const;
	UINT GetButtonState(int iButton) const;
	void GetDropTarget(IDropTarget** ppDT) const;
	int GetPos() const;
	void RecalcSize() const;
	COLORREF SetBkColor(COLORREF crValue) const;
	int SetBorder(int iBorder) const;
	int SetButtonSize(int iButton) const;
	void SetChild(HWND hChildWnd) const;
	void SetPos(int iPos) const;
};

AFXINLINE CPagerCtrl::CPagerCtrl()
{
	// Does nothing
}

AFXINLINE CPagerCtrl::CPagerCtrl(HWND hPagerCtrl)
{
	m_hWnd = hPagerCtrl;
}

AFXINLINE void CPagerCtrl::operator =(HWND hPagerCtrl)
{
	m_hWnd = hPagerCtrl;
}

AFXINLINE BOOL CPagerCtrl::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nPagerCtrlId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_PAGERCTRL, NULL, dwStyle, x, y, iWidth, iHeight,
		hParentWnd, (HMENU)nPagerCtrlId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE void CPagerCtrl::ForwardMouse(BOOL bForward /* = TRUE */) const
{
	::SendMessage(m_hWnd, PGM_FORWARDMOUSE, bForward, UNUSED);
}

AFXINLINE COLORREF CPagerCtrl::GetBkColor() const
{
	return ::SendMessage(m_hWnd, PGM_GETBKCOLOR, UNUSED, UNUSED);
}

AFXINLINE int CPagerCtrl::GetBorder() const
{
	return ::SendMessage(m_hWnd, PGM_GETBORDER, UNUSED, UNUSED);
}

AFXINLINE int CPagerCtrl::GetButtonSize() const
{
	return ::SendMessage(m_hWnd, PGM_GETBUTTONSIZE, UNUSED, UNUSED);
}

AFXINLINE UINT CPagerCtrl::GetButtonState(int iButton) const
{
	return ::SendMessage(m_hWnd, PGM_GETBUTTONSTATE, UNUSED, iButton);
}

AFXINLINE void CPagerCtrl::GetDropTarget(IDropTarget** ppDT) const
{
	::SendMessage(m_hWnd, PGM_GETDROPTARGET, UNUSED, (LPARAM)ppDT);
}

AFXINLINE int CPagerCtrl::GetPos() const
{
	return ::SendMessage(m_hWnd, PGM_GETPOS, UNUSED, UNUSED);
}

AFXINLINE void CPagerCtrl::RecalcSize() const
{
	::SendMessage(m_hWnd, PGM_RECALCSIZE, UNUSED, UNUSED);
}

AFXINLINE COLORREF CPagerCtrl::SetBkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, PGM_SETBKCOLOR, UNUSED, crValue);
}

AFXINLINE int CPagerCtrl::SetBorder(int iBorder) const
{
	return ::SendMessage(m_hWnd, PGM_SETBORDER, UNUSED, iBorder);
}

AFXINLINE int CPagerCtrl::SetButtonSize(int iButton) const
{
	return ::SendMessage(m_hWnd, PGM_SETBUTTONSIZE, UNUSED, iButton);
}

AFXINLINE void CPagerCtrl::SetChild(HWND hChildWnd) const
{
	::SendMessage(m_hWnd, PGM_SETCHILD, UNUSED, (LPARAM)hChildWnd);
}

AFXINLINE void CPagerCtrl::SetPos(int iPos) const
{
	::SendMessage(m_hWnd, PGM_SETPOS, UNUSED, iPos);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CProgress

class CProgress : public CWnd
{
public:
	CProgress();
	CProgress(HWND hProgress);
	void operator =(HWND hProgress);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nProgressId);
	int DeltaPos(int iAmount) const;
	int GetPos() const;
	void GetRange(PPBRANGE pPBR) const;
	int GetRange(BOOL bLoLimit) const;
	COLORREF SetBarColor(COLORREF crValue) const;
	COLORREF SetBkColor(COLORREF crValue) const;
	void SetMarquee(int iInterval = 0) const;
	int SetPos(int iPos) const;
	DWORD SetRange(int iLoLimit, int iHiLimit) const;
	int SetStep(int iStepInc) const;
	int StepIt() const;
	void StopMarquee() const;

#if (WINVER >= 0x0600)
	int GetState() const;
	int SetState(int iState) const;
#endif
};

AFXINLINE CProgress::CProgress()
{
	// Does nothing
}

AFXINLINE CProgress::CProgress(HWND hProgress)
{
	m_hWnd = hProgress;
}

AFXINLINE void CProgress::operator =(HWND hProgress)
{
	m_hWnd = hProgress;
}

AFXINLINE BOOL CProgress::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nProgressId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_PROGRESS, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nProgressId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE int CProgress::DeltaPos(int iAmount) const
{
	return ::SendMessage(m_hWnd, PBM_DELTAPOS, iAmount, UNUSED);
}

AFXINLINE int CProgress::GetPos() const
{
	return ::SendMessage(m_hWnd, PBM_GETPOS, UNUSED, UNUSED);
}

AFXINLINE void CProgress::GetRange(PPBRANGE pPBR) const
{
	::SendMessage(m_hWnd, PBM_GETRANGE, UNUSED, (LPARAM)pPBR);
}

AFXINLINE int CProgress::GetRange(BOOL bLoLimit) const
{
	return ::SendMessage(m_hWnd, PBM_GETRANGE, bLoLimit, UNUSED);
}

AFXINLINE COLORREF CProgress::SetBarColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, PBM_SETBARCOLOR, UNUSED, crValue);
}

AFXINLINE COLORREF CProgress::SetBkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, PBM_SETBKCOLOR, UNUSED, crValue);
}

AFXINLINE void CProgress::SetMarquee(int iInterval /* = 0 */) const
{
	::SendMessage(m_hWnd, PBM_SETMARQUEE, TRUE, iInterval);
}

AFXINLINE int CProgress::SetPos(int iPos) const
{
	return ::SendMessage(m_hWnd, PBM_SETPOS, iPos, UNUSED);
}

AFXINLINE DWORD CProgress::SetRange(int iLoLimit, int iHiLimit) const
{
	return ::SendMessage(m_hWnd, PBM_SETRANGE32, iLoLimit, iHiLimit);
}

AFXINLINE int CProgress::SetStep(int iStepInc) const
{
	return ::SendMessage(m_hWnd, PBM_SETSTEP, iStepInc, UNUSED);
}

AFXINLINE int CProgress::StepIt() const
{
	return ::SendMessage(m_hWnd, PBM_STEPIT, UNUSED, UNUSED);
}

AFXINLINE void CProgress::StopMarquee() const
{
	::SendMessage(m_hWnd, PBM_SETMARQUEE, FALSE, UNUSED);
}

#if (WINVER >= 0x0600)
AFXINLINE int CProgress::GetState() const
{
	return ::SendMessage(m_hWnd, PBM_GETSTATE, UNUSED, UNUSED);
}

AFXINLINE int CProgress::SetState(int iState) const
{
	return ::SendMessage(m_hWnd, PBM_SETSTATE, iState, UNUSED);
}
#endif

////////////////////////////////////////////////////////////////////////////////////////////////
// CPropPage

#define PP_DEFAULT           PSP_DEFAULT
#define PP_DLGINDIRECT       PSP_DLGINDIRECT
#define PP_HASHELP           PSP_HASHELP
#define PP_HIDEHEADER        PSP_HIDEHEADER
#define PP_PREMATURE         PSP_PREMATURE
#define PP_RTLREADING        PSP_RTLREADING
#define PP_USECALLBACK       PSP_USECALLBACK
#define PP_USEHEADERSUBTITLE PSP_USEHEADERSUBTITLE
#define PP_USEHEADERTITLE    PSP_USEHEADERTITLE
#define PP_USEHICON          PSP_USEHICON
#define PP_USEICONID         PSP_USEICONID
#define PP_USEREFPARENT      PSP_USEREFPARENT
#define PP_USETITLE          PSP_USETITLE

// Only can be derived (cannot be instantiated)
// lParam member of PROPPAGE structure must be pointed to the associated page object
// Callback function PropPageProc must be used, if it is overriding, call the base first
// Return value of based PropPageProc can be ignored
class CPropPage : public CDialog
{
public:
	// Property page handle
	HPROPPAGE m_hPropPage;

public:
	operator HPROPPAGE() const;
	BOOL CreatePage(PCPROPPAGE pPP);
	BOOL DestroyPage();

public:
	static UINT CALLBACK PropPageProc(HWND hWnd, UINT nMsg, PPROPPAGE pPP);

protected:
	CPropPage();
};

AFXINLINE CPropPage::CPropPage()
{
	// Does nothing
}

AFXINLINE CPropPage::operator HPROPPAGE() const
{
	return m_hPropPage;
}

AFXINLINE BOOL CPropPage::CreatePage(PCPROPPAGE pPP)
{
	m_hPropPage = ::CreatePropertySheetPage(pPP);
	return (BOOL)VERIFY(m_hPropPage);
}

AFXINLINE BOOL CPropPage::DestroyPage()
{
	return VERIFY(::DestroyPropertySheetPage(m_hPropPage));
}

AFXINLINE UINT CALLBACK CPropPage::PropPageProc(HWND hWnd, UINT nMsg, PPROPPAGE pPP)
{
	if(nMsg == PSPCB_CREATE)
	{
		ASSERT(!_m_pWnd);
		_m_pWnd = (CWnd*)pPP->lParam;
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CPropSheet

// Requires every property page to do something
// Returns: Result value of the message processed
#define ON_PSM_QUERYSIBLINGS(fName) \
	case PSM_QUERYSIBLINGS: \
		return pWnd->fName(wParam, lParam);

#define ON_PSN_APPLY(fName)             _ON_NOTIFY_R(PSN_APPLY, fName, PCPSHNOTIFY)
#define ON_PSN_GETOBJECT(fName)         _ON_NOTIFY_V(PSN_GETOBJECT, fName, PNMOBJECTNOTIFY)
#define ON_PSN_HELP(fName)              _ON_NOTIFY_V(PSN_HELP, fName, PCNMHDR)
#define ON_PSN_KILLACTIVE(fName)        _ON_NOTIFY_R(PSN_KILLACTIVE, fName, PCNMHDR)
#define ON_PSN_QUERYCANCEL(fName)       _ON_NOTIFY_R(PSN_QUERYCANCEL, fName, PCNMHDR)
#define ON_PSN_QUERYINITIALFOCUS(fName) _ON_NOTIFY_R(PSN_QUERYINITIALFOCUS, fName, PCPSHNOTIFY)
#define ON_PSN_RESET(fName)             _ON_NOTIFY_V(PSN_RESET, fName, PCPSHNOTIFY)
#define ON_PSN_SETACTIVE(fName)         _ON_NOTIFY_R(PSN_SETACTIVE, fName, PCNMHDR)
#define ON_PSN_TRANSLATEACCELERATOR(fName) \
	_ON_NOTIFY_R(PSN_TRANSLATEACCELERATOR, fName, PCPSHNOTIFY)
#define ON_PSN_WIZBACK(fName)   _ON_NOTIFY_R(PSN_WIZBACK, fName, PCNMHDR)
#define ON_PSN_WIZFINISH(fName) _ON_NOTIFY_R(PSN_WIZFINISH, fName, PCNMHDR)
#define ON_PSN_WIZNEXT(fName)   _ON_NOTIFY_R(PSN_WIZNEXT, fName, PCNMHDR)

#define PS_DEFAULT           PSH_DEFAULT
#define PS_HASHELP           PSH_HASHELP
#define PS_HEADER            PSH_HEADER
#define PS_MODELESS          PSH_MODELESS
#define PS_NOAPPLY           PSH_NOAPPLYNOW
#define PS_NOCONTEXTHELP     PSH_NOCONTEXTHELP
#define PS_PROPPAGE          PSH_PROPSHEETPAGE
#define PS_PROPTITLE         PSH_PROPTITLE
#define PS_RTLREADING        PSH_RTLREADING
#define PS_STRETCHWATERMARK  PSH_STRETCHWATERMARK
#define PS_USECALLBACK       PSH_USECALLBACK
#define PS_USEHBMHEADER      PSH_USEHBMHEADER
#define PS_USEHBMWATERMARK   PSH_USEHBMWATERMARK
#define PS_USEHICON          PSH_USEHICON
#define PS_USEHPLWATERMARK   PSH_USEHPLWATERMARK
#define PS_USEICONID         PSH_USEICONID
#define PS_USEPAGELANG       PSH_USEPAGELANG
#define PS_USEPSTARTPAGE     PSH_USEPSTARTPAGE
#define PS_WATERMARK         PSH_WATERMARK
#define PS_WIZARD            PSH_WIZARD
#define PS_WIZARD97          PSH_WIZARD97
#define PS_WIZARDCONTEXTHELP PSH_WIZARDCONTEXTHELP
#define PS_WIZARDHASFINISH   PSH_WIZARDHASFINISH
#define PS_WIZARD_LITE       PSH_WIZARD_LITE
#define PSBTN_APPLY          PSBTN_APPLYNOW

// Button identifiers
#define ID_PS_APPLY  12321
#define ID_PS_BACK   12323
#define ID_PS_NEXT   12324
#define ID_PS_FINISH 12325

// Static and tab control identifiers
#define IDC_PS_TAB  12320
#define IDC_PS_SEPB 12326
#define IDC_PS_SEPT 12327

// Callback function PropSheetProc must be used, if it is overriding, call the base first
// Return value of based PropSheetProc can be ignored
class CPropSheet : public CDialog
{
public:
	BOOL AddPage(HPROPPAGE hPropPage) const;
	BOOL Apply() const;
	void CancelToClose() const;
	void Changed(HWND hPageDlg) const;
	HWND GetActivePage() const;
	HWND GetPage(int iPage) const;
	HPROPPAGE GetPageHandle(int iPage) const;
	UINT GetPageId(int iPage) const;
	int GetPageIndex(HPROPPAGE hPropPage) const;
	int GetPageIndex(HWND hPageDlg) const;
	int GetPageIndex(UINT nPageId) const;
	int GetResult() const;
	HWND GetTabCtrl() const;
	BOOL InsertPage(HPROPPAGE hPropPage, HPROPPAGE hFrontPage) const;
	BOOL InsertPage(HPROPPAGE hPropPage, int iPage = 0) const;
	BOOL IsDialogMessage(PCMSG pMsg) const;
	void PressButton(int iButton) const;
	int PropertySheet(PCPROPSHEET pPS);
	int QuerySiblings(WPARAM wParam, LPARAM lParam) const;
	void RebootSystem() const;
	BOOL RecalcPageSizes() const;
	void RemovePage(HPROPPAGE hPropPage) const;
	void RemovePage(int iPage) const;
	void RestartWindows() const;
	BOOL SetActivePage(HPROPPAGE hPropPage) const;
	BOOL SetActivePage(int iPage) const;
	BOOL SetCurSel(UINT nPageId) const;
	void SetFinishText(PCTSTR pszText) const;
	void SetHeaderSubtitle(int iPage, PCTSTR pszText) const;
	void SetHeaderTitle(int iPage, PCTSTR pszText) const;
	void SetTitle(PCTSTR pszText, UINT nFlag = PSH_PROPTITLE) const;
	void SetTitle(UINT nTextId, UINT nFlag = PSH_PROPTITLE) const;
	void SetWizButtons(UINT nFlags) const;
	void Unchanged(HWND hPageDlg) const;

public:
	static int CALLBACK PropSheetProc(HWND hSheetDlg, UINT nMsg, LPARAM lParam);
};

AFXINLINE BOOL CPropSheet::AddPage(HPROPPAGE hPropPage) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_ADDPAGE, UNUSED, (LPARAM)hPropPage));
}

AFXINLINE BOOL CPropSheet::Apply() const
{
	return ::SendMessage(m_hWnd, PSM_APPLY, UNUSED, UNUSED);
}

AFXINLINE void CPropSheet::CancelToClose() const
{
	::PostMessage(m_hWnd, PSM_CANCELTOCLOSE, UNUSED, UNUSED);
}

AFXINLINE void CPropSheet::Changed(HWND hPageDlg) const
{
	::SendMessage(m_hWnd, PSM_CHANGED, (WPARAM)hPageDlg, UNUSED);
}

AFXINLINE HWND CPropSheet::GetActivePage() const
{
	return (HWND)::SendMessage(m_hWnd, PSM_GETCURRENTPAGEHWND, UNUSED, UNUSED);
}

AFXINLINE HWND CPropSheet::GetPage(int iPage) const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, PSM_INDEXTOHWND, iPage, UNUSED));
}

AFXINLINE HPROPPAGE CPropSheet::GetPageHandle(int iPage) const
{
	return (HPROPPAGE)VERIFY(::SendMessage(m_hWnd, PSM_INDEXTOPAGE, iPage, UNUSED));
}

AFXINLINE UINT CPropSheet::GetPageId(int iPage) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_INDEXTOID, iPage, UNUSED));
}

AFXINLINE int CPropSheet::GetPageIndex(HPROPPAGE hPropPage) const
{
	return UNEQUAL(::SendMessage(m_hWnd, PSM_PAGETOINDEX, UNUSED, (LPARAM)hPropPage), RV_ERR);
}

AFXINLINE int CPropSheet::GetPageIndex(HWND hPageDlg) const
{
	return UNEQUAL(::SendMessage(m_hWnd, PSM_HWNDTOINDEX, (WPARAM)hPageDlg, UNUSED), RV_ERR);
}

AFXINLINE int CPropSheet::GetPageIndex(UINT nPageId) const
{
	return UNEQUAL(::SendMessage(m_hWnd, PSM_IDTOINDEX, UNUSED, nPageId), RV_ERR);
}

AFXINLINE int CPropSheet::GetResult() const
{
	return UNEQUAL(::SendMessage(m_hWnd, PSM_GETRESULT, UNUSED, UNUSED), RV_ERR);
}

AFXINLINE HWND CPropSheet::GetTabCtrl() const
{
	return (HWND)::SendMessage(m_hWnd, PSM_GETTABCONTROL, UNUSED, UNUSED);
}

AFXINLINE BOOL CPropSheet::InsertPage(HPROPPAGE hPropPage, HPROPPAGE hFrontPage) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_INSERTPAGE, (WPARAM)hPropPage, (LPARAM)hPropPage));
}

AFXINLINE BOOL CPropSheet::InsertPage(HPROPPAGE hPropPage, int iPage /* = 0 */) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_INSERTPAGE, iPage, (LPARAM)hPropPage));
}

AFXINLINE BOOL CPropSheet::IsDialogMessage(PCMSG pMsg) const
{
	return ::SendMessage(m_hWnd, PSM_ISDIALOGMESSAGE, UNUSED, (LPARAM)pMsg);
}

AFXINLINE void CPropSheet::PressButton(int iButton) const
{
	::PostMessage(m_hWnd, PSM_PRESSBUTTON, iButton, UNUSED);
}

AFXINLINE int CPropSheet::PropertySheet(PCPROPSHEET pPS)
{
	ASSERT(!_m_pWnd);
	_m_pWnd = this;
	return UNEQUAL(::PropertySheet(pPS), RV_ERR);
}

AFXINLINE int CALLBACK CPropSheet::PropSheetProc(HWND hSheetDlg, UINT nMsg, LPARAM lParam)
{
	if(nMsg == PSCB_INITIALIZED)
	{
		CPropSheet* pSheetDlg = (CPropSheet*)_m_pWnd;
		ASSERT_WRITE(pSheetDlg, sizeof(CPropSheet));
		pSheetDlg->m_hWnd = hSheetDlg;
		::SetWindowLong(hSheetDlg, GWL_USERDATA, (LONG)pSheetDlg);
		DEBUG_ONLY(_m_pWnd = NULL);
	}
	return RV_IGNORE;
}

AFXINLINE int CPropSheet::QuerySiblings(WPARAM wParam, LPARAM lParam) const
{
	return ::SendMessage(m_hWnd, PSM_QUERYSIBLINGS, wParam, lParam);
}

AFXINLINE void CPropSheet::RebootSystem() const
{
	::SendMessage(m_hWnd, PSM_REBOOTSYSTEM, UNUSED, UNUSED);
}

AFXINLINE BOOL CPropSheet::RecalcPageSizes() const
{
	::SendMessage(m_hWnd, PSM_RECALCPAGESIZES, UNUSED, UNUSED);
}

AFXINLINE void CPropSheet::RemovePage(HPROPPAGE hPropPage) const
{
	::SendMessage(m_hWnd, PSM_REMOVEPAGE, UNUSED, (LPARAM)hPropPage);
}

AFXINLINE void CPropSheet::RemovePage(int iPage) const
{
	::SendMessage(m_hWnd, PSM_REMOVEPAGE, iPage, UNUSED);
}

AFXINLINE void CPropSheet::RestartWindows() const
{
	::SendMessage(m_hWnd, PSM_RESTARTWINDOWS, UNUSED, UNUSED);
}

AFXINLINE BOOL CPropSheet::SetActivePage(HPROPPAGE hPropPage) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_SETCURSEL, UNUSED, (LPARAM)hPropPage));
}

AFXINLINE BOOL CPropSheet::SetActivePage(int iPage) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_SETCURSEL, iPage, UNUSED));
}

AFXINLINE BOOL CPropSheet::SetCurSel(UINT nPageId) const
{
	return VERIFY(::SendMessage(m_hWnd, PSM_SETCURSELID, UNUSED, nPageId));
}

AFXINLINE void CPropSheet::SetFinishText(PCTSTR pszText) const
{
	::SendMessage(m_hWnd, PSM_SETFINISHTEXT, UNUSED, (LPARAM)pszText);
}

AFXINLINE void CPropSheet::SetHeaderSubtitle(int iPage, PCTSTR pszText) const
{
	::SendMessage(m_hWnd, PSM_SETHEADERSUBTITLE, iPage, (LPARAM)pszText);
}

AFXINLINE void CPropSheet::SetHeaderTitle(int iPage, PCTSTR pszText) const
{
	::SendMessage(m_hWnd, PSM_SETHEADERTITLE, iPage, (LPARAM)pszText);
}

AFXINLINE void CPropSheet::SetTitle(PCTSTR pszText, UINT nFlag /* = PSH_PROPTITLE */) const
{
	::SendMessage(m_hWnd, PSM_SETTITLE, nFlag, (LPARAM)pszText);
}

AFXINLINE void CPropSheet::SetTitle(UINT nTextId, UINT nFlag /* = PSH_PROPTITLE */) const
{
	::SendMessage(m_hWnd, PSM_SETTITLE, nFlag, nTextId);
}

AFXINLINE void CPropSheet::SetWizButtons(UINT nFlags) const
{
	::PostMessage(m_hWnd, PSM_SETWIZBUTTONS, UNUSED, nFlags);
}

AFXINLINE void CPropSheet::Unchanged(HWND hPageDlg) const
{
	::SendMessage(m_hWnd, PSM_UNCHANGED, (WPARAM)hPageDlg, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CRebar

#define ON_RBN_AUTOSIZE(fName)      _ON_NOTIFY_V(RBN_AUTOSIZE, fName, PCNMRBAUTOSIZE)
#define ON_RBN_BEGINDRAG(fName)     _ON_NOTIFY_R(RBN_BEGINDRAG, fName, PCNMREBAR)
#define ON_RBN_CHEVRONPUSHED(fName) _ON_NOTIFY_V(RBN_CHEVRONPUSHED, fName, PCNMREBARCHEVRON)
#define ON_RBN_CHILDSIZE(fName)     _ON_NOTIFY_V(RBN_CHILDSIZE, fName, PNMREBARCHILDSIZE)
#define ON_RBN_DELETEDBAND(fName)   _ON_NOTIFY_V(RBN_DELETEDBAND, fName, PCNMREBAR)
#define ON_RBN_DELETINGBAND(fName)  _ON_NOTIFY_V(RBN_DELETINGBAND, fName, PCNMREBAR)
#define ON_RBN_ENDDRAG(fName)       _ON_NOTIFY_V(RBN_ENDDRAG, fName, PCNMREBAR)
#define ON_RBN_GETOBJECT(fName)     _ON_NOTIFY_V(RBN_GETOBJECT, fName, PNMOBJECTNOTIFY)
#define ON_RBN_HEIGHTCHANGE(fName)  _ON_NOTIFY_V(RBN_HEIGHTCHANGE, fName, PCNMHDR)
#define ON_RBN_LAYOUTCHANGED(fName) _ON_NOTIFY_V(RBN_LAYOUTCHANGED, fName, PCNMHDR)
#define ON_RBN_MINMAX(fName)        _ON_NOTIFY_R(RBN_MINMAX, fName, PCNMHDR)

class CRebar : public CWnd
{
public:
	CRebar();
	CRebar(HWND hRebar);
	void operator =(HWND hRebar);
	BOOL AppendBand(PCREBARBANDINFO pRBI) const;
	void BeginDrag(int iBand, DWORD dwPos = MAX_DWORD) const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nRebarId);
	BOOL DeleteBand(int iBand) const;
	void DragMove(DWORD dwPos = MAX_DWORD) const;
	void EndDrag() const;
	void GetBandBorders(int iBand, PRECT pRect) const;
	int GetBandCount() const;
	int GetBandIndex(UINT nBandId) const;
	BOOL GetBandInfo(int iBand, PREBARBANDINFO pRBI) const;
	BOOL GetBandRect(int iBand, PRECT pRect) const;
	int GetBarHeight() const;
	BOOL GetBarInfo(PREBARINFO pRI) const;
	COLORREF GetBkColor() const;
	BOOL GetColorScheme(PCOLORSCHEME pCS) const;
	void GetDropTarget(IDropTarget** ppDT) const;
	HPALETTE GetPalette() const;
	int GetRowCount() const;
	int GetRowHeight(int iBand) const;
	COLORREF GetTextColor() const;
	HWND GetTooltips() const;
	BOOL GetUnicodeFormat() const;
	BOOL HideBand(int iBand) const;
	int HitTest(PRBHITTESTINFO pRHTI) const;
	BOOL InsertBand(int iBand, PCREBARBANDINFO pRBI) const;
	BOOL InsertBand(PCREBARBANDINFO pRBI) const;
	BOOL Layout(PCRECT pRect) const;
	void MaximizeBand(int iBand, BOOL bIdeal) const;
	void MinimizeBand(int iBand) const;
	BOOL MoveBand(int iBand, int iNew) const;
	void PushChevron(int iBand, LPARAM lParamNM) const;
	BOOL SetBandInfo(int iBand, PCREBARBANDINFO pRBI) const;
	BOOL SetBarInfo(PCREBARINFO pRI) const;
	COLORREF SetBkColor(COLORREF crValue) const;
	void SetColorScheme(PCCOLORSCHEME pCS) const;
	HPALETTE SetPalette(HPALETTE hPalette) const;
	HWND SetParent(HWND hWnd) const;
	COLORREF SetTextColor(COLORREF crValue) const;
	void SetTooltips(HWND hTooltip) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
	BOOL ShowBand(int iBand) const;
};

AFXINLINE CRebar::CRebar()
{
	// Does nothing
}

AFXINLINE CRebar::CRebar(HWND hRebar)
{
	m_hWnd = hRebar;
}

AFXINLINE void CRebar::operator =(HWND hRebar)
{
	m_hWnd = hRebar;
}

AFXINLINE BOOL CRebar::AppendBand(PCREBARBANDINFO pRBI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_INSERTBAND, -1, (LPARAM)pRBI));
}

AFXINLINE void CRebar::BeginDrag(int iBand, DWORD dwPos /* = MAX_DWORD */) const
{
	::SendMessage(m_hWnd, RB_BEGINDRAG, iBand, dwPos);
}

AFXINLINE BOOL CRebar::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nRebarId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_REBAR, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nRebarId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CRebar::DeleteBand(int iBand) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_DELETEBAND, iBand, UNUSED));
}

AFXINLINE void CRebar::DragMove(DWORD dwPos /* = MAX_DWORD */) const
{
	::SendMessage(m_hWnd, RB_DRAGMOVE, UNUSED, dwPos);
}

AFXINLINE void CRebar::EndDrag() const
{
	::SendMessage(m_hWnd, RB_ENDDRAG, UNUSED, UNUSED);
}

AFXINLINE void CRebar::GetBandBorders(int iBand, PRECT pRect) const
{
	::SendMessage(m_hWnd, RB_GETBANDBORDERS, iBand, (LPARAM)pRect);
}

AFXINLINE int CRebar::GetBandCount() const
{
	return ::SendMessage(m_hWnd, RB_GETBANDCOUNT, UNUSED, UNUSED);
}

AFXINLINE int CRebar::GetBandIndex(UINT nBandId) const
{
	return UNEQUAL(::SendMessage(m_hWnd, RB_IDTOINDEX, nBandId, UNUSED), RV_ERR);
}

AFXINLINE BOOL CRebar::GetBandInfo(int iBand, PREBARBANDINFO pRBI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_GETBANDINFO, iBand, (LPARAM)pRBI));
}

AFXINLINE BOOL CRebar::GetBandRect(int iBand, PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_GETRECT, iBand, (LPARAM)pRect));
}

AFXINLINE int CRebar::GetBarHeight() const
{
	return ::SendMessage(m_hWnd, RB_GETBARHEIGHT, UNUSED, UNUSED);
}

AFXINLINE BOOL CRebar::GetBarInfo(PREBARINFO pRI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_GETBARINFO, UNUSED, (LPARAM)pRI));
}

AFXINLINE COLORREF CRebar::GetBkColor() const
{
	return ::SendMessage(m_hWnd, RB_GETBKCOLOR, UNUSED, UNUSED);
}

AFXINLINE BOOL CRebar::GetColorScheme(PCOLORSCHEME pCS) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_GETCOLORSCHEME, UNUSED, (LPARAM)pCS));
}

AFXINLINE void CRebar::GetDropTarget(IDropTarget** ppDT) const
{
	::SendMessage(m_hWnd, RB_GETDROPTARGET, UNUSED, (LPARAM)ppDT);
}

AFXINLINE HPALETTE CRebar::GetPalette() const
{
	return (HPALETTE)::SendMessage(m_hWnd, RB_GETPALETTE, UNUSED, UNUSED);
}

AFXINLINE int CRebar::GetRowCount() const
{
	return ::SendMessage(m_hWnd, RB_GETROWCOUNT, UNUSED, UNUSED);
}

AFXINLINE int CRebar::GetRowHeight(int iBand) const
{
	return ::SendMessage(m_hWnd, RB_GETROWHEIGHT, iBand, UNUSED);
}

AFXINLINE COLORREF CRebar::GetTextColor() const
{
	return ::SendMessage(m_hWnd, RB_GETTEXTCOLOR, UNUSED, UNUSED);
}

AFXINLINE HWND CRebar::GetTooltips() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, RB_GETTOOLTIPS, UNUSED, UNUSED));
}

AFXINLINE BOOL CRebar::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, RB_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE BOOL CRebar::HideBand(int iBand) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_SHOWBAND, iBand, FALSE));
}

AFXINLINE int CRebar::HitTest(PRBHITTESTINFO pRHTI) const
{
	return ::SendMessage(m_hWnd, RB_HITTEST, UNUSED, (LPARAM)pRHTI);
}

AFXINLINE BOOL CRebar::InsertBand(int iBand, PCREBARBANDINFO pRBI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_INSERTBAND, iBand, (LPARAM)pRBI));
}

AFXINLINE BOOL CRebar::InsertBand(PCREBARBANDINFO pRBI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_INSERTBAND, -1, (LPARAM)pRBI));
}

AFXINLINE BOOL CRebar::Layout(PCRECT pRect) const
{
	return ::SendMessage(m_hWnd, RB_SIZETORECT, UNUSED, (LPARAM)pRect);
}

AFXINLINE void CRebar::MaximizeBand(int iBand, BOOL bIdeal) const
{
	::SendMessage(m_hWnd, RB_MAXIMIZEBAND, iBand, bIdeal);
}

AFXINLINE void CRebar::MinimizeBand(int iBand) const
{
	::SendMessage(m_hWnd, RB_MINIMIZEBAND, iBand, UNUSED);
}

AFXINLINE BOOL CRebar::MoveBand(int iBand, int iNew) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_MOVEBAND, iBand, iNew));
}

AFXINLINE void CRebar::PushChevron(int iBand, LPARAM lParamNM) const
{
	::SendMessage(m_hWnd, RB_PUSHCHEVRON, iBand, lParamNM);
}

AFXINLINE BOOL CRebar::SetBandInfo(int iBand, PCREBARBANDINFO pRBI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_SETBANDINFO, iBand, (LPARAM)pRBI));
}

AFXINLINE BOOL CRebar::SetBarInfo(PCREBARINFO pRI) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_SETBARINFO, UNUSED, (LPARAM)pRI));
}

AFXINLINE COLORREF CRebar::SetBkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, RB_SETBKCOLOR, UNUSED, crValue);
}

AFXINLINE void CRebar::SetColorScheme(PCCOLORSCHEME pCS) const
{
	::SendMessage(m_hWnd, RB_SETCOLORSCHEME, UNUSED, (LPARAM)pCS);
}

AFXINLINE HPALETTE CRebar::SetPalette(HPALETTE hPalette) const
{
	return (HPALETTE)::SendMessage(m_hWnd, RB_SETPALETTE, UNUSED, (LPARAM)hPalette);
}

AFXINLINE HWND CRebar::SetParent(HWND hWnd) const
{
	return (HWND)::SendMessage(m_hWnd, RB_SETPARENT, (WPARAM)hWnd, UNUSED);
}

AFXINLINE COLORREF CRebar::SetTextColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, RB_SETTEXTCOLOR, UNUSED, crValue);
}

AFXINLINE void CRebar::SetTooltips(HWND hTooltip) const
{
	::SendMessage(m_hWnd, RB_SETTOOLTIPS, (WPARAM)hTooltip, UNUSED);
}

AFXINLINE BOOL CRebar::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, RB_SETUNICODEFORMAT, bUnicode, UNUSED);
}

AFXINLINE BOOL CRebar::ShowBand(int iBand) const
{
	return VERIFY(::SendMessage(m_hWnd, RB_SHOWBAND, iBand, TRUE));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CStatusBar

#define ON_SBN_SIMPLEMODECHANGE(fName) _ON_NOTIFY_V(SBN_SIMPLEMODECHANGE, fName, PCNMHDR)

class CStatusBar : public CWnd
{
public:
	CStatusBar();
	CStatusBar(HWND hStatusBar);
	void operator =(HWND hStatusBar);
	void AutoSize() const;
	BOOL CreateWindow(DWORD dwStyle, PCTSTR pszText, HWND hParentWnd, UINT nStatusBarId);
	BOOL CreateWindow(PCTSTR pszText, DWORD dwStyle, HWND hParentWnd, UINT nStatusBarId);
	BOOL GetBorders(PINT piaBorder) const;
	HICON GetIcon(int iPart = -1) const;
	int GetParts(PINT piaRightPos = NULL, int ceRightPos = UNUSED) const;
	BOOL GetRect(int iPart, PRECT pRect) const;
	DWORD GetText(int iPart, PTSTR pszBuffer) const;
	DWORD GetTextLength(int iPart) const;
	void GetTipText(int iPart, PTSTR pszBuffer, int ccBuffer) const;
	BOOL GetUnicodeFormat() const;
	BOOL IsSimple() const;
	void MenuHelp(WPARAM wParam, LPARAM lParam, HMENU hMenu, HINSTANCE hInstance,
		PVOID pvMH) const;
	void MenuHelp(UINT nItemId, UINT nFlags, HMENU hMenu, HINSTANCE hInstance) const;
	COLORREF SetBkColor(COLORREF crValue) const;
	BOOL SetIcon(int iPart, HICON hIcon = NULL) const;
	BOOL SetIcon(HICON hIcon = NULL) const;
	void SetMinHeight(int iHeight) const;
	BOOL SetParts(PCINT piaRightPos, int ceRightPos) const;
	BOOL SetText(int iPart, PCTSTR pszText, UINT nType = UNUSED) const;
	BOOL SetText(PCTSTR pszText, UINT nType = UNUSED) const;
	void SetTipText(int iPart, PCTSTR pszText) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
	void Simple(BOOL bSimple = TRUE) const;
};

AFXINLINE CStatusBar::CStatusBar()
{
	// Does nothing
}

AFXINLINE CStatusBar::CStatusBar(HWND hStatusBar)
{
	m_hWnd = hStatusBar;
}

AFXINLINE void CStatusBar::operator =(HWND hStatusBar)
{
	m_hWnd = hStatusBar;
}

AFXINLINE void CStatusBar::AutoSize() const
{
	::SendMessage(m_hWnd, WM_SIZE, UNUSED, UNUSED);
}

AFXINLINE BOOL CStatusBar::CreateWindow(DWORD dwStyle, PCTSTR pszText,
	HWND hParentWnd, UINT nStatusBarId)
{
	m_hWnd = ::CreateStatusWindow(dwStyle, pszText, hParentWnd, nStatusBarId);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CStatusBar::CreateWindow(PCTSTR pszText, DWORD dwStyle,
	HWND hParentWnd, UINT nStatusBarId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_STATUSBAR, pszText, dwStyle,
		0, 0, 0, 0, hParentWnd, (HMENU)nStatusBarId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CStatusBar::GetBorders(PINT piaBorder) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_GETBORDERS, UNUSED, (LPARAM)piaBorder));
}

AFXINLINE HICON CStatusBar::GetIcon(int iPart /* = -1 */) const
{
	return (HICON)::SendMessage(m_hWnd, SB_GETICON, iPart, UNUSED);
}

AFXINLINE int CStatusBar::GetParts(PINT piaRightPos /* = NULL */,
	int ceRightPos /* = UNUSED */) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_GETPARTS, ceRightPos, (LPARAM)piaRightPos));
}

AFXINLINE BOOL CStatusBar::GetRect(int iPart, PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_GETRECT, iPart, (LPARAM)pRect));
}

AFXINLINE DWORD CStatusBar::GetText(int iPart, PTSTR pszBuffer) const
{
	return ::SendMessage(m_hWnd, SB_GETTEXT, iPart, (LPARAM)pszBuffer);
}

AFXINLINE DWORD CStatusBar::GetTextLength(int iPart) const
{
	return ::SendMessage(m_hWnd, SB_GETTEXTLENGTH, iPart, UNUSED);
}

AFXINLINE void CStatusBar::GetTipText(int iPart, PTSTR pszBuffer, int ccBuffer) const
{
	::SendMessage(m_hWnd, SB_GETTIPTEXT, MAKEWPARAM(iPart, ccBuffer), (LPARAM)pszBuffer);
}

AFXINLINE BOOL CStatusBar::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, SB_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE BOOL CStatusBar::IsSimple() const
{
	return ::SendMessage(m_hWnd, SB_ISSIMPLE, UNUSED, UNUSED);
}

AFXINLINE void CStatusBar::MenuHelp(WPARAM wParam, LPARAM lParam, HMENU hMenu,
	HINSTANCE hInstance, PVOID pvMH) const
{
	::MenuHelp(WM_MENUSELECT, wParam, lParam, hMenu, hInstance, m_hWnd, (PUINT)pvMH);
}

AFXINLINE void CStatusBar::MenuHelp(UINT nItemId, UINT nFlags, HMENU hMenu,
	HINSTANCE hInstance) const
{
	UINT nDummy = 0;
	::MenuHelp(WM_MENUSELECT, MAKEWPARAM(nItemId, nFlags), (LPARAM)hMenu, NULL,
		hInstance, m_hWnd, &nDummy);
}

AFXINLINE COLORREF CStatusBar::SetBkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, SB_SETBKCOLOR, UNUSED, crValue);
}

AFXINLINE BOOL CStatusBar::SetIcon(int iPart, HICON hIcon /* = NULL */) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_SETICON, iPart, (LPARAM)hIcon));
}

AFXINLINE BOOL CStatusBar::SetIcon(HICON hIcon /* = NULL */) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_SETICON, -1, (LPARAM)hIcon));
}

AFXINLINE void CStatusBar::SetMinHeight(int iHeight) const
{
	::SendMessage(m_hWnd, SB_SETMINHEIGHT, iHeight, UNUSED);
}

AFXINLINE BOOL CStatusBar::SetParts(PCINT piaRightPos, int ceRightPos) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_SETPARTS, ceRightPos, (LPARAM)piaRightPos));
}

AFXINLINE BOOL CStatusBar::SetText(int iPart, PCTSTR pszText, UINT nType /* = UNUSED */) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_SETTEXT, iPart | nType, (LPARAM)pszText));
}

AFXINLINE BOOL CStatusBar::SetText(PCTSTR pszText, UINT nType /* = UNUSED */) const
{
	return VERIFY(::SendMessage(m_hWnd, SB_SETTEXT, SB_SIMPLEID | nType, (LPARAM)pszText));
}

AFXINLINE void CStatusBar::SetTipText(int iPart, PCTSTR pszText) const
{
	::SendMessage(m_hWnd, SB_SETTIPTEXT, iPart, (LPARAM)pszText);
}

AFXINLINE BOOL CStatusBar::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, SB_SETUNICODEFORMAT, bUnicode, UNUSED);
}

AFXINLINE void CStatusBar::Simple(BOOL bSimple /* = TRUE */) const
{
	::SendMessage(m_hWnd, SB_SIMPLE, bSimple, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CTabCtrl

#define ON_TCN_FOCUSCHANGE(fName) _ON_NOTIFY_V(TCN_FOCUSCHANGE, fName, PCNMHDR)
#define ON_TCN_GETOBJECT(fName)   _ON_NOTIFY_V(TCN_GETOBJECT, fName, PNMOBJECTNOTIFY)
#define ON_TCN_KEYDOWN(fName)     _ON_NOTIFY_V(TCN_KEYDOWN, fName, PCNMTCKEYDOWN)
#define ON_TCN_SELCHANGE(fName)   _ON_NOTIFY_V(TCN_SELCHANGE, fName, PCNMHDR)
#define ON_TCN_SELCHANGING(fName) _ON_NOTIFY_R(TCN_SELCHANGING, fName, PCNMHDR)

class CTabCtrl : public CWnd
{
public:
	CTabCtrl();
	CTabCtrl(HWND hTabCtrl);
	void operator =(HWND hTabCtrl);
	void AdjustRect(PRECT pRect, BOOL bDispRect) const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nTabCtrlId);
	BOOL DeleteAllItems() const;
	BOOL DeleteItem(int iItem) const;
	void DeselectAll(BOOL bExcCurSel = FALSE) const;
	int GetCurFocus() const;
	int GetCurSel() const;
	DWORD GetExStyle() const;
	HIMAGELIST GetImageList() const;
	BOOL GetItem(int iItem, PTCITEM pTCI) const;
	int GetItemCount() const;
	BOOL GetItemRect(int iItem, PRECT pRect) const;
	int GetRowCount() const;
	HWND GetTooltips() const;
	BOOL GetUnicodeFormat() const;
	BOOL HighlightItem(int iItem, BOOL bHighlight = TRUE) const;
	int HitTest(PTCHITTESTINFO pTCHTI) const;
	int InsertItem(int iItem, PCTCITEM pTCI) const;
	void RemoveImage(int iImage) const;
	void SetCurFocus(int iItem) const;
	int SetCurSel(int iItem) const;
	DWORD SetExStyle(DWORD dwStyle, DWORD dwMask = UNUSED) const;
	HIMAGELIST SetImageList(HIMAGELIST hImageList) const;
	BOOL SetItem(int iItem, PCTCITEM pTCI) const;
	BOOL SetItemExtra(int cbExtra) const;
	DWORD SetItemSize(int iWidth, int iHeight) const;
	int SetMinItemWidth(int iWidth = -1) const;
	void SetPadding(int cxAmount, int cyAmount) const;
	void SetTooltips(HWND hTooltip) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
};

AFXINLINE CTabCtrl::CTabCtrl()
{
	// Does nothing
}

AFXINLINE CTabCtrl::CTabCtrl(HWND hTabCtrl)
{
	m_hWnd = hTabCtrl;
}

AFXINLINE void CTabCtrl::operator =(HWND hTabCtrl)
{
	m_hWnd = hTabCtrl;
}

AFXINLINE void CTabCtrl::AdjustRect(PRECT pRect, BOOL bDispRect) const
{
	::SendMessage(m_hWnd, TCM_ADJUSTRECT, bDispRect, (LPARAM)pRect);
}

AFXINLINE BOOL CTabCtrl::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nTabCtrlId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_TABCTRL, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nTabCtrlId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CTabCtrl::DeleteAllItems() const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_DELETEALLITEMS, UNUSED, UNUSED));
}

AFXINLINE BOOL CTabCtrl::DeleteItem(int iItem) const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_DELETEITEM, iItem, UNUSED));
}

AFXINLINE void CTabCtrl::DeselectAll(BOOL bExcCurSel /* = FALSE */) const
{
	::SendMessage(m_hWnd, TCM_DESELECTALL, bExcCurSel, UNUSED);
}

AFXINLINE int CTabCtrl::GetCurFocus() const
{
	return ::SendMessage(m_hWnd, TCM_GETCURFOCUS, UNUSED, UNUSED);
}

AFXINLINE int CTabCtrl::GetCurSel() const
{
	return ::SendMessage(m_hWnd, TCM_GETCURSEL, UNUSED, UNUSED);
}

AFXINLINE DWORD CTabCtrl::GetExStyle() const
{
	return ::SendMessage(m_hWnd, TCM_GETEXTENDEDSTYLE, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CTabCtrl::GetImageList() const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, TCM_GETIMAGELIST, UNUSED, UNUSED));
}

AFXINLINE BOOL CTabCtrl::GetItem(int iItem, PTCITEM pTCI) const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_GETITEM, iItem, (LPARAM)pTCI));
}

AFXINLINE int CTabCtrl::GetItemCount() const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_GETITEMCOUNT, UNUSED, UNUSED));
}

AFXINLINE BOOL CTabCtrl::GetItemRect(int iItem, PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_GETITEMRECT, iItem, (LPARAM)pRect));
}

AFXINLINE int CTabCtrl::GetRowCount() const
{
	return ::SendMessage(m_hWnd, TCM_GETROWCOUNT, UNUSED, UNUSED);
}

AFXINLINE HWND CTabCtrl::GetTooltips() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, TCM_GETTOOLTIPS, UNUSED, UNUSED));
}

AFXINLINE BOOL CTabCtrl::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, TCM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE BOOL CTabCtrl::HighlightItem(int iItem, BOOL bHighlight /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_HIGHLIGHTITEM, iItem, bHighlight));
}

AFXINLINE int CTabCtrl::HitTest(PTCHITTESTINFO pTCHTI) const
{
	return ::SendMessage(m_hWnd, TCM_HITTEST, UNUSED, (LPARAM)pTCHTI);
}

AFXINLINE int CTabCtrl::InsertItem(int iItem, PCTCITEM pTCI) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TCM_INSERTITEM, iItem, (LPARAM)pTCI), RV_ERR);
}

AFXINLINE void CTabCtrl::RemoveImage(int iImage) const
{
	::SendMessage(m_hWnd, TCM_REMOVEIMAGE, iImage, UNUSED);
}

AFXINLINE void CTabCtrl::SetCurFocus(int iItem) const
{
	::SendMessage(m_hWnd, TCM_SETCURFOCUS, iItem, UNUSED);
}

AFXINLINE int CTabCtrl::SetCurSel(int iItem) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TCM_SETCURSEL, iItem, UNUSED), RV_ERR);
}

AFXINLINE DWORD CTabCtrl::SetExStyle(DWORD dwStyle, DWORD dwMask /* = UNUSED */) const
{
	return ::SendMessage(m_hWnd, TCM_SETEXTENDEDSTYLE, dwMask, dwStyle);
}

AFXINLINE HIMAGELIST CTabCtrl::SetImageList(HIMAGELIST hImageList) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TCM_SETIMAGELIST, UNUSED, (LPARAM)hImageList);
}

AFXINLINE BOOL CTabCtrl::SetItem(int iItem, PCTCITEM pTCI) const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_SETITEM, iItem, (LPARAM)pTCI));
}

AFXINLINE BOOL CTabCtrl::SetItemExtra(int cbExtra) const
{
	return VERIFY(::SendMessage(m_hWnd, TCM_SETITEMEXTRA, cbExtra, UNUSED));
}

AFXINLINE DWORD CTabCtrl::SetItemSize(int iWidth, int iHeight) const
{
	return ::SendMessage(m_hWnd, TCM_SETITEMSIZE, UNUSED, MAKELPARAM(iWidth, iHeight));
}

AFXINLINE int CTabCtrl::SetMinItemWidth(int iWidth /* = -1 */) const
{
	return ::SendMessage(m_hWnd, TCM_SETMINTABWIDTH, UNUSED, iWidth);
}

AFXINLINE void CTabCtrl::SetPadding(int cxAmount, int cyAmount) const
{
	::SendMessage(m_hWnd, TCM_SETPADDING, UNUSED, MAKELPARAM(cxAmount, cyAmount));
}

AFXINLINE void CTabCtrl::SetTooltips(HWND hTooltip) const
{
	::SendMessage(m_hWnd, TCM_SETTOOLTIPS, (WPARAM)hTooltip, UNUSED);
}

AFXINLINE BOOL CTabCtrl::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, TCM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CToolbar

// A toolbar is about to be drawn
// UINT OnNmCustomDrawTB(PNMTBCUSTOMDRAW pNMTBCD);
// Returns: Result value of the message processed
#define ON_NM_CUSTOMDRAWTB(fName) _ON_NOTIFY_R(NM_CUSTOMDRAW, fName, PNMTBCUSTOMDRAW)

#define ON_TBN_BEGINADJUST(fName)    _ON_NOTIFY_V(TBN_BEGINADJUST, fName, PCNMHDR)
#define ON_TBN_BEGINDRAG(fName)      _ON_NOTIFY_V(TBN_BEGINDRAG, fName, PCNMTOOLBAR)
#define ON_TBN_CUSTHELP(fName)       _ON_NOTIFY_V(TBN_CUSTHELP, fName, PCNMHDR)
#define ON_TBN_DELETINGBUTTON(fName) _ON_NOTIFY_V(TBN_DELETINGBUTTON, fName, PCNMTOOLBAR)
#define ON_TBN_DRAGOUT(fName)        _ON_NOTIFY_V(TBN_DRAGOUT, fName, PCNMTOOLBAR)
#define ON_TBN_DROPDOWN(fName)       _ON_NOTIFY_R(TBN_DROPDOWN, fName, PCNMTOOLBAR)
#define ON_TBN_ENDADJUST(fName)      _ON_NOTIFY_V(TBN_ENDADJUST, fName, PCNMHDR)
#define ON_TBN_ENDDRAG(fName)        _ON_NOTIFY_V(TBN_ENDDRAG, fName, PCNMTOOLBAR)
#define ON_TBN_GETBUTTONINFO(fName)  _ON_NOTIFY_R(TBN_GETBUTTONINFO, fName, PNMTOOLBAR)
#define ON_TBN_GETDISPINFO(fName)    _ON_NOTIFY_V(TBN_GETDISPINFO, fName, PNMTBDISPINFO)
#define ON_TBN_GETINFOTIP(fName)     _ON_NOTIFY_V(TBN_GETINFOTIP, fName, PNMTBGETINFOTIP)
#define ON_TBN_GETOBJECT(fName)      _ON_NOTIFY_V(TBN_GETOBJECT, fName, PNMOBJECTNOTIFY)
#define ON_TBN_HOTITEMCHANGE(fName)  _ON_NOTIFY_R(TBN_HOTITEMCHANGE, fName, PCNMTBHOTITEM)
#define ON_TBN_INITCUSTOMIZE(fName)  _ON_NOTIFY_R(TBN_INITCUSTOMIZE, fName, PCNMHDR)
#define ON_TBN_QUERYDELETE(fName)    _ON_NOTIFY_R(TBN_QUERYDELETE, fName, PCNMTOOLBAR)
#define ON_TBN_QUERYINSERT(fName)    _ON_NOTIFY_R(TBN_QUERYINSERT, fName, PCNMTOOLBAR)
#define ON_TBN_RESET(fName)          _ON_NOTIFY_V(TBN_RESET, fName, PCNMHDR)
#define ON_TBN_RESTORE(fName)        _ON_NOTIFY_V(TBN_RESTORE, fName, PNMTBRESTORE)
#define ON_TBN_SAVE(fName)           _ON_NOTIFY_V(TBN_SAVE, fName, PNMTBSAVE)
#define ON_TBN_TOOLBARCHANGE(fName)  _ON_NOTIFY_V(TBN_TOOLBARCHANGE, fName, PCNMHDR)

class CToolbar : public CWnd
{
public:
	CToolbar();
	CToolbar(HWND hToolbar);
	void operator =(HWND hToolbar);
	int AddBitmap(PCTBADDBITMAP pTBAB, int ceImage = UNUSED) const;
	BOOL AddButtons(PCTBBUTTON pTBB, int ceTBB) const;
	int AddString(HINSTANCE hInstance, UINT nStringId) const;
	int AddString(PCTSTR pszaString) const;
	void AutoSize() const;
	int ButtonCount() const;
	void ButtonStructSize() const;
	BOOL ChangeBitmap(UINT nCmdId, int iImage) const;
	BOOL CheckButton(UINT nCmdId, BOOL bCheck = TRUE) const;
	int CommandToIndex(UINT nCmdId) const;
	BOOL CreateWindow(HWND hParentWnd, DWORD dwStyle, UINT nToolbarId, int ceImage,
		HINSTANCE hInstance, UINT nBitmapId, PCTBBUTTON paTBB, int ceTBB,
		int cxButton, int cyButton, int cxIamge, int cyIamge);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nToolbarId);
	BOOL CreateWindow(DWORD dwStyle, HWND hParentWnd, UINT nToolbarId);
	void Customize() const;
	BOOL DeleteButton(int iButton) const;
	BOOL EnableButton(UINT nCmdId, BOOL bEnable = TRUE) const;
	BOOL GetAnchorHighlight() const;
	int GetBitmap(UINT nCmdId) const;
	DWORD GetBitmapFlags() const;
	BOOL GetButton(int iButton, PTBBUTTON pTBB) const;
	int GetButtonInfo(UINT nCmdId, PTBBUTTONINFO pTBBI) const;
	DWORD GetButtonSize() const;
	int GetButtonText(UINT nCmdId, PTSTR pszBuffer) const;
	BOOL GetColorScheme(PCOLORSCHEME pCS) const;
	HIMAGELIST GetDisabledImageList() const;
	DWORD GetExStyle() const;
	HIMAGELIST GetHotImageList() const;
	int GetHotItem() const;
	HIMAGELIST GetImageList() const;
	void GetInsertMark(PTBINSERTMARK pTBIM) const;
	COLORREF GetInsertMarkColor() const;
	BOOL GetItemRect(int iButton, PRECT pRect) const;
	BOOL GetMaxSize(PSIZE pSize) const;
	void GetMetrics(PTBMETRICS pTBM) const;
	HRESULT GetObject(IDropTarget** ppDT) const;
	DWORD GetPadding() const;
	BOOL GetRect(UINT nCmdId, PRECT pRect) const;
	int GetRows() const;
	int GetState(UINT nCmdId) const;
	int GetString(int iString, PTSTR pszBuffer, int ccBuffer) const;
	DWORD GetStyle() const;
	int GetTextRows() const;
	HWND GetTooltips() const;
	BOOL GetUnicodeFormat() const;
	int GetVersion() const;
	BOOL HideButton(UINT nCmdId, BOOL bHide = TRUE) const;
	int HitTest(PCPOINT pPoint) const;
	BOOL Indeterminate(UINT nCmdId, BOOL bIndeterminate = TRUE) const;
	BOOL InsertButton(int iButton, PCTBBUTTON pTBB) const;
	BOOL InsertMarkHitTest(PCPOINT pPoint, PTBINSERTMARK pTBIM) const;
	BOOL IsButtonChecked(UINT nCmdId) const;
	BOOL IsButtonEnabled(UINT nCmdId) const;
	BOOL IsButtonHidden(UINT nCmdId) const;
	BOOL IsButtonHighlighted(UINT nCmdId) const;
	BOOL IsButtonIndeterminate(UINT nCmdId) const;
	BOOL IsButtonPressed(UINT nCmdId) const;
	int LoadImages(UINT nBitmapId, HINSTANCE hInstance = HINST_COMMCTRL) const;
	BOOL MapAccelerator(TCHAR cAccel, PUINT pnCmdId) const;
	BOOL MarkButton(UINT nCmdId, BOOL bMark = TRUE) const;
	BOOL MoveButton(int iOldPos, int iNewPos) const;
	BOOL PressButton(UINT nCmdId, BOOL bPress = TRUE) const;
	BOOL ReplaceBitmap(PCTBREPLACEBITMAP pTBRB) const;
	void Restore(PCTBSAVEPARAMS pTBSP) const;
	void Save(PCTBSAVEPARAMS pTBSP) const;
	BOOL SetAnchorHighlight(BOOL bEnable = TRUE) const;
	BOOL SetBitmapSize(int cxImage, int cyImage) const;
	BOOL SetButtonInfo(UINT nCmdId, PCTBBUTTONINFO pTBBI) const;
	BOOL SetButtonSize(int cxButton, int cyButton) const;
	BOOL SetButtonWidth(int cxMin, int cxMax) const;
	BOOL SetCmdId(int iButton, UINT nCmdId) const;
	void SetColorScheme(PCCOLORSCHEME pCS) const;
	HIMAGELIST SetDisabledImageList(HIMAGELIST hImageList) const;
	UINT SetDrawTextFlags(UINT nMask, UINT nFlags) const;
	DWORD SetExStyle(DWORD dwStyle) const;
	HIMAGELIST SetHotImageList(HIMAGELIST hImageList) const;
	int SetHotItem(int iItem = -1) const;
	HIMAGELIST SetImageList(HIMAGELIST hImageList, UINT nListId = 0) const;
	BOOL SetIndent(int cxIndent) const;
	void SetInsertMark(PCTBINSERTMARK pTBIM) const;
	COLORREF SetInsertMarkColor(COLORREF crValue) const;
	BOOL SetMaxTextRows(int ceRow) const;
	void SetMetrics(PCTBMETRICS pTBM) const;
	DWORD SetPadding(int cxAmount, int cyAmount) const;
	HWND SetParent(HWND hWnd) const;
	void SetRows(int ceRow, PRECT pRect, BOOL bMore = TRUE) const;
	BOOL SetState(UINT nCmdId, UINT nState) const;
	void SetStyle(DWORD dwStyle) const;
	void SetTooltips(HWND hTooltip) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
	int SetVersion(int iVersion) const;
};

AFXINLINE CToolbar::CToolbar()
{
	// Does nothing
}

AFXINLINE CToolbar::CToolbar(HWND hToolbar)
{
	m_hWnd = hToolbar;
}

AFXINLINE void CToolbar::operator =(HWND hToolbar)
{
	m_hWnd = hToolbar;
}

AFXINLINE int CToolbar::AddBitmap(PCTBADDBITMAP pTBAB, int ceImage /* = UNUSED */) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_ADDBITMAP, ceImage, (LPARAM)pTBAB), RV_ERR);
}

AFXINLINE BOOL CToolbar::AddButtons(PCTBBUTTON pTBB, int ceTBB) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_ADDBUTTONS, ceTBB, (LPARAM)pTBB));
}

AFXINLINE int CToolbar::AddString(HINSTANCE hInstance, UINT nStringId) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_ADDSTRING, (WPARAM)hInstance, nStringId), RV_ERR);
}

AFXINLINE int CToolbar::AddString(PCTSTR pszaString) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_ADDSTRING, UNUSED, (LPARAM)pszaString), RV_ERR);
}

AFXINLINE void CToolbar::AutoSize() const
{
	::SendMessage(m_hWnd, TB_AUTOSIZE, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::ButtonCount() const
{
	return ::SendMessage(m_hWnd, TB_BUTTONCOUNT, UNUSED, UNUSED);
}

AFXINLINE void CToolbar::ButtonStructSize() const
{
	::SendMessage(m_hWnd, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), UNUSED);
}

AFXINLINE BOOL CToolbar::ChangeBitmap(UINT nCmdId, int iImage) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_CHANGEBITMAP, nCmdId, iImage));
}

AFXINLINE BOOL CToolbar::CheckButton(UINT nCmdId, BOOL bCheck /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_CHECKBUTTON, nCmdId, bCheck));
}

AFXINLINE int CToolbar::CommandToIndex(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_COMMANDTOINDEX, nCmdId, UNUSED);
}

AFXINLINE BOOL CToolbar::CreateWindow(HWND hParentWnd, DWORD dwStyle, UINT nToolbarId,
	int ceImage, HINSTANCE hInstance, UINT nBitmapId, PCTBBUTTON paTBB, int ceTBB,
	int cxButton, int cyButton, int cxIamge, int cyIamge)
{
	m_hWnd = ::CreateToolbarEx(hParentWnd, dwStyle, nToolbarId, ceImage, hInstance, nBitmapId,
		paTBB, ceTBB, cxButton, cyButton, cxIamge, cyIamge, sizeof(TBBUTTON));
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CToolbar::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nToolbarId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_TOOLBAR, NULL, dwStyle, x, y, iWidth, iHeight,
		hParentWnd, (HMENU)nToolbarId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CToolbar::CreateWindow(DWORD dwStyle, HWND hParentWnd, UINT nToolbarId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_TOOLBAR, NULL, dwStyle, 0, 0, 0, 0,
		hParentWnd, (HMENU)nToolbarId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE void CToolbar::Customize() const
{
	::SendMessage(m_hWnd, TB_CUSTOMIZE, UNUSED, UNUSED);
}

AFXINLINE BOOL CToolbar::DeleteButton(int iButton) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_DELETEBUTTON, iButton, UNUSED));
}

AFXINLINE BOOL CToolbar::EnableButton(UINT nCmdId, BOOL bEnable /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_ENABLEBUTTON, nCmdId, bEnable));
}

AFXINLINE BOOL CToolbar::GetAnchorHighlight() const
{
	return ::SendMessage(m_hWnd, TB_GETANCHORHIGHLIGHT, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::GetBitmap(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_GETBITMAP, nCmdId, UNUSED);
}

AFXINLINE DWORD CToolbar::GetBitmapFlags() const
{
	return ::SendMessage(m_hWnd, TB_GETBITMAPFLAGS, UNUSED, UNUSED);
}

AFXINLINE BOOL CToolbar::GetButton(int iButton, PTBBUTTON pTBB) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_GETBUTTON, iButton, (LPARAM)pTBB));
}

AFXINLINE int CToolbar::GetButtonInfo(UINT nCmdId, PTBBUTTONINFO pTBBI) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_GETBUTTONINFO, nCmdId, (LPARAM)pTBBI), RV_ERR);
}

AFXINLINE DWORD CToolbar::GetButtonSize() const
{
	return ::SendMessage(m_hWnd, TB_GETBUTTONSIZE, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::GetButtonText(UINT nCmdId, PTSTR pszBuffer) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_GETBUTTONTEXT, nCmdId, (LPARAM)pszBuffer), RV_ERR);
}

AFXINLINE BOOL CToolbar::GetColorScheme(PCOLORSCHEME pCS) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_GETCOLORSCHEME, UNUSED, (LPARAM)pCS));
}

AFXINLINE HIMAGELIST CToolbar::GetDisabledImageList() const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TB_GETDISABLEDIMAGELIST, UNUSED, UNUSED);
}

AFXINLINE DWORD CToolbar::GetExStyle() const
{
	return ::SendMessage(m_hWnd, TB_GETEXTENDEDSTYLE, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CToolbar::GetHotImageList() const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TB_GETHOTIMAGELIST, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::GetHotItem() const
{
	return ::SendMessage(m_hWnd, TB_GETHOTITEM, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CToolbar::GetImageList() const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, TB_GETIMAGELIST, UNUSED, UNUSED));
}

AFXINLINE void CToolbar::GetInsertMark(PTBINSERTMARK pTBIM) const
{
	::SendMessage(m_hWnd, TB_GETINSERTMARK, UNUSED, (LPARAM)pTBIM);
}

AFXINLINE COLORREF CToolbar::GetInsertMarkColor() const
{
	return ::SendMessage(m_hWnd, TB_GETINSERTMARKCOLOR, UNUSED, UNUSED);
}

AFXINLINE BOOL CToolbar::GetItemRect(int iButton, PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_GETITEMRECT, iButton, (LPARAM)pRect));
}

AFXINLINE BOOL CToolbar::GetMaxSize(PSIZE pSize) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_GETMAXSIZE, UNUSED, (LPARAM)pSize));
}

AFXINLINE void CToolbar::GetMetrics(PTBMETRICS pTBM) const
{
	::SendMessage(m_hWnd, TB_GETMETRICS, UNUSED, (LPARAM)pTBM);
}

AFXINLINE HRESULT CToolbar::GetObject(IDropTarget** ppDT) const
{
	return VERIFY_HRESULT(::SendMessage(m_hWnd, TB_GETOBJECT,
		(WPARAM)&IID_IDropTarget, (LPARAM)ppDT));
}

AFXINLINE DWORD CToolbar::GetPadding() const
{
	return ::SendMessage(m_hWnd, TB_GETPADDING, UNUSED, UNUSED);
}

AFXINLINE BOOL CToolbar::GetRect(UINT nCmdId, PRECT pRect) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_GETRECT, nCmdId, (LPARAM)pRect));
}

AFXINLINE int CToolbar::GetRows() const
{
	return ::SendMessage(m_hWnd, TB_GETROWS, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::GetState(UINT nCmdId) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_GETSTATE, nCmdId, UNUSED), RV_ERR);
}

AFXINLINE int CToolbar::GetString(int iString, PTSTR pszBuffer, int ccBuffer) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TB_GETSTRING,
		MAKEWPARAM(ccBuffer, iString), (LPARAM)pszBuffer), RV_ERR);
}

AFXINLINE DWORD CToolbar::GetStyle() const
{
	return ::SendMessage(m_hWnd, TB_GETSTYLE, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::GetTextRows() const
{
	return ::SendMessage(m_hWnd, TB_GETTEXTROWS, UNUSED, UNUSED);
}

AFXINLINE HWND CToolbar::GetTooltips() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, TB_GETTOOLTIPS, UNUSED, UNUSED));
}

AFXINLINE BOOL CToolbar::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, TB_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE int CToolbar::GetVersion() const
{
	return ::SendMessage(m_hWnd, CCM_GETVERSION, UNUSED, UNUSED);
}

AFXINLINE BOOL CToolbar::HideButton(UINT nCmdId, BOOL bHide /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_HIDEBUTTON, nCmdId, bHide));
}

AFXINLINE int CToolbar::HitTest(PCPOINT pPoint) const
{
	return ::SendMessage(m_hWnd, TB_HITTEST, UNUSED, (LPARAM)pPoint);
}

AFXINLINE BOOL CToolbar::Indeterminate(UINT nCmdId, BOOL bIndeterminate /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_INDETERMINATE, nCmdId, bIndeterminate));
}

AFXINLINE BOOL CToolbar::InsertButton(int iButton, PCTBBUTTON pTBB) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_INSERTBUTTON, iButton, (LPARAM)pTBB));
}

AFXINLINE BOOL CToolbar::InsertMarkHitTest(PCPOINT pPoint, PTBINSERTMARK pTBIM) const
{
	return ::SendMessage(m_hWnd, TB_INSERTMARKHITTEST, (WPARAM)pPoint, (LPARAM)pTBIM);
}

AFXINLINE BOOL CToolbar::IsButtonChecked(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_ISBUTTONCHECKED, nCmdId, UNUSED);
}

AFXINLINE BOOL CToolbar::IsButtonEnabled(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_ISBUTTONENABLED, nCmdId, UNUSED);
}

AFXINLINE BOOL CToolbar::IsButtonHidden(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_ISBUTTONHIDDEN, nCmdId, UNUSED);
}

AFXINLINE BOOL CToolbar::IsButtonHighlighted(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_ISBUTTONHIGHLIGHTED, nCmdId, UNUSED);
}

AFXINLINE BOOL CToolbar::IsButtonIndeterminate(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_ISBUTTONINDETERMINATE, nCmdId, UNUSED);
}

AFXINLINE BOOL CToolbar::IsButtonPressed(UINT nCmdId) const
{
	return ::SendMessage(m_hWnd, TB_ISBUTTONPRESSED, nCmdId, UNUSED);
}

AFXINLINE int CToolbar::LoadImages(UINT nBitmapId,
	HINSTANCE hInstance /* = HINST_COMMCTRL */) const
{
	return ::SendMessage(m_hWnd, TB_LOADIMAGES, nBitmapId, (LPARAM)hInstance);
}

AFXINLINE BOOL CToolbar::MapAccelerator(TCHAR cAccel, PUINT pnCmdId) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_MAPACCELERATOR, (TUCHAR)cAccel, (LPARAM)pnCmdId));
}

AFXINLINE BOOL CToolbar::MarkButton(UINT nCmdId, BOOL bMark /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_MARKBUTTON, nCmdId, bMark));
}

AFXINLINE BOOL CToolbar::MoveButton(int iOldPos, int iNewPos) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_MOVEBUTTON, iOldPos, iNewPos));
}

AFXINLINE BOOL CToolbar::PressButton(UINT nCmdId, BOOL bPress /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_PRESSBUTTON, nCmdId, bPress));
}

AFXINLINE BOOL CToolbar::ReplaceBitmap(PCTBREPLACEBITMAP pTBRB) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_REPLACEBITMAP, UNUSED, (LPARAM)pTBRB));
}

AFXINLINE void CToolbar::Restore(PCTBSAVEPARAMS pTBSP) const
{
	::SendMessage(m_hWnd, TB_SAVERESTORE, FALSE, (LPARAM)pTBSP);
}

AFXINLINE void CToolbar::Save(PCTBSAVEPARAMS pTBSP) const
{
	::SendMessage(m_hWnd, TB_SAVERESTORE, TRUE, (LPARAM)pTBSP);
}

AFXINLINE BOOL CToolbar::SetAnchorHighlight(BOOL bEnable /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, TB_SETANCHORHIGHLIGHT, bEnable, UNUSED);
}

AFXINLINE BOOL CToolbar::SetBitmapSize(int cxImage, int cyImage) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETBITMAPSIZE,
		UNUSED, MAKELPARAM(cxImage, cyImage)));
}

AFXINLINE BOOL CToolbar::SetButtonInfo(UINT nCmdId, PCTBBUTTONINFO pTBBI) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETBUTTONINFO, nCmdId, (LPARAM)pTBBI));
}

AFXINLINE BOOL CToolbar::SetButtonSize(int cxButton, int cyButton) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETBUTTONSIZE,
		UNUSED, MAKELPARAM(cxButton, cyButton)));
}

AFXINLINE BOOL CToolbar::SetButtonWidth(int cxMin, int cxMax) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETBUTTONWIDTH, UNUSED, MAKELPARAM(cxMin, cxMax)));
}

AFXINLINE BOOL CToolbar::SetCmdId(int iButton, UINT nCmdId) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETCMDID, iButton, nCmdId));
}

AFXINLINE void CToolbar::SetColorScheme(PCCOLORSCHEME pCS) const
{
	::SendMessage(m_hWnd, TB_SETCOLORSCHEME, UNUSED, (LPARAM)pCS);
}

AFXINLINE HIMAGELIST CToolbar::SetDisabledImageList(HIMAGELIST hImageList) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TB_SETDISABLEDIMAGELIST,
		UNUSED, (LPARAM)hImageList);
}

AFXINLINE UINT CToolbar::SetDrawTextFlags(UINT nMask, UINT nFlags) const
{
	return ::SendMessage(m_hWnd, TB_SETDRAWTEXTFLAGS, nMask, nFlags);
}

AFXINLINE DWORD CToolbar::SetExStyle(DWORD dwStyle) const
{
	return ::SendMessage(m_hWnd, TB_SETEXTENDEDSTYLE, UNUSED, dwStyle);
}

AFXINLINE HIMAGELIST CToolbar::SetHotImageList(HIMAGELIST hImageList) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TB_SETHOTIMAGELIST, UNUSED, (LPARAM)hImageList);
}

AFXINLINE int CToolbar::SetHotItem(int iItem /* = -1 */) const
{
	return ::SendMessage(m_hWnd, TB_SETHOTITEM, iItem, UNUSED);
}

AFXINLINE HIMAGELIST CToolbar::SetImageList(HIMAGELIST hImageList, UINT nListId /* = 0 */) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TB_SETIMAGELIST, nListId, (LPARAM)hImageList);
}

AFXINLINE BOOL CToolbar::SetIndent(int cxIndent) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETINDENT, cxIndent, UNUSED));
}

AFXINLINE void CToolbar::SetInsertMark(PCTBINSERTMARK pTBIM) const
{
	::SendMessage(m_hWnd, TB_SETINSERTMARK, UNUSED, (LPARAM)pTBIM);
}

AFXINLINE COLORREF CToolbar::SetInsertMarkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, TB_SETINSERTMARKCOLOR, UNUSED, crValue);
}

AFXINLINE BOOL CToolbar::SetMaxTextRows(int ceRow) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETMAXTEXTROWS, ceRow, UNUSED));
}

AFXINLINE void CToolbar::SetMetrics(PCTBMETRICS pTBM) const
{
	::SendMessage(m_hWnd, TB_SETMETRICS, UNUSED, (LPARAM)pTBM);
}

AFXINLINE DWORD CToolbar::SetPadding(int cxAmount, int cyAmount) const
{
	return ::SendMessage(m_hWnd, TB_SETPADDING, UNUSED, MAKELPARAM(cxAmount, cyAmount));
}

AFXINLINE HWND CToolbar::SetParent(HWND hWnd) const
{
	return (HWND)::SendMessage(m_hWnd, TB_SETPARENT, (WPARAM)hWnd, UNUSED);
}

AFXINLINE void CToolbar::SetRows(int ceRow, PRECT pRect, BOOL bMore /* = TRUE */) const
{
	::SendMessage(m_hWnd, TB_SETROWS, MAKEWPARAM(ceRow, bMore), (LPARAM)pRect);
}

AFXINLINE BOOL CToolbar::SetState(UINT nCmdId, UINT nState) const
{
	return VERIFY(::SendMessage(m_hWnd, TB_SETSTATE, nCmdId, nState));
}

AFXINLINE void CToolbar::SetStyle(DWORD dwStyle) const
{
	::SendMessage(m_hWnd, TB_SETSTYLE, UNUSED, dwStyle);
}

AFXINLINE void CToolbar::SetTooltips(HWND hTooltip) const
{
	::SendMessage(m_hWnd, TB_SETTOOLTIPS, (WPARAM)hTooltip, UNUSED);
}

AFXINLINE BOOL CToolbar::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, TB_SETUNICODEFORMAT, bUnicode, UNUSED);
}

AFXINLINE int CToolbar::SetVersion(int iVersion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, CCM_SETVERSION, iVersion, UNUSED), RV_ERR);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CTooltip

// A tooltip is about to be drawn
// UINT OnNmCustomDrawTT(PNMTTCUSTOMDRAW pNMTTCD);
// Returns: Result value of the message processed
#define ON_NM_CUSTOMDRAWTT(fName) _ON_NOTIFY_R(NM_CUSTOMDRAW, fName, PNMTTCUSTOMDRAW)

// Displays text for a window other than the one beneath the mouse cursor
// Returns: A handle to the window that contains the point or NULL
#define ON_TTM_WINDOWFROMPOINT(fName) \
	case TTM_WINDOWFROMPOINT: \
		return pWnd->fName((PPOINT)lParam);

#define ON_TTN_GETDISPINFO(fName) _ON_NOTIFY_V(TTN_GETDISPINFO, fName, PNMTTDISPINFO)
#define ON_TTN_POP(fName)         _ON_NOTIFY_V(TTN_POP, fName, PCNMHDR)
#define ON_TTN_SHOW(fName)        _ON_NOTIFY_R(TTN_SHOW, fName, PCNMHDR)

class CTooltip : public CWnd
{
public:
	CTooltip();
	CTooltip(HWND hTooltip);
	void operator =(HWND hTooltip);
	void Activate(BOOL bActive = TRUE) const;
	BOOL AddTool(PCTTTOOLINFO pTTTI) const;
	BOOL AdjustRect(PRECT pRect, BOOL bDispRect) const;
	BOOL CreateWindow(DWORD dwExStyle, DWORD dwStyle, HWND hParentWnd, UINT nTooltipId);
	BOOL CreateWindow(DWORD dwStyle, HWND hParentWnd, UINT nTooltipId);
	void DelTool(PCTTTOOLINFO pTTTI) const;
	BOOL EnumTools(int iTool, PTTTOOLINFO pTTTI) const;
	DWORD GetBubbleSize(PCTTTOOLINFO pTTTI) const;
	BOOL GetCurTool(PTTTOOLINFO pTTTI = NULL) const;
	UINT GetDelayTime(UINT nFlag) const;
	void GetMargin(PRECT pRect) const;
	int GetMaxTipWidth() const;
	void GetText(PCTTTOOLINFO pTTTI) const;
	COLORREF GetTipBkColor() const;
	COLORREF GetTipTextColor() const;
	int GetToolCount() const;
	BOOL GetToolInfo(PTTTOOLINFO pTTTI) const;
	BOOL HitTest(PTTHITTESTINFO pTTHTI) const;
	void NewToolRect(PCTTTOOLINFO pTTTI) const;
	void Pop() const;
	void RelayEvent(PCMSG pMsg) const;
	void SetDelayTime(UINT nFlag, UINT nTime = MAX_UINT) const;
	void SetMargin(PCRECT pRect) const;
	int SetMaxTipWidth(int iWidth) const;
	void SetTipBkColor(COLORREF crValue) const;
	void SetTipTextColor(COLORREF crValue) const;
	BOOL SetTitle(PCTSTR pszTitle, UINT nIcon = 0) const;
	void SetToolInfo(PCTTTOOLINFO pTTTI) const;
	void TrackActivate(PCTTTOOLINFO pTTTI, BOOL bActive = TRUE) const;
	void TrackPosition(int x, int y) const;
	void Update() const;
	void UpdateTipText(PCTTTOOLINFO pTTTI) const;
};

AFXINLINE CTooltip::CTooltip()
{
	// Does nothing
}

AFXINLINE CTooltip::CTooltip(HWND hTooltip)
{
	m_hWnd = hTooltip;
}

AFXINLINE void CTooltip::operator =(HWND hTooltip)
{
	m_hWnd = hTooltip;
}

AFXINLINE void CTooltip::Activate(BOOL bActive /* = TRUE */) const
{
	::SendMessage(m_hWnd, TTM_ACTIVATE, bActive, UNUSED);
}

AFXINLINE BOOL CTooltip::AddTool(PCTTTOOLINFO pTTTI) const
{
	return VERIFY(::SendMessage(m_hWnd, TTM_ADDTOOL, UNUSED, (LPARAM)pTTTI));
}

AFXINLINE BOOL CTooltip::AdjustRect(PRECT pRect, BOOL bDispRect) const
{
	return VERIFY(::SendMessage(m_hWnd, TTM_ADJUSTRECT, bDispRect, (LPARAM)pRect));
}

AFXINLINE BOOL CTooltip::CreateWindow(DWORD dwExStyle, DWORD dwStyle,
	HWND hParentWnd, UINT nTooltipId)
{
	m_hWnd = ::CreateWindowEx(dwExStyle, WC_TOOLTIP, NULL, dwStyle,
		0, 0, 0, 0, hParentWnd, (HMENU)nTooltipId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CTooltip::CreateWindow(DWORD dwStyle, HWND hParentWnd, UINT nTooltipId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_TOOLTIP, NULL, dwStyle,
		0, 0, 0, 0, hParentWnd, (HMENU)nTooltipId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE void CTooltip::DelTool(PCTTTOOLINFO pTTTI) const
{
	::SendMessage(m_hWnd, TTM_DELTOOL, UNUSED, (LPARAM)pTTTI);
}

AFXINLINE BOOL CTooltip::EnumTools(int iTool, PTTTOOLINFO pTTTI) const
{
	return VERIFY(::SendMessage(m_hWnd, TTM_ENUMTOOLS, iTool, (LPARAM)pTTTI));
}

AFXINLINE DWORD CTooltip::GetBubbleSize(PCTTTOOLINFO pTTTI) const
{
	return VERIFY(::SendMessage(m_hWnd, TTM_GETBUBBLESIZE, UNUSED, (LPARAM)pTTTI));
}

AFXINLINE BOOL CTooltip::GetCurTool(PTTTOOLINFO pTTTI /* = NULL */) const
{
	return ::SendMessage(m_hWnd, TTM_GETCURRENTTOOL, UNUSED, (LPARAM)pTTTI);
}

AFXINLINE UINT CTooltip::GetDelayTime(UINT nFlag) const
{
	return ::SendMessage(m_hWnd, TTM_GETDELAYTIME, nFlag, UNUSED);
}

AFXINLINE void CTooltip::GetMargin(PRECT pRect) const
{
	::SendMessage(m_hWnd, TTM_GETMARGIN, UNUSED, (LPARAM)pRect);
}

AFXINLINE int CTooltip::GetMaxTipWidth() const
{
	return ::SendMessage(m_hWnd, TTM_GETMAXTIPWIDTH, UNUSED, UNUSED);
}

AFXINLINE void CTooltip::GetText(PCTTTOOLINFO pTTTI) const
{
	::SendMessage(m_hWnd, TTM_GETTEXT, UNUSED, (LPARAM)pTTTI);
}

AFXINLINE COLORREF CTooltip::GetTipBkColor() const
{
	return ::SendMessage(m_hWnd, TTM_GETTIPBKCOLOR, UNUSED, UNUSED);
}

AFXINLINE COLORREF CTooltip::GetTipTextColor() const
{
	return ::SendMessage(m_hWnd, TTM_GETTIPTEXTCOLOR, UNUSED, UNUSED);
}

AFXINLINE int CTooltip::GetToolCount() const
{
	return ::SendMessage(m_hWnd, TTM_GETTOOLCOUNT, UNUSED, UNUSED);
}

AFXINLINE BOOL CTooltip::GetToolInfo(PTTTOOLINFO pTTTI) const
{
	return VERIFY(::SendMessage(m_hWnd, TTM_GETTOOLINFO, UNUSED, (LPARAM)pTTTI));
}

AFXINLINE BOOL CTooltip::HitTest(PTTHITTESTINFO pTTHTI) const
{
	return ::SendMessage(m_hWnd, TTM_HITTEST, UNUSED, (LPARAM)pTTHTI);
}

AFXINLINE void CTooltip::NewToolRect(PCTTTOOLINFO pTTTI) const
{
	::SendMessage(m_hWnd, TTM_NEWTOOLRECT, UNUSED, (LPARAM)pTTTI);
}

AFXINLINE void CTooltip::Pop() const
{
	::SendMessage(m_hWnd, TTM_POP, UNUSED, UNUSED);
}

AFXINLINE void CTooltip::RelayEvent(PCMSG pMsg) const
{
	::SendMessage(m_hWnd, TTM_RELAYEVENT, UNUSED, (LPARAM)pMsg);
}

AFXINLINE void CTooltip::SetDelayTime(UINT nFlag, UINT nTime /* = MAX_UINT */) const
{
	::SendMessage(m_hWnd, TTM_SETDELAYTIME, nFlag, nTime);
}

AFXINLINE void CTooltip::SetMargin(PCRECT pRect) const
{
	::SendMessage(m_hWnd, TTM_SETMARGIN, UNUSED, (LPARAM)pRect);
}

AFXINLINE int CTooltip::SetMaxTipWidth(int iWidth) const
{
	return ::SendMessage(m_hWnd, TTM_SETMAXTIPWIDTH, UNUSED, iWidth);
}

AFXINLINE void CTooltip::SetTipBkColor(COLORREF crValue) const
{
	::SendMessage(m_hWnd, TTM_SETTIPBKCOLOR, crValue, UNUSED);
}

AFXINLINE void CTooltip::SetTipTextColor(COLORREF crValue) const
{
	::SendMessage(m_hWnd, TTM_SETTIPTEXTCOLOR, crValue, UNUSED);
}

AFXINLINE BOOL CTooltip::SetTitle(PCTSTR pszTitle, UINT nIcon /* = 0 */) const
{
	return VERIFY(::SendMessage(m_hWnd, TTM_SETTITLE, nIcon, (LPARAM)pszTitle));
}

AFXINLINE void CTooltip::SetToolInfo(PCTTTOOLINFO pTTTI) const
{
	::SendMessage(m_hWnd, TTM_SETTOOLINFO, UNUSED, (LPARAM)pTTTI);
}

AFXINLINE void CTooltip::TrackActivate(PCTTTOOLINFO pTTTI, BOOL bActive /* = TRUE */) const
{
	::SendMessage(m_hWnd, TTM_TRACKACTIVATE, bActive, (LPARAM)pTTTI);
}

AFXINLINE void CTooltip::TrackPosition(int x, int y) const
{
	::SendMessage(m_hWnd, TTM_TRACKPOSITION, UNUSED, MAKELPARAM(x, y));
}

AFXINLINE void CTooltip::Update() const
{
	::SendMessage(m_hWnd, TTM_UPDATE, UNUSED, UNUSED);
}

AFXINLINE void CTooltip::UpdateTipText(PCTTTOOLINFO pTTTI) const
{
	::SendMessage(m_hWnd, TTM_UPDATETIPTEXT, UNUSED, (LPARAM)pTTTI);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CTrackbar

class CTrackbar : public CWnd
{
public:
	CTrackbar();
	CTrackbar(HWND hTrackbar);
	void operator =(HWND hTrackbar);
	void ClearSel(BOOL bRedraw = TRUE) const;
	void ClearTics(BOOL bRedraw = TRUE) const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nTrackbarId);
	HWND GetBuddy(BOOL bLeft) const;
	void GetChannelRect(PRECT pRect) const;
	int GetLineSize() const;
	int GetPageSize() const;
	int GetPos() const;
	int GetRangeMax() const;
	int GetRangeMin() const;
	int GetSelEnd() const;
	int GetSelStart() const;
	int GetThumbLength() const;
	void GetThumbRect(PRECT pRect) const;
	int GetTic(int iTic) const;
	int GetTicCount() const;
	int GetTicPos(int iTic) const;
	PCINT GetTics() const;
	HWND GetTooltips() const;
	BOOL GetUnicodeFormat() const;
	HWND SetBuddy(HWND hBuddyWnd, BOOL bLeft) const;
	int SetLineSize(int iSize) const;
	int SetPageSize(int iSize) const;
	void SetPos(int iPos, BOOL bRedraw = TRUE) const;
	void SetRange(int iMin, int iMax, BOOL bRedraw = FALSE) const;
	void SetRangeMax(int iMax, BOOL bRedraw = FALSE) const;
	void SetRangeMin(int iMin, BOOL bRedraw = FALSE) const;
	void SetSel(int iStart, int iEnd, BOOL bRedraw = TRUE) const;
	void SetSelEnd(int iEnd, BOOL bRedraw = TRUE) const;
	void SetSelStart(int iStart, BOOL bRedraw = TRUE) const;
	void SetThumbLength(int iLength) const;
	BOOL SetTic(int iPos) const;
	void SetTicFreq(int iFreq) const;
	UINT SetTipSide(UINT nLocation) const;
	void SetTooltips(HWND hTooltip) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
};

AFXINLINE CTrackbar::CTrackbar()
{
	// Does nothing
}

AFXINLINE CTrackbar::CTrackbar(HWND hTrackbar)
{
	m_hWnd = hTrackbar;
}

AFXINLINE void CTrackbar::operator =(HWND hTrackbar)
{
	m_hWnd = hTrackbar;
}

AFXINLINE void CTrackbar::ClearSel(BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, TBM_CLEARSEL, bRedraw, UNUSED);
}

AFXINLINE void CTrackbar::ClearTics(BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, TBM_CLEARTICS, bRedraw, UNUSED);
}

AFXINLINE BOOL CTrackbar::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nTrackbarId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_TRACKBAR, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nTrackbarId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE HWND CTrackbar::GetBuddy(BOOL bLeft) const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, TBM_GETBUDDY, bLeft, UNUSED));
}

AFXINLINE void CTrackbar::GetChannelRect(PRECT pRect) const
{
	::SendMessage(m_hWnd, TBM_GETCHANNELRECT, UNUSED, (LPARAM)pRect);
}

AFXINLINE int CTrackbar::GetLineSize() const
{
	return ::SendMessage(m_hWnd, TBM_GETLINESIZE, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetPageSize() const
{
	return ::SendMessage(m_hWnd, TBM_GETPAGESIZE, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetPos() const
{
	return ::SendMessage(m_hWnd, TBM_GETPOS, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetRangeMax() const
{
	return ::SendMessage(m_hWnd, TBM_GETRANGEMAX, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetRangeMin() const
{
	return ::SendMessage(m_hWnd, TBM_GETRANGEMIN, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetSelEnd() const
{
	return ::SendMessage(m_hWnd, TBM_GETSELEND, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetSelStart() const
{
	return ::SendMessage(m_hWnd, TBM_GETSELSTART, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetThumbLength() const
{
	return ::SendMessage(m_hWnd, TBM_GETTHUMBLENGTH, UNUSED, UNUSED);
}

AFXINLINE void CTrackbar::GetThumbRect(PRECT pRect) const
{
	::SendMessage(m_hWnd, TBM_GETTHUMBRECT, UNUSED, (LPARAM)pRect);
}

AFXINLINE int CTrackbar::GetTic(int iTic) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TBM_GETTIC, iTic, UNUSED), RV_ERR);
}

AFXINLINE int CTrackbar::GetTicCount() const
{
	return ::SendMessage(m_hWnd, TBM_GETNUMTICS, UNUSED, UNUSED);
}

AFXINLINE int CTrackbar::GetTicPos(int iTic) const
{
	return UNEQUAL(::SendMessage(m_hWnd, TBM_GETTICPOS, iTic, UNUSED), RV_ERR);
}

AFXINLINE PCINT CTrackbar::GetTics() const
{
	return (PCINT)::SendMessage(m_hWnd, TBM_GETPTICS, UNUSED, UNUSED);
}

AFXINLINE HWND CTrackbar::GetTooltips() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, TBM_GETTOOLTIPS, UNUSED, UNUSED));
}

AFXINLINE BOOL CTrackbar::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, TBM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE HWND CTrackbar::SetBuddy(HWND hBuddyWnd, BOOL bLeft) const
{
	return (HWND)::SendMessage(m_hWnd, TBM_SETBUDDY, bLeft, (LPARAM)hBuddyWnd);
}

AFXINLINE int CTrackbar::SetLineSize(int iSize) const
{
	return ::SendMessage(m_hWnd, TBM_SETLINESIZE, UNUSED, iSize);
}

AFXINLINE int CTrackbar::SetPageSize(int iSize) const
{
	return ::SendMessage(m_hWnd, TBM_SETPAGESIZE, UNUSED, iSize);
}

AFXINLINE void CTrackbar::SetPos(int iPos, BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, TBM_SETPOS, bRedraw, iPos);
}

AFXINLINE void CTrackbar::SetRange(int iMin, int iMax, BOOL bRedraw /* = FALSE */) const
{
	::SendMessage(m_hWnd, TBM_SETRANGE, bRedraw, MAKELPARAM(iMin, iMax));
}

AFXINLINE void CTrackbar::SetRangeMax(int iMax, BOOL bRedraw /* = FALSE */) const
{
	::SendMessage(m_hWnd, TBM_SETRANGEMAX, bRedraw, iMax);
}

AFXINLINE void CTrackbar::SetRangeMin(int iMin, BOOL bRedraw /* = FALSE */) const
{
	::SendMessage(m_hWnd, TBM_SETRANGEMIN, bRedraw, iMin);
}

AFXINLINE void CTrackbar::SetSel(int iStart, int iEnd, BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, TBM_SETSEL, bRedraw, MAKELPARAM(iStart, iEnd));
}

AFXINLINE void CTrackbar::SetSelEnd(int iEnd, BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, TBM_SETSELEND, bRedraw, iEnd);
}

AFXINLINE void CTrackbar::SetSelStart(int iStart, BOOL bRedraw /* = TRUE */) const
{
	::SendMessage(m_hWnd, TBM_SETSELSTART, bRedraw, iStart);
}

AFXINLINE void CTrackbar::SetThumbLength(int iLength) const
{
	::SendMessage(m_hWnd, TBM_SETTHUMBLENGTH, iLength, UNUSED);
}

AFXINLINE BOOL CTrackbar::SetTic(int iPos) const
{
	return VERIFY(::SendMessage(m_hWnd, TBM_SETTIC, UNUSED, iPos));
}

AFXINLINE void CTrackbar::SetTicFreq(int iFreq) const
{
	::SendMessage(m_hWnd, TBM_SETTICFREQ, iFreq, UNUSED);
}

AFXINLINE UINT CTrackbar::SetTipSide(UINT nLocation) const
{
	return ::SendMessage(m_hWnd, TBM_SETTIPSIDE, nLocation, UNUSED);
}

AFXINLINE void CTrackbar::SetTooltips(HWND hTooltip) const
{
	::SendMessage(m_hWnd, TBM_SETTOOLTIPS, (WPARAM)hTooltip, UNUSED);
}

AFXINLINE BOOL CTrackbar::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, TBM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CTreeView

// A tree view is about to be drawn
// UINT OnNmCustomDrawTV(PCNMTVCUSTOMDRAW pNMTVCD);
// Returns: Result value of the message processed
#define ON_NM_CUSTOMDRAWTV(fName) _ON_NOTIFY_R(NM_CUSTOMDRAW, fName, PCNMTVCUSTOMDRAW)

#define ON_TVN_BEGINDRAG(fName)      _ON_NOTIFY_V(TVN_BEGINDRAG, fName, PCNMTREEVIEW)
#define ON_TVN_BEGINLABELEDIT(fName) _ON_NOTIFY_R(TVN_BEGINLABELEDIT, fName, PCNMTVDISPINFO)
#define ON_TVN_BEGINRDRAG(fName)     _ON_NOTIFY_V(TVN_BEGINRDRAG, fName, PCNMTREEVIEW)
#define ON_TVN_DELETEITEM(fName)     _ON_NOTIFY_V(TVN_DELETEITEM, fName, PCNMTREEVIEW)
#define ON_TVN_ENDLABELEDIT(fName)   _ON_NOTIFY_R(TVN_ENDLABELEDIT, fName, PCNMTVDISPINFO)
#define ON_TVN_GETDISPINFO(fName)    _ON_NOTIFY_V(TVN_GETDISPINFO, fName, PNMTVDISPINFO)
#define ON_TVN_GETINFOTIP(fName)     _ON_NOTIFY_V(TVN_GETINFOTIP, fName, PNMTVGETINFOTIP)
#define ON_TVN_ITEMEXPANDED(fName)   _ON_NOTIFY_V(TVN_ITEMEXPANDED, fName, PCNMTREEVIEW)
#define ON_TVN_ITEMEXPANDING(fName)  _ON_NOTIFY_R(TVN_ITEMEXPANDING, fName, PCNMTREEVIEW)
#define ON_TVN_KEYDOWN(fName)        _ON_NOTIFY_R(TVN_KEYDOWN, fName, PCNMTVKEYDOWN)
#define ON_TVN_SELCHANGED(fName)     _ON_NOTIFY_V(TVN_SELCHANGED, fName, PCNMTREEVIEW)
#define ON_TVN_SELCHANGING(fName)    _ON_NOTIFY_R(TVN_SELCHANGING, fName, PCNMTREEVIEW)
#define ON_TVN_SETDISPINFO(fName)    _ON_NOTIFY_V(TVN_SETDISPINFO, fName, PCNMTVDISPINFO)
#define ON_TVN_SINGLEEXPAND(fName)   _ON_NOTIFY_R(TVN_SINGLEEXPAND, fName, PCNMTREEVIEW)

class CTreeView : public CWnd
{
public:
	CTreeView();
	CTreeView(HWND hTreeView);
	void operator =(HWND hTreeView);
	HIMAGELIST CreateDragImage(HTREEITEM hTreeItem) const;
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nTreeViewId);
	BOOL DeleteAllItems() const;
	BOOL DeleteItem(HTREEITEM hTreeItem) const;
	HWND EditLabel(HTREEITEM hTreeItem) const;
	BOOL EndLabelEdit(BOOL bCancel = TRUE) const;
	BOOL EnsureVisible(HTREEITEM hTreeItem) const;
	BOOL Expand(HTREEITEM hTreeItem, UINT nAction) const;
	COLORREF GetBkColor() const;
	BOOL GetCheckState(HTREEITEM hTreeItem) const;
	int GetCount() const;
	HWND GetEditCtrl() const;
	HIMAGELIST GetImageList(UINT nType) const;
	int GetIndent() const;
	COLORREF GetInsertMarkColor() const;
	int GetISearchString(PTSTR pszBuffer) const;
	BOOL GetItem(PTVITEMEX pTVIX) const;
	BOOL GetItem(PTVITEM pTVI) const;
	int GetItemHeight() const;
	BOOL GetItemRect(HTREEITEM hTreeItem, PRECT pRect, BOOL bOnlyText = FALSE) const;
	UINT GetItemState(HTREEITEM hTreeItem, UINT nMask) const;
	COLORREF GetLineColor() const;
	HTREEITEM GetNextItem(HTREEITEM hTreeItem, UINT nFlag = TVGN_NEXT) const;
	HTREEITEM GetNextItem(UINT nFlag) const;
	UINT GetScrollTime() const;
	COLORREF GetTextColor() const;
	HWND GetTooltips() const;
	BOOL GetUnicodeFormat() const;
	int GetVersion() const;
	int GetVisibleCount() const;
	HTREEITEM HitTest(PTVHITTESTINFO pTVHTI) const;
	HTREEITEM InsertItem(PCTVINSERTSTRUCT pTVIS) const;
	HIMAGELIST RemoveImageList(UINT nType) const;
	BOOL RemoveInsertMark() const;
	BOOL SelectItem(HTREEITEM hTreeItem, UINT nAction = TVGN_CARET) const;
	COLORREF SetBkColor(COLORREF crValue) const;
	BOOL SetCheckState(HTREEITEM hTreeItem, BOOL bCheck) const;
	HIMAGELIST SetImageList(HIMAGELIST hImageList, UINT nType) const;
	void SetIndent(int iWidth) const;
	BOOL SetInsertMark(HTREEITEM hTreeItem, BOOL bAfter) const;
	COLORREF SetInsertMarkColor(COLORREF crValue) const;
	BOOL SetItem(PCTVITEMEX pTVIX) const;
	BOOL SetItem(PCTVITEM pTVI) const;
	int SetItemHeight(int iHeight = -1) const;
	COLORREF SetLineColor(COLORREF crValue) const;
	UINT SetScrollTime(UINT nTime) const;
	COLORREF SetTextColor(COLORREF crValue) const;
	HWND SetTooltips(HWND hTooltip) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
	int SetVersion(int iVersion) const;
	BOOL SortChildren(HTREEITEM hTreeItem) const;
	BOOL SortChildren(PCTVSORTCB pTVSCB) const;
};

AFXINLINE CTreeView::CTreeView()
{
	// Does nothing
}

AFXINLINE CTreeView::CTreeView(HWND hTreeView)
{
	m_hWnd = hTreeView;
}

AFXINLINE void CTreeView::operator =(HWND hTreeView)
{
	m_hWnd = hTreeView;
}

AFXINLINE HIMAGELIST CTreeView::CreateDragImage(HTREEITEM hTreeItem) const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, TVM_CREATEDRAGIMAGE,
		UNUSED, (LPARAM)hTreeItem));
}

AFXINLINE BOOL CTreeView::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nTreeViewId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_TREEVIEW, NULL, dwStyle,
		x, y, iWidth, iHeight, hParentWnd, (HMENU)nTreeViewId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CTreeView::DeleteAllItems() const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_DELETEITEM, UNUSED, (LPARAM)TVI_ROOT));
}

AFXINLINE BOOL CTreeView::DeleteItem(HTREEITEM hTreeItem) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_DELETEITEM, UNUSED, (LPARAM)hTreeItem));
}

AFXINLINE HWND CTreeView::EditLabel(HTREEITEM hTreeItem) const
{
	return (HWND)::SendMessage(m_hWnd, TVM_EDITLABEL, UNUSED, (LPARAM)hTreeItem);
}

AFXINLINE BOOL CTreeView::EndLabelEdit(BOOL bCancel /* = TRUE */) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_ENDEDITLABELNOW, bCancel, UNUSED));
}

AFXINLINE BOOL CTreeView::EnsureVisible(HTREEITEM hTreeItem) const
{
	return ::SendMessage(m_hWnd, TVM_ENSUREVISIBLE, UNUSED, (LPARAM)hTreeItem);
}

AFXINLINE BOOL CTreeView::Expand(HTREEITEM hTreeItem, UINT nAction) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_EXPAND, nAction, (LPARAM)hTreeItem));
}

AFXINLINE COLORREF CTreeView::GetBkColor() const
{
	return ::SendMessage(m_hWnd, TVM_GETBKCOLOR, UNUSED, UNUSED);
}

AFXINLINE BOOL CTreeView::GetCheckState(HTREEITEM hTreeItem) const
{
	return (::SendMessage(m_hWnd, TVM_GETITEMSTATE,
		(WPARAM)hTreeItem, TVIS_STATEIMAGEMASK) & 0x2000);
}

AFXINLINE int CTreeView::GetCount() const
{
	return ::SendMessage(m_hWnd, TVM_GETCOUNT, UNUSED, UNUSED);
}

AFXINLINE HWND CTreeView::GetEditCtrl() const
{
	return (HWND)::SendMessage(m_hWnd, TVM_GETEDITCONTROL, UNUSED, UNUSED);
}

AFXINLINE HIMAGELIST CTreeView::GetImageList(UINT nType) const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, TVM_GETIMAGELIST, nType, UNUSED));
}

AFXINLINE int CTreeView::GetIndent() const
{
	return ::SendMessage(m_hWnd, TVM_GETINDENT, UNUSED, UNUSED);
}

AFXINLINE COLORREF CTreeView::GetInsertMarkColor() const
{
	return ::SendMessage(m_hWnd, TVM_GETINSERTMARKCOLOR, UNUSED, UNUSED);
}

AFXINLINE int CTreeView::GetISearchString(PTSTR pszBuffer) const
{
	return ::SendMessage(m_hWnd, TVM_GETISEARCHSTRING, UNUSED, (LPARAM)pszBuffer);
}

AFXINLINE BOOL CTreeView::GetItem(PTVITEMEX pTVIX) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_GETITEM, UNUSED, (LPARAM)pTVIX));
}

AFXINLINE BOOL CTreeView::GetItem(PTVITEM pTVI) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_GETITEM, UNUSED, (LPARAM)pTVI));
}

AFXINLINE int CTreeView::GetItemHeight() const
{
	return ::SendMessage(m_hWnd, TVM_GETITEMHEIGHT, UNUSED, UNUSED);
}

AFXINLINE BOOL CTreeView::GetItemRect(HTREEITEM hTreeItem, PRECT pRect,
	BOOL bOnlyText /* = FALSE */) const
{
	pRect->left = (LONG)hTreeItem;
	return VERIFY(::SendMessage(m_hWnd, TVM_GETITEMRECT, bOnlyText, (LPARAM)pRect));
}

AFXINLINE UINT CTreeView::GetItemState(HTREEITEM hTreeItem, UINT nMask) const
{
	return ::SendMessage(m_hWnd, TVM_GETITEMSTATE, (WPARAM)hTreeItem, nMask);
}

AFXINLINE COLORREF CTreeView::GetLineColor() const
{
	return ::SendMessage(m_hWnd, TVM_GETLINECOLOR, UNUSED, UNUSED);
}

AFXINLINE HTREEITEM CTreeView::GetNextItem(HTREEITEM hTreeItem,
	UINT nFlag /* = TVGN_NEXT */) const
{
	return (HTREEITEM)::SendMessage(m_hWnd, TVM_GETNEXTITEM, nFlag, (LPARAM)hTreeItem);
}

AFXINLINE HTREEITEM CTreeView::GetNextItem(UINT nFlag) const
{
	return (HTREEITEM)::SendMessage(m_hWnd, TVM_GETNEXTITEM, nFlag, UNUSED);
}

AFXINLINE UINT CTreeView::GetScrollTime() const
{
	return ::SendMessage(m_hWnd, TVM_GETSCROLLTIME, UNUSED, UNUSED);
}

AFXINLINE COLORREF CTreeView::GetTextColor() const
{
	return ::SendMessage(m_hWnd, TVM_GETTEXTCOLOR, UNUSED, UNUSED);
}

AFXINLINE HWND CTreeView::GetTooltips() const
{
	return (HWND)VERIFY(::SendMessage(m_hWnd, TVM_GETTOOLTIPS, UNUSED, UNUSED));
}

AFXINLINE BOOL CTreeView::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, TVM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE int CTreeView::GetVersion() const
{
	return ::SendMessage(m_hWnd, CCM_GETVERSION, UNUSED, UNUSED);
}

AFXINLINE int CTreeView::GetVisibleCount() const
{
	return ::SendMessage(m_hWnd, TVM_GETVISIBLECOUNT, UNUSED, UNUSED);
}

AFXINLINE HTREEITEM CTreeView::HitTest(PTVHITTESTINFO pTVHTI) const
{
	return (HTREEITEM)::SendMessage(m_hWnd, TVM_HITTEST, UNUSED, (LPARAM)pTVHTI);
}

AFXINLINE HTREEITEM CTreeView::InsertItem(PCTVINSERTSTRUCT pTVIS) const
{
	return (HTREEITEM)VERIFY(::SendMessage(m_hWnd, TVM_INSERTITEM, UNUSED, (LPARAM)pTVIS));
}

AFXINLINE HIMAGELIST CTreeView::RemoveImageList(UINT nType) const
{
	return (HIMAGELIST)VERIFY(::SendMessage(m_hWnd, TVM_SETIMAGELIST, nType, UNUSED));
}

AFXINLINE BOOL CTreeView::RemoveInsertMark() const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SETINSERTMARK, UNUSED, UNUSED));
}

AFXINLINE BOOL CTreeView::SelectItem(HTREEITEM hTreeItem, UINT nAction /* = TVGN_CARET */) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SELECTITEM, nAction, (LPARAM)hTreeItem));
}

AFXINLINE COLORREF CTreeView::SetBkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, TVM_SETBKCOLOR, UNUSED, crValue);
}

AFXINLINE BOOL CTreeView::SetCheckState(HTREEITEM hTreeItem, BOOL bCheck) const
{
	TVITEM tvi;
	tvi.mask      = TVIF_STATE;
	tvi.hItem     = hTreeItem;
	tvi.state     = bCheck ? 0x2000 : 0x1000;
	tvi.stateMask = TVIS_STATEIMAGEMASK;
	return VERIFY(::SendMessage(m_hWnd, TVM_SETITEM, UNUSED, (LPARAM)&tvi));
}

AFXINLINE HIMAGELIST CTreeView::SetImageList(HIMAGELIST hImageList, UINT nType) const
{
	return (HIMAGELIST)::SendMessage(m_hWnd, TVM_SETIMAGELIST, nType, (LPARAM)hImageList);
}

AFXINLINE void CTreeView::SetIndent(int iWidth) const
{
	::SendMessage(m_hWnd, TVM_SETINDENT, iWidth, UNUSED);
}

AFXINLINE BOOL CTreeView::SetInsertMark(HTREEITEM hTreeItem, BOOL bAfter) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SETINSERTMARK, bAfter, (LPARAM)hTreeItem));
}

AFXINLINE COLORREF CTreeView::SetInsertMarkColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, TVM_SETINSERTMARKCOLOR, UNUSED, crValue);
}

AFXINLINE BOOL CTreeView::SetItem(PCTVITEMEX pTVIX) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SETITEM, UNUSED, (LPARAM)pTVIX));
}

AFXINLINE BOOL CTreeView::SetItem(PCTVITEM pTVI) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SETITEM, UNUSED, (LPARAM)pTVI));
}

AFXINLINE int CTreeView::SetItemHeight(int iHeight /* = -1 */) const
{
	return ::SendMessage(m_hWnd, TVM_SETITEMHEIGHT, iHeight, UNUSED);
}

AFXINLINE COLORREF CTreeView::SetLineColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, TVM_SETLINECOLOR, UNUSED, crValue);
}

AFXINLINE UINT CTreeView::SetScrollTime(UINT nTime) const
{
	return ::SendMessage(m_hWnd, TVM_SETSCROLLTIME, nTime, UNUSED);
}

AFXINLINE COLORREF CTreeView::SetTextColor(COLORREF crValue) const
{
	return ::SendMessage(m_hWnd, TVM_SETTEXTCOLOR, UNUSED, crValue);
}

AFXINLINE HWND CTreeView::SetTooltips(HWND hTooltip) const
{
	return (HWND)::SendMessage(m_hWnd, TVM_SETTOOLTIPS, (WPARAM)hTooltip, UNUSED);
}

AFXINLINE BOOL CTreeView::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, TVM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

AFXINLINE int CTreeView::SetVersion(int iVersion) const
{
	return UNEQUAL(::SendMessage(m_hWnd, CCM_SETVERSION, iVersion, UNUSED), RV_ERR);
}

AFXINLINE BOOL CTreeView::SortChildren(HTREEITEM hTreeItem) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SORTCHILDREN, UNUSED, (LPARAM)hTreeItem));
}

AFXINLINE BOOL CTreeView::SortChildren(PCTVSORTCB pTVSCB) const
{
	return VERIFY(::SendMessage(m_hWnd, TVM_SORTCHILDRENCB, UNUSED, (LPARAM)pTVSCB));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// CUpDown

#define ON_UDN_DELTAPOS(fName) _ON_NOTIFY_R(UDN_DELTAPOS, fName, PCNMUPDOWN)

class CUpDown : public CWnd
{
public:
	CUpDown();
	CUpDown(HWND hUpDown);
	void operator =(HWND hUpDown);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, int iUpDownId, HWND hBuddyWnd, int iMin, int iMax, int iPos);
	BOOL CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
		HWND hParentWnd, UINT nUpDownId);
	int GetAccel(PUDACCEL paUDA = NULL, int ceUDA = 0) const;
	UINT GetBase() const;
	HWND GetBuddy() const;
	int GetPos(PBOOL pbError = NULL) const;
	void GetRange(PINT piMin = NULL, PINT piMax = NULL) const;
	BOOL GetUnicodeFormat() const;
	BOOL SetAccel(PCUDACCEL paUDA, int ceUDA) const;
	UINT SetBase(UINT nBase) const;
	HWND SetBuddy(HWND hBuddyWnd = NULL) const;
	int SetPos(int iPos) const;
	void SetRange(int iMin, int iMax) const;
	BOOL SetUnicodeFormat(BOOL bUnicode = TRUE) const;
};

AFXINLINE CUpDown::CUpDown()
{
	// Does nothing
}

AFXINLINE CUpDown::CUpDown(HWND hUpDown)
{
	m_hWnd = hUpDown;
}

AFXINLINE void CUpDown::operator =(HWND hUpDown)
{
	m_hWnd = hUpDown;
}

AFXINLINE BOOL CUpDown::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, int iUpDownId, HWND hBuddyWnd, int iMin, int iMax, int iPos)
{
	m_hWnd = ::CreateUpDownControl(dwStyle, x, y, iWidth, iHeight,
		hParentWnd, iUpDownId, NULL, hBuddyWnd, iMin, iMax, iPos);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE BOOL CUpDown::CreateWindow(DWORD dwStyle, int x, int y, int iWidth, int iHeight,
	HWND hParentWnd, UINT nUpDownId)
{
	m_hWnd = ::CreateWindowEx(UNUSED, WC_UPDOWN, NULL, dwStyle, x, y, iWidth, iHeight,
		hParentWnd, (HMENU)nUpDownId, NULL, NULL);
	return (BOOL)VERIFY(m_hWnd);
}

AFXINLINE int CUpDown::GetAccel(PUDACCEL paUDA /* = NULL */, int ceUDA /* = 0 */) const
{
	return ::SendMessage(m_hWnd, UDM_GETACCEL, ceUDA, (LPARAM)paUDA);
}

AFXINLINE UINT CUpDown::GetBase() const
{
	return ::SendMessage(m_hWnd, UDM_GETBASE, UNUSED, UNUSED);
}

AFXINLINE HWND CUpDown::GetBuddy() const
{
	return (HWND)::SendMessage(m_hWnd, UDM_GETBUDDY, UNUSED, UNUSED);
}

AFXINLINE int CUpDown::GetPos(PBOOL pbError /* = NULL */) const
{
#ifdef DEBUG
	BOOL bError;
	int  iPos = ::SendMessage(m_hWnd, UDM_GETPOS32, UNUSED, (LPARAM)&bError);
	ASSERT(!bError);
	if(pbError)
		*pbError = bError;
	return iPos;
#else
	return ::SendMessage(m_hWnd, UDM_GETPOS32, UNUSED, (LPARAM)pbError);
#endif
}

AFXINLINE void CUpDown::GetRange(PINT piMin /* = NULL */, PINT piMax /* = NULL */) const
{
	::SendMessage(m_hWnd, UDM_GETRANGE32, (WPARAM)piMax, (LPARAM)piMin);
}

AFXINLINE BOOL CUpDown::GetUnicodeFormat() const
{
	return ::SendMessage(m_hWnd, UDM_GETUNICODEFORMAT, UNUSED, UNUSED);
}

AFXINLINE BOOL CUpDown::SetAccel(PCUDACCEL paUDA, int ceUDA) const
{
	return VERIFY(::SendMessage(m_hWnd, UDM_SETACCEL, ceUDA, (LPARAM)paUDA));
}

AFXINLINE UINT CUpDown::SetBase(UINT nBase) const
{
	return VERIFY(::SendMessage(m_hWnd, UDM_SETBASE, nBase, UNUSED));
}

AFXINLINE HWND CUpDown::SetBuddy(HWND hBuddyWnd /* = NULL */) const
{
	return (HWND)::SendMessage(m_hWnd, UDM_SETBUDDY, (WPARAM)hBuddyWnd, UNUSED);
}

AFXINLINE int CUpDown::SetPos(int iPos) const
{
	return ::SendMessage(m_hWnd, UDM_SETPOS32, UNUSED, iPos);
}

AFXINLINE void CUpDown::SetRange(int iMin, int iMax) const
{
	::SendMessage(m_hWnd, UDM_SETRANGE32, iMax, iMin);
}

AFXINLINE BOOL CUpDown::SetUnicodeFormat(BOOL bUnicode /* = TRUE */) const
{
	return ::SendMessage(m_hWnd, UDM_SETUNICODEFORMAT, bUnicode, UNUSED);
}

// End of _COMMCTRL_INCLUDED_
#endif
